#include "syntx.h"

#define        NumofAdjDgns    19
#define        NumofAdjAction  11


extern struct Syntx_Term *sentence; 
extern int                sentence_len;
extern struct SPOC_Pos   sentence_spoc;
extern boolean           intrnl_dsply;




DIAGNOSIS_ARRAY adj_dgns[NumofAdjDgns + 1] = {
                                               "cmb_lft",
                                               "next(find_mdf)",
                                               "next(P_A_V)",
                                               "next(P_A_N)",
                                               "next(S_N_A_V)",
                                               "next(O_N_A_V)",
                                               "next(M_N_A_V)",
                                               "next(P_N_A_V)",
                                               "next(S_N_A_N)",
                                               "next(O_N_A_N)",
                                               "next(M_N_A_N)",
                                               "next(P_N_A_N)",
                                               "is_phrs(adj)",
                                               "is_phrs(adj_er)",
                                               "is_phrs(adj_est)",
                                               "is_phrs(vt_ing)",
                                               "is_phrs(vi_ing)",
                                               "is_phrs(vt_pprt)",
                                               "is_phrs(vi_pprt)",
                                               ""
                                             };


static int        symptoms_idx;
SYMPTOM_ARRAY     symptoms[mmax(3*MAXPTRNS+2,MAXSYMP)];
  
void    adj_phrase();
int     do_adjP();
boolean adjP_lftptrn();
boolean adjP_cntptrn();
boolean adjP_rhtptrn();



/*----------------------------------------------------------------------

  adj_phrase  --  control the action of do_adjP

    input  -- pos:  the position where the action to be taken
              lklhd: the likelyhood at which the action will take
              who: indicate who invoke the function
    output -- none
 
-----------------------------------------------------------------------*/
void adj_phrase(pos, lklhd, who)
int pos, lklhd, who;
{
  int adjP_code, phrs_pos, old_phrs_pos, i, slen_bak;
  boolean next[NumofAdjAction];
  struct Syntx_Term *stc_bak;
  struct SPOC_Pos spoc_bak;


  if (intrnl_dsply) {
    begin_title("adj_phrase", pos, lklhd);
  }

  load_prb("AdjPhrase");

  stc_bak = (struct Syntx_Term *)stc_cpy(&slen_bak, &spoc_bak, 
                                    sentence, sentence_len,&sentence_spoc);

  if ((adjP_code = do_adjP(pos, lklhd, who, &phrs_pos, next)) == 0) {
    if (intrnl_dsply) {
      printf("no adjective phrases can be formed\n");
    }
    goto end_adj_phrase;
  }

  switch (adjP_code) {
    case 1:                     /* do adv_phrase at the current position */
    case 3:                                             /* adj_er phrase */
    case 4:                                            /* adj_est phrase */
    case 5:                                             /* vt_ing phrase */
    case 6:                                             /* vi_ing phrase */
    case 7:                                            /* vt_pprt phrase */
    case 8:                                            /* vi_pprt phrase */
            
            break;

    case 2:                                                /* adj phrase */
            old_phrs_pos = phrs_pos;
            break;

    default: stx_err("unexpected code by do_adjP", __LINE__, __FILE__);
  }

save_next:

  if (next[0])                                         /* next(find_mdf) */
    stc_push(sentence, sentence_len, &sentence_spoc, FindModifier,
             phrs_pos+1, lklhd, AdjPhrase);

  if (next[1])                                            /* next(P_A_V) */
    stc_push(stc_bak, slen_bak, &spoc_bak, AdvPhrase, pos, lklhd, PrepAdj);

  if (next[2])                                            /* next(P_A_N) */
    stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase,
             phrs_pos+1, lklhd, PrepAdj);

  if (next[3])                                          /* next(S_N_A_V) */
    stc_push(stc_bak, slen_bak, &spoc_bak, AdvPhrase,pos,lklhd,SubNounAdj);

  if (next[4])                                          /* next(O_N_A_V) */
    stc_push(stc_bak, slen_bak, &spoc_bak, AdvPhrase,pos,lklhd,ObjNounAdj);

  if (next[9])                                          /* next(M_N_A_V) */
    stc_push(stc_bak, slen_bak, &spoc_bak, AdvPhrase,pos,lklhd,MdfNounAdj);

  if (next[5])                                          /* next(P_N_A_V) */
    stc_push(stc_bak, slen_bak, &spoc_bak,AdvPhrase,pos,lklhd,PrepNounAdj);

  if (next[6])                                          /* next(S_N_A_N) */
    stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase, 
             phrs_pos+1, lklhd, SubNounAdj);

  if (next[7])                                          /* next(O_N_A_N) */
    stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase, 
             phrs_pos+1, lklhd, ObjNounAdj);

  if (next[10])                                         /* next(M_N_A_N) */
    stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase, 
             phrs_pos+1, lklhd, MdfNounAdj);

  if (next[8])                                          /* next(P_N_A_N) */
    stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase, 
             phrs_pos+1, lklhd, PrepNounAdj);

  if (adjP_code == 2) {                                    /* adj phrase */

    adjP_code = do_adjP(old_phrs_pos+1, lklhd, who, &phrs_pos, next);
    if (adjP_code != 0) {
      old_phrs_pos = phrs_pos;
      goto save_next;
    }
  }

end_adj_phrase:
  stc_dsp(stc_bak);
  if (intrnl_dsply) {
    end_title("adj_phrase");
  }
}


/*---------------------------------------------------------------------

  do_adjP  --  execute adj_phrase.prg  

    input  -- pos: the position where the do_adjP works on
              lklhd: the likelihood the do_adjP works at
              who:   who issued adv_phrase
    output -- phrs_pos: the position of the formed phrase
              next:     suggested next action
                next[0] = TRUE --> find_mdf
                next[1] = TRUE --> P_A_V
                next[2] = TRUE --> P_A_N
                next[3] = TRUE --> S_N_A_V
                next[4] = TRUE --> O_N_A_V
                next[5] = TRUE --> P_N_A_V
                next[6] = TRUE --> S_N_A_N
                next[7] = TRUE --> O_N_A_N
                next[8] = TRUE --> P_N_A_N
                next[9] = TRUE --> M_N_A_V
                next[10] = TRUE --> M_N_A_N


  function returns  0: no adjective phrase can be formed
                    1: do adv_phrase at the current position
                    2: adj phrase is formed
                    3: adj_er phrase is formed 
                    4: adj_est phrase is formed
                    5: vt_ing phrase is formed
                    6: vi_ing phrase is formed
                    7: vt_pprt phrase is formed
                    8: vi_pprt phrase is formed

----------------------------------------------------------------------*/
int do_adjP(pos, lklhd, who, phrs_pos, next)
int pos, lklhd, who, *phrs_pos;
boolean next[NumofAdjAction];
{
  DIAGNOSIS_ARRAY   dgns[NumofAdjDgns + 1];
  char              dgns_var[VAR_MAX + 1],  ptrn[PTRN_PHRS_MAX+1],
                    ptrn_names[MAXPTRNS+1][PTRN_PHRS_MAX+1];
  int               i, lft, cnt, rht, lh, lklhds[MAXPTRNS], return_val;
  boolean           find_mdf = FALSE, P_A_V = FALSE, P_A_N = FALSE,
                    S_N_A_V = FALSE, O_N_A_V = FALSE, P_N_A_V = FALSE, 
                    S_N_A_N = FALSE, O_N_A_N = FALSE, P_N_A_N = FALSE,
                    M_N_A_V = FALSE, M_N_A_N = FALSE;

  symptoms_idx = 0;
  cnt = pos;
  lft = pos - 1;
  rht = pos + 1;
 
  switch(who) {
    case FindModifier: 
                       strcpy(symptoms[symptoms_idx++], "who(find_mdf)");
                       break;

    case PrepPhrase:   
                       strcpy(symptoms[symptoms_idx++], "who(prep_prs)");
                       break;

    case PrepAdjAdv:
                       strcpy(symptoms[symptoms_idx++], "who(P_A_V)");
                       break;
  
    case SubNoun:      
                       strcpy(symptoms[symptoms_idx++], "who(S_N)");
                       break;
  
    case ObjNoun:
                       strcpy(symptoms[symptoms_idx++], "who(O_N)");
                       break;

    case MdfNoun:
                       strcpy(symptoms[symptoms_idx++], "who(M_N)");
                       break;

    case PrepNoun:     
                       strcpy(symptoms[symptoms_idx++], "who(P_N)");
                       break;

    case SubNounAdjAdv:
                       strcpy(symptoms[symptoms_idx++], "who(S_N_A_V)");
                       break;

    case ObjNounAdjAdv:
                       strcpy(symptoms[symptoms_idx++], "who(O_N_A_V)");
                       break;

    case MdfNounAdjAdv:
                       strcpy(symptoms[symptoms_idx++], "who(M_N_A_V)");
                       break;

    case PrepNounAdjAdv:
                       strcpy(symptoms[symptoms_idx++], "who(P_N_A_V)");
                       break;

    default: stx_err("unexpected problem code", __LINE__, __FILE__);
  }

  if (has_phrase(sentence, sentence_len, lft, "adj", &lh))
    strcpy(symptoms[symptoms_idx++], "lft_phrs(adj)");
  if (has_phrase(sentence, sentence_len, lft, "adv", &lh))
    strcpy(symptoms[symptoms_idx++], "lft_phrs(adv)");
  get_ptrn_names(sentence, sentence_len, lft, ptrn_names, lklhds);
  i = 0;
  strcpy(ptrn, ptrn_names[i++]);
  while (!EQUAL(ptrn,"")) {
    if (adjP_lftptrn(ptrn)) {
      sprintf(symptoms[symptoms_idx++], "lft_ptrn(%s)", ptrn);
    }
    strcpy(ptrn, ptrn_names[i++]);
  }

  get_ptrn_names(sentence, sentence_len, cnt, ptrn_names, lklhds);
  i = 0;
  strcpy(ptrn, ptrn_names[i++]);
  while (!EQUAL(ptrn,"")) {
    if (adjP_cntptrn(ptrn)) {
      sprintf(symptoms[symptoms_idx++], "cnt_ptrn(%s)", ptrn);
    }
    strcpy(ptrn, ptrn_names[i++]);
  }
/*
  if (has_phrase(sentence, sentence_len, rht, "adj", &lh)) {
    strcpy(symptoms[symptoms_idx++], "rht_phrs(adj)");
    if (left_stop_adj(sentence, sentence_len, rht)) 
      strcpy(symptoms[symptoms_idx++], "rht_adj_lftstop");
  }
*/
  get_ptrn_names(sentence, sentence_len, rht, ptrn_names, lklhds);
  i = 0;
  strcpy(ptrn, ptrn_names[i++]);
  while (!EQUAL(ptrn,"")) {
    if (adjP_rhtptrn(ptrn)) {
      sprintf(symptoms[symptoms_idx++], "rht_ptrn(%s)", ptrn);
    }
    strcpy(ptrn, ptrn_names[i++]);
  }
  strcpy(symptoms[symptoms_idx],"");
  if (symptoms_idx == 0) return 0;

  mst_smp(symptoms, name, state, type, value, errcde);
  sol_prb(name, state, type, value, errcde);
  if (errcde[0] != 0) {
    stx_err("failed to solve problem", __LINE__, __FILE__);
  }

  if EQUAL(state, "S") { 
    copy_dgns(dgns, adj_dgns);
    get_dgn(dgns,name,state,type,value,errcde);
    if (value[0]) {                      /* has at least one true value */
      boolean cmb_lft = FALSE;
      char    phrase_name[PTRN_PHRS_MAX+1] = "";
      char    clss[MAXPHRASE][PTRN_PHRS_MAX+1]; 

      i = 0;
      phrase_name[0] = '\0';
      while (! EQUAL(dgns[i],"")) {
        strcpy(dgns_var, dgns[i++]);
  
        if (EQUAL(dgns_var,"cmb_lft")) { cmb_lft = TRUE; continue; }
/*        if (EQUAL(dgns_var,"cmb_rht")) { cmb_rht = TRUE; continue; }*/

        if (EQUAL(dgns_var,"next(find_mdf)")) { 
          find_mdf = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(P_A_V)")) { 
          P_A_V = TRUE; 
          *phrs_pos = cnt;
          return_val = 1;
          goto end_of_doadjP; 
        }
        if (EQUAL(dgns_var,"next(P_A_N)")) { 
          P_A_N = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(S_N_A_V)")) { 
          S_N_A_V = TRUE;
          *phrs_pos = cnt;
          return_val = 1;
          goto end_of_doadjP; 
        }
        if (EQUAL(dgns_var,"next(O_N_A_V)")) { 
          O_N_A_V = TRUE;
          *phrs_pos = cnt;
          return_val = 1;
          goto end_of_doadjP; 
        }
        if (EQUAL(dgns_var,"next(M_N_A_V)")) { 
          M_N_A_V = TRUE;
          *phrs_pos = cnt;
          return_val = 1;
          goto end_of_doadjP; 
        }
        if (EQUAL(dgns_var,"next(P_N_A_V)")) { 
          P_N_A_V = TRUE;
          *phrs_pos = cnt;
          return_val = 1;
          goto end_of_doadjP; 
        }
        if (EQUAL(dgns_var,"next(S_N_A_N)")) { 
          S_N_A_N = TRUE;
          continue; 
        }
        if (EQUAL(dgns_var,"next(O_N_A_N)")) { 
          O_N_A_N = TRUE;
          continue; 
        }
        if (EQUAL(dgns_var,"next(M_N_A_N)")) { 
          M_N_A_N = TRUE;
          continue; 
        }
        if (EQUAL(dgns_var,"next(P_N_A_N)")) { 
          P_N_A_N = TRUE;
          continue; 
        }

        if (EQUAL(dgns_var,"is_phrs(adj)")) { 
          strcpy(phrase_name, "adj");
          return_val = 2;
          continue;
        }
        if (EQUAL(dgns_var,"is_phrs(adj_er)")) { 
          strcpy(phrase_name, "adj_er");
          return_val = 3;
          continue;
        }
        if (EQUAL(dgns_var,"is_phrs(adj_est)")) { 
          strcpy(phrase_name, "adj_est");
          return_val = 4;
          continue;
        }
        if (EQUAL(dgns_var,"is_phrs(vt_ing)")) { 
          strcpy(phrase_name, "vt_ing");
          return_val = 5;
          continue;
        }
        if (EQUAL(dgns_var,"is_phrs(vi_ing)")) { 
          strcpy(phrase_name, "vi_ing");
          return_val = 6;
          continue;
        }
        if (EQUAL(dgns_var,"is_phrs(vt_pprt)")) { 
          strcpy(phrase_name, "vt_pprt");
          return_val = 7;
          continue;
        }
        if (EQUAL(dgns_var,"is_phrs(vi_pprt)")) { 
          strcpy(phrase_name, "vi_pprt");
          return_val = 8;
          continue;
        }
      }
      if (EQUAL(phrase_name,"")) { return_val = 0; goto end_of_doadjP; }
  
      if (cmb_lft) { 
        if (intrnl_dsply) {
          printf("%d + %d  ==>  phrase '%s'\n\n", lft, cnt, phrase_name);
        }    
        if (EQUAL(phrase_name,"adj_est")) { strcpy(clss[0], "artcl_df"); }
        else {
          if (has_pattern(sentence, sentence_len, lft, "adj", &lh)) {
            strcpy(clss[0], "adj");
          }
          else {  strcpy(clss[0], "adv"); }
        }
        strcpy(clss[1], phrase_name);
        cmb_token(sentence, &sentence_len, &sentence_spoc, lft, cnt, clss, 
                  phrase_name, lklhd);
        *phrs_pos = lft;
        goto end_of_doadjP;
      }
      else {
        if (intrnl_dsply) {
          printf("%d ==>  phrase '%s'\n\n", cnt, phrase_name);
        }    
        strcpy(clss[0], phrase_name);
        cmb_token(sentence, &sentence_len, &sentence_spoc, cnt, cnt, clss, 
                  phrase_name, lklhd);
        *phrs_pos = cnt;
        goto end_of_doadjP;
      }
    }
  }
  else stx_err("problem is unsatisfied", __LINE__, __FILE__);
  
  return_val = 0;
  
end_of_doadjP:

  if (return_val != 0) {
    next[0] = find_mdf;
    next[1] = P_A_V;
    next[2] = P_A_N;
    next[3] = S_N_A_V;
    next[4] = O_N_A_V;
    next[5] = P_N_A_V;
    next[6] = S_N_A_N;
    next[7] = O_N_A_N;
    next[8] = P_N_A_N;
    next[9] = M_N_A_V;
    next[10] = M_N_A_N;
  }

  strcpy(state, "A");
  rst_prb(name, state, type, value, errcde);
  return return_val;
}

/*---------------------------------------------------------------------

  adjP_lftptrn  --  check if left pattern is considered in the log file

    input  -- ptrn: left pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean adjP_lftptrn(ptrn)
char *ptrn;
{
  if (EQUAL(ptrn,"artcl_df") OR
      EQUAL(ptrn,"adj")      OR
      EQUAL(ptrn,"adv"))        return TRUE;
  return FALSE;
}



/*---------------------------------------------------------------------

  adjP_cntptrn  --  check if current pattern is considered in the log file

    input  -- ptrn: current pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean adjP_cntptrn(ptrn)
char *ptrn;
{
  char str[4];

  str[0] = ptrn[0];
  str[1] = ptrn[1];
  str[2] = ptrn[2];
  str[3] = '\0';

  if (EQUAL(str,"adj")) return TRUE;

  if (EQUAL(ptrn,"vt_ing")  OR
      EQUAL(ptrn,"vi_ing")  OR
      EQUAL(ptrn,"vt_pprt") OR
      EQUAL(ptrn,"vi_pprt") OR
      EQUAL(ptrn,"adv"))       return TRUE;

  return FALSE;
}


/*---------------------------------------------------------------------

  adjP_rhtptrn  --  check if right pattern is considered in the log file

    input  -- ptrn: right pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean adjP_rhtptrn(ptrn)
char *ptrn;
{
  if (EQUAL(ptrn,"vt_ing")  OR
      EQUAL(ptrn,"vi_ing")  OR
      EQUAL(ptrn,"vt_pprt") OR
      EQUAL(ptrn,"vi_pprt") OR
      EQUAL(ptrn,"adj_er")  OR
      EQUAL(ptrn,"adj"))        return TRUE;
  return FALSE;
}

