#include "syntx.h"

#define        NumofAdvDgns    22
#define        NumofAdvAction  18


extern struct Syntx_Term *sentence; 
extern int                sentence_len;
extern struct SPOC_Pos    sentence_spoc;
extern boolean            intrnl_dsply;



DIAGNOSIS_ARRAY adv_dgns[NumofAdvDgns + 1] = {
                                               "cmb_lft",
                                               "next(find_mdf)",
                                               "next(be_phrs)",
                                               "next(pv_phrs)",
                                               "next(hv_phrs)",
                                               "next(do_phrs)",
                                               "next(aux_phrs)",
                                               "next(pbeadvbe)",
                                               "next(hbeadvbe)",
                                               "next(P_A_V_A)",
                                               "next(SNAVA)",
                                               "next(ONAVA)",
                                               "next(MNAVA)",
                                               "next(PNAVA)",
                                               "next(X_H_V_H)",
                                               "next(XHBVB)",
                                               "next(X_B_V_B)",
                                               "next(PV_H_V_H)",
                                               "next(PVHBVB)",
                                               "is_phrs(adv)",
                                               "is_phrs(adv_er)",
                                               "is_phrs(adv_est)",
                                               ""
                                             };


static int        symptoms_idx;
SYMPTOM_ARRAY     symptoms[mmax(2*MAXPTRNS+1,MAXSYMP)];
  
void    adv_phrase();
int     do_advP();
boolean advP_lftptrn();
boolean advP_cntptrn();



/*----------------------------------------------------------------------

  adv_phrase  --  control the action of do_advP

    input  -- pos:  the position where the action to be taken
              lklhd: the likelyhood at which the action will take
              who: indicate who invoke the function
    output -- none
 
-----------------------------------------------------------------------*/
void adv_phrase(pos, lklhd, who)
int pos, lklhd, who;
{
  int advP_code, phrs_pos, old_phrs_pos, i;
  boolean next[NumofAdvAction];


  if (intrnl_dsply) {
    begin_title("adv_phrase", pos, lklhd);
  }

  load_prb("AdvPhrase");

  if ((advP_code = do_advP(pos, lklhd, who, &phrs_pos, next)) == 0) {
    if (intrnl_dsply) {
      printf("no adverb phrases can be formed\n");
    }
    goto end_adv_phrase;
  }

  switch (advP_code) {
    case 2:                                             /* adv_er phrase */
    case 3:                                            /* adv_est phrase */
            break;

    case 1:                                                /* adv phrase */
            old_phrs_pos = phrs_pos;
            break;

    default: stx_err("unexpected code by do_advP", __LINE__, __FILE__);
  }

save_next:


  if (next[0])                                         /* next(find_mdf) */
    stc_push(sentence, sentence_len, &sentence_spoc, FindModifier,
             phrs_pos+1, lklhd, AdvPhrase);
  if (next[1])                                          /* next(P_A_V_A) */
    stc_push(sentence, sentence_len, &sentence_spoc, AdjPhrase,
             phrs_pos+1, lklhd, PrepAdjAdv);
  if (next[2])                                            /* next(SNAVA) */
    stc_push(sentence, sentence_len, &sentence_spoc, AdjPhrase,
             phrs_pos+1, lklhd, SubNounAdjAdv);
  if (next[3])                                            /* next(ONAVA) */
    stc_push(sentence, sentence_len, &sentence_spoc, AdjPhrase,
             phrs_pos+1, lklhd, ObjNounAdjAdv);
  if (next[6])                                            /* next(MNAVA) */
    stc_push(sentence, sentence_len, &sentence_spoc, AdjPhrase,
             phrs_pos+1, lklhd, MdfNounAdjAdv);
  if (next[4])                                            /* next(PNAVA) */
    stc_push(sentence, sentence_len, &sentence_spoc, AdjPhrase,
             phrs_pos+1, lklhd, PrepNounAdjAdv);
  if (next[5])                                          /* next(be_phrs) */
    stc_push(sentence, sentence_len, &sentence_spoc, BePhrase,
             phrs_pos-1, lklhd, AdvPhrase);
  if (next[7])                                          /* next(pv_phrs) */
    stc_push(sentence, sentence_len, &sentence_spoc, PronvbPhrase,
             phrs_pos-1, lklhd, AdvPhrase);
  if (next[8])                                         /* next(pbeadvbe) */
    stc_push(sentence, sentence_len, &sentence_spoc, BePhrase,
             phrs_pos-1, lklhd, PronvbBeAdv);
  if (next[9])                                          /* next(hv_phrs) */
    stc_push(sentence, sentence_len, &sentence_spoc, HavePhrase,
             phrs_pos-1, lklhd, AdvPhrase);
  if (next[10])                                        /* next(hbeadvbe) */
    stc_push(sentence, sentence_len, &sentence_spoc, BePhrase,
             phrs_pos-1, lklhd, HaveBeAdv);
  if (next[11])                                         /* next(do_phrs) */
    stc_push(sentence, sentence_len, &sentence_spoc, DoPhrase,
             phrs_pos-1, lklhd, AdvPhrase);
  if (next[12])                                        /* next(aux_phrs) */
    stc_push(sentence, sentence_len, &sentence_spoc, AuxPhrase,
             phrs_pos-1, lklhd, AdvPhrase);
  if (next[13])                                         /* next(X_H_V_H) */
    stc_push(sentence, sentence_len, &sentence_spoc, HavePhrase,
             phrs_pos-1, lklhd, AuxHaveAdv);
  if (next[14])                                         /* next(XHBVB) */
    stc_push(sentence, sentence_len, &sentence_spoc, BePhrase,
             phrs_pos-1, lklhd, AuxHaveBeAdv);
  if (next[15])                                         /* next(X_B_V_B) */
    stc_push(sentence, sentence_len, &sentence_spoc, BePhrase,
             phrs_pos-1, lklhd, AuxBeAdv);
  if (next[16])                                        /* next(PV_H_V_H) */
    stc_push(sentence, sentence_len, &sentence_spoc, HavePhrase,
             phrs_pos-1, lklhd, PvHaveAdv);
  if (next[17])                                          /* next(PVHBVB) */
    stc_push(sentence, sentence_len, &sentence_spoc, BePhrase,
             phrs_pos-1, lklhd, PvHaveBeAdv);


  

  if (advP_code == 1) {                                    /* adv phrase */

    advP_code = do_advP(old_phrs_pos+1, lklhd, who, &phrs_pos, next);
    if (advP_code != 0) {
      old_phrs_pos = phrs_pos;
      goto save_next;
    }
  }


end_adv_phrase:  ;
  if (intrnl_dsply) {
    end_title("adv_phrase");
  }
}


/*---------------------------------------------------------------------

  do_advP  --  execute do_advP.prg  

    input  -- pos: the position where the do_advP works on
              lklhd: the likelihood the do_advP works at
              who:   who issued adv_phrase
    output -- phrs_pos: the position of the formed phrase
              next:     suggested next action
                next[0]  = TRUE --> find_mdf
                next[1]  = TRUE --> P_A_V_A
                next[2]  = TRUE --> SNAVA
                next[3]  = TRUE --> ONAVA
                next[4]  = TRUE --> PNAVA
                next[5]  = TRUE --> be_phrs
                next[6]  = TRUE --> MNAVA
                next[7]  = TRUE --> pv_phrs
                next[8]  = TRUE --> pbeadvbe
                next[9]  = TRUE --> hv_phrs
                next[10] = TRUE --> hbeadvbe
                next[11] = TRUE --> do_phrs
                next[12] = TRUE --> aux_phrs
                next[13] = TRUE --> X_H_V_H
                next[14] = TRUE --> XHBVB
                next[15] = TRUE --> X_B_V_B
                next[16] = TRUE --> PV_H_V_H
                next[17] = TRUE --> PVHBVB


  function returns  0: no adverb phrase can be formed
                    1: adv phrase is formed
                    2: adv_er phrase is formed 
                    3: adv_est phrase is formed

----------------------------------------------------------------------*/
int do_advP(pos, lklhd, who, phrs_pos, next)
int pos, lklhd, who, *phrs_pos;
boolean next[NumofAdvAction];
{
  DIAGNOSIS_ARRAY   dgns[NumofAdvDgns + 1];
  char              dgns_var[VAR_MAX + 1],  ptrn[PTRN_PHRS_MAX+1],
                    ptrn_names[MAXPTRNS+1][PTRN_PHRS_MAX+1], msg[100];
  int               i, lft, cnt, lh, lklhds[MAXPTRNS], return_val;
  boolean           find_mdf = FALSE, P_A_V_A = FALSE, be_phrs = FALSE,
                    SNAVA = FALSE, ONAVA = FALSE, PNAVA = FALSE,
                    MNAVA = FALSE, pv_phrs = FALSE, pbeadvbe = FALSE,
                    hv_phrs = FALSE, hbeadvbe = FALSE, do_phrs = FALSE, 
                    aux_phrs = FALSE, X_H_V_H = FALSE, XHBVB = FALSE,
                    X_B_V_B = FALSE, PV_H_V_H = FALSE, PVHBVB = FALSE;

  symptoms_idx = 0;
  cnt = pos;
  lft = pos - 1;
 
  switch(who) {
    case FindModifier: 
                        strcpy(symptoms[symptoms_idx++], "who(find_mdf)");
                        break;
  
    case PrepAdj: 
                        strcpy(symptoms[symptoms_idx++], "who(P_A)");
                        break;
  
    case SubNounAdj: 
                        strcpy(symptoms[symptoms_idx++], "who(S_N_A)");
                        break;

    case ObjNounAdj: 
                        strcpy(symptoms[symptoms_idx++], "who(O_N_A)");
                        break;

    case MdfNounAdj: 
                        strcpy(symptoms[symptoms_idx++], "who(M_N_A)");
                        break;

    case PrepNounAdj: 
                        strcpy(symptoms[symptoms_idx++], "who(P_N_A)");
                        break;

    case BePhrase:
                        strcpy(symptoms[symptoms_idx++], "who(be_phrs)");
                        break;

    case PronvbPhrase:
                        strcpy(symptoms[symptoms_idx++], "who(pv_phrs)");
                        break;

    case PronvbBe:
                        strcpy(symptoms[symptoms_idx++], "who(pv_be)");
                        break;

    case HaveBe:
                        strcpy(symptoms[symptoms_idx++], "who(hv_be)");
                        break;

    case HavePhrase:
                        strcpy(symptoms[symptoms_idx++], "who(hv_phrs)");
                        break;

    case DoPhrase:
                        strcpy(symptoms[symptoms_idx++], "who(do_phrs)");
                        break;

    case AuxPhrase:   
                        strcpy(symptoms[symptoms_idx++], "who(aux_phrs)");
                        break;

    case AuxHave:   
                        strcpy(symptoms[symptoms_idx++], "who(aux_hv)");
                        break;

    case AuxHaveBe:   
                        strcpy(symptoms[symptoms_idx++], "who(X_H_B)");
                        break;

    case AuxBe:   
                        strcpy(symptoms[symptoms_idx++], "who(aux_be)");
                        break;

    case PvHave:   
                        strcpy(symptoms[symptoms_idx++], "who(pv_hv)");
                        break;

    case PvHaveBe:   
                        strcpy(symptoms[symptoms_idx++], "who(PV_H_B)");
                        break;

    default: sprintf(msg, "unexpected problem code: %d", who);
             stx_err(msg, __LINE__, __FILE__);
  }

  if (has_phrase(sentence, sentence_len, lft, "adv", &lh))
    strcpy(symptoms[symptoms_idx++], "lft_phrs(adv)");
  get_ptrn_names(sentence, sentence_len, lft, ptrn_names, lklhds);
  i = 0;
  strcpy(ptrn, ptrn_names[i++]);
  while (!EQUAL(ptrn,"")) {
    if (advP_lftptrn(ptrn)) {
      sprintf(symptoms[symptoms_idx++], "lft_ptrn(%s)", ptrn);
    }
    strcpy(ptrn, ptrn_names[i++]);
  }

  get_ptrn_names(sentence, sentence_len, cnt, ptrn_names, lklhds);
  i = 0;
  strcpy(ptrn, ptrn_names[i++]);
  while (!EQUAL(ptrn,"")) {
    if (advP_cntptrn(ptrn)) {
      sprintf(symptoms[symptoms_idx++], "cnt_ptrn(%s)", ptrn);
    }
    strcpy(ptrn, ptrn_names[i++]);
  }
  strcpy(symptoms[symptoms_idx],"");
  if (symptoms_idx == 0) return 0;

  mst_smp(symptoms, name, state, type, value, errcde);
  sol_prb(name, state, type, value, errcde);
  if (errcde[0] != 0) {
    stx_err("failed to solve problem", __LINE__, __FILE__);
  }

  if EQUAL(state, "S") { 
    copy_dgns(dgns, adv_dgns);
    get_dgn(dgns,name,state,type,value,errcde);
    if (value[0]) {                      /* has at least one true value */
      boolean cmb_lft = FALSE;
      char    phrase_name[PTRN_PHRS_MAX+1] = "";
      char    clss[MAXPHRASE][PTRN_PHRS_MAX+1]; 

      i = 0;
      while (! EQUAL(dgns[i],"")) {
        strcpy(dgns_var, dgns[i++]);
        if (EQUAL(dgns_var,"cmb_lft")) { cmb_lft = TRUE; continue; }

        if (EQUAL(dgns_var,"next(find_mdf)")) { 
          find_mdf = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(be_phrs)")) { 
          be_phrs = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(pv_phrs)")) { 
          pv_phrs = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(hv_phrs)")) { 
          hv_phrs = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(do_phrs)")) { 
          do_phrs = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(aux_phrs)")) { 
          aux_phrs = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(pbeadvbe)")) { 
          pbeadvbe = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(hbeadvbe)")) { 
          hbeadvbe = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(P_A_V_A)")) { 
          P_A_V_A = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(SNAVA)")) { 
          SNAVA = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(ONAVA)")) { 
          ONAVA = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(MNAVA)")) { 
          MNAVA = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(PNAVA)")) { 
          PNAVA = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(X_H_V_H)")) { 
          X_H_V_H = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(XHBVB)")) { 
          XHBVB = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(X_B_V_B)")) { 
          X_B_V_B = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(PV_H_V_H)")) { 
          PV_H_V_H = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(PVHBVB)")) { 
          PVHBVB = TRUE; 
          continue; 
        }


        if (EQUAL(dgns_var,"is_phrs(adv)")) { 
          strcpy(phrase_name, "adv");
          return_val = 1;
          continue;
        }
        if (EQUAL(dgns_var,"is_phrs(adv_er)")) { 
          strcpy(phrase_name, "adv_er");
          return_val = 2;
          continue;
        }
        if (EQUAL(dgns_var,"is_phrs(adv_est)")) { 
          strcpy(phrase_name, "adv_est");
          return_val = 3;
          continue;
        }
      }
      if (EQUAL(phrase_name,"")) { return_val = 0; goto end_of_doadvP; }
  
      if (cmb_lft) { 
        if (intrnl_dsply) {
          printf("%d + %d  ==>  phrase '%s'\n\n", lft, cnt, phrase_name);
        }    
        if (EQUAL(phrase_name,"adv_est")) { strcpy(clss[0], "artcl_df"); }
        else { strcpy(clss[0], "adv"); }
        strcpy(clss[1], phrase_name);
        cmb_token(sentence, &sentence_len, &sentence_spoc, lft, cnt, clss, 
                  phrase_name, lklhd);
        *phrs_pos = lft;
      }
      else {
        if (intrnl_dsply) {
          printf("%d ==>  phrase '%s'\n\n", cnt, phrase_name);
        }     
        strcpy(clss[0], phrase_name);
        cmb_token(sentence, &sentence_len, &sentence_spoc, cnt, cnt, clss, 
                  phrase_name, lklhd);
        *phrs_pos = cnt;
      }
      goto end_of_doadvP;
    }
  }
  else stx_err("problem is unsatisfied", __LINE__, __FILE__);
  
  return_val = 0;
  
end_of_doadvP:

  if (return_val != 0) {
    next[0] = find_mdf;
    next[1] = P_A_V_A;
    next[2] = SNAVA;
    next[3] = ONAVA;
    next[4] = PNAVA;
    next[5] = be_phrs;
    next[6] = MNAVA;
    next[7] = pv_phrs;
    next[8] = pbeadvbe;
    next[9] = hv_phrs;
    next[10] = hbeadvbe;
    next[11] = do_phrs;
    next[12] = aux_phrs;
    next[13] = X_H_V_H;
    next[14] = XHBVB;
    next[15] = X_B_V_B;
    next[16] = PV_H_V_H;
    next[17] = PVHBVB;
  }

  strcpy(state, "A");
  rst_prb(name, state, type, value, errcde);
  return return_val;
}

/*---------------------------------------------------------------------

  advP_lftptrn  --  check if left pattern is considered in the log file

    input  -- ptrn: left pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean advP_lftptrn(ptrn)
char *ptrn;
{
  if (EQUAL(ptrn,"artcl_df")) return TRUE;
  return FALSE;
}



/*---------------------------------------------------------------------

  advP_cntptrn  --  check if current pattern is considered in the log file

    input  -- ptrn: current pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean advP_cntptrn(ptrn)
char *ptrn;
{
  char str[4];

  str[0] = ptrn[0];
  str[1] = ptrn[1];
  str[2] = ptrn[2];
  str[3] = '\0';

  if (EQUAL(str,"adv")) return TRUE;
  return FALSE;
}



