/*************************************************************************/
/*                                                                       */
/*                             create_bidx.c                             */
/*                                                                       */
/*                              (Feb, 10, 1993)                          */
/*                                                                       */
/*    This is the program to creat the file bckt.idx which contains the  */
/*    index of bucketname. That is, for the prefix of a word (it is      */
/*    actually a bucket name) there is an entry in the "bckt.idx" which  */
/*    contains the location of this bucket in the file word.index and    */
/*    other informations about the bucket.                               */  /*                                                                       */
/*************************************************************************/
#include <stdlib.h>
#include <string.h>
                                                             
#include     "create.h"
#include     "HashFnct.h"

#define      BNAME     "bcktname.dat"
#define      BIDX      "bckt.idx"


struct   BcktIdxEnt  wordbk[SIZEOFWORDBK];   
unsigned             i, freq, max;
unsigned long int    conflict;
char                 prefix[PREFIXLEN + 1];
long int             total;

FILE  *bname, *bidx;


void   Initial()

{
  int  i;

  for (i = 0; i < SIZEOFWORDBK; i++)
  {
    wordbk[i].bcktnm[0] = '\0';
    wordbk[i].bksize = 0;
    wordbk[i].fnct = ' ';
    wordbk[i].maxcnft = 0;
  };
}




void  InsrtWdbkindex()

{

  unsigned   i, val, c;
  



  while ((i = strlen(prefix)) < PREFIXLEN)
  {
    prefix[i] = ' ';
    prefix[i + 1] = '\0';
  };
   
  val = BcktHash(prefix);
  c = 0;
/*printf("hashvalue %d\n", val);*/
  while (wordbk[val].bcktnm[0] != '\0')
  {
/*printf("occupied by %s\n", wordbk[val].bcktnm);*/
    conflict ++;
    val = (val + 1) % SIZEOFWORDBK;
/*printf("val = %d\n", val);*/
    c++;
  };
  if (max < c)
  {
    max = c; 
  };

  strcpy(wordbk[val].bcktnm, prefix);
  wordbk[val].freq = freq;

}

 
  
main()

{ 
    
  Initial();

  conflict = 0;

  if ((bname = fopen(BNAME, READ)) == NULL)
  {
    fprintf(stderr, "fail to open the %s \n", BNAME);
    exit(0);
  };

  if ((bidx = fopen(BIDX, WRITE)) == NULL)
  {
    fprintf(stderr, "fail to open the %s \n", BIDX);
    exit(0);
  };


  
  ReadSucc = fscanf(bname, "%ld\n", &total);
  if (! ReadSucc)
  {
    fprintf(stderr, "fail to read from %s\n", BNAME);
    exit(0);
  };
 
printf("total %ld\n", total);

  for (i = 1; i <= total; i++)
  {
    ReadSucc = fscanf(bname, "%s %d\n", prefix, &freq);
    if (! ReadSucc)
    {
      fprintf(stderr, "fail to read from %s\n", BNAME);
      exit(0);
    };
/*printf("prefix %s \n", prefix);*/

    InsrtWdbkindex();

    
  };

  WriteSucc = fwrite(wordbk, sizeof(wordbk), 1, bidx);
  if (! WriteSucc)
  {
    fprintf(stderr, "fail to write into %s\n", BIDX);
    exit(0);
  };
  
  fclose(bname);
  fclose(bidx);
  printf("total conflicts is %d \n", conflict);
  printf("the max conflicts is %d\n", max);
}

  

    
    
  
