/**************************************************************************/
/*                                                                        */
/*                              create_wdidx.c                            */
/*                                                                        */
/*                              (April 8, 1993)                           */
/*                                                                        */
/*    This is the program to creat the file word.idx                      */
/*                                                                        */
/*    input data files: word.dat                                          */
/*                      bckt.idx                                          */
/*                                                                        */
/*    output file: word.idx                                               */
/*                                                                        */
/*    procedure:                                                          */
/*               1. scanning word.dat word by word;                       */
/*               2. based on the info in bckt.idx, fix corresponding info */
/*                  for each word (size of word, word location, etc.),    */
/*                  and store them in word.idx                            */
/*                                                                        */
/**************************************************************************/
#include <stdlib.h>
#include <string.h>
                                                             
#include     "create.h"
#include     "HashFnct.h"
 
#define    WORDDAT   "word.dat"
#define    BIDX      "bckt.idx"
#define    WORDIDX   "word.idx"
 


struct   BcktIdxEnt  Bindex[SIZEOFWORDBK];
struct   WordIdxEnt  Windex[WDIDXSIZE];
char                 prefix[PREFIXLEN + 1], Word[MAXWORDLEN + 1], pattern[10];
unsigned long int    idx;
 

FILE  *wddat, *bidx, *wdidx;




int  GetBcktIdx()

{

  unsigned   i, val;
  



  val = BcktHash(prefix);
  i = 0;
/*printf("hashvalue1 %d\n", val);*/
/*printf("prefix %s\n", wordbk[val].bcktnm);*/
  while ((strcmp(Bindex[val].bcktnm, prefix) != 0) && (i <= MAXBKCONFLICT))
  {
    if (Bindex[val].bcktnm[0] == '\0')
    {
      i = MAXBKCONFLICT;
    };

    val = (val + 1) % SIZEOFWORDBK;
    i++;
  };

  if (i > MAXBKCONFLICT)
  {
    return(-1);
  }
  else
  {
    return(val);
  };
}







unsigned  HashVal(fnct, size)

char      fnct;
unsigned  size;


{
  unsigned  val; 
 
  
  switch(fnct)
  {
    case '1':  val = WordHash1(Word, size);
               break;
    case '2':  val = WordHash2(Word, size);
               break;
    case '3':  val = WordHash3(Word, size);
               break;
    case '4':  val = WordHash4(Word, size);
               break;
    case '5':  val = WordHash5(Word, size);
               break;

  };

  return(val);

 
}

                 



main()

{ 
  int                i, bcktidx, j, maxc;
  unsigned long int  wordidx, base, total, tmp;
  char               ch, fnt;
  unsigned           freq, size, hval;
  






 
 
  idx = 0;

 

  if ((wddat = fopen(WORDDAT, READ)) == NULL)
  {
    fprintf(stderr, "fail to open the %s \n", WORDDAT);
    exit(0);
  };



  if ((bidx = fopen(BIDX, READ)) == NULL)
  {
    fprintf(stderr, "fail to open the %s \n", BIDX);
    exit(0);
  };

  ReadSucc = fread(Bindex, sizeof(Bindex), 1, bidx);
  if (! ReadSucc)
  {
    fprintf(stderr, "fail to read from %s\n", BIDX);
    exit(0);
  };



  if ((wdidx = fopen(WORDIDX, WRITE)) == NULL)
  {
    fprintf(stderr, "fail to open the %s \n", WORDIDX);
    exit(0);
  };





  total = 0;
  tmp = 0;
  while (total < NUMOFWORDS)
  {
   
    fscanf(wddat, "%s %s\n", Word, pattern);
 /* printf("word %s\n", Word);*/
    strncpy(prefix, Word, PREFIXLEN);
    while ((i = strlen(prefix)) < PREFIXLEN)
    {
      prefix[i] = ' ';
      prefix[i + 1] = '\0';
    };


    if ((bcktidx = GetBcktIdx()) == -1)
    {
      printf("there is no prefix %s in %s for word %s\n", prefix, BIDX,Word);
      printf("total %ld\n", total);
      exit(0);
    };

    freq = Bindex[bcktidx].freq;
    base = Bindex[bcktidx].bkloc;
    size = Bindex[bcktidx].bksize;
    fnt = Bindex[bcktidx].fnct;
    maxc = Bindex[bcktidx].maxcnft;
 
    hval = HashVal(fnt, size);
    wordidx = base + hval;
/*printf("idx %ld\n", wordidx);*/

    i = 0;
    while ((Windex[wordidx].length != 0) && (i <= maxc))
    {
      hval = (hval + 1) % size;
      wordidx = base + hval;
      i ++;
    };
    if (i > maxc)
    {
      printf("can't find index for word %s\n", Word);
/*printf("freq %d, base %ld, size %d, maxc %d\n", freq, base, size, maxc);*/
      exit(0);
    };
        
    Windex[wordidx].length = strlen(Word);
    Windex[wordidx].wdloc = idx;
 
    idx = idx + strlen(Word) + strlen(pattern) + 2;

    for (j = 1; j < freq; j ++)
    {
      fscanf(wddat, "%s %s\n", Word, pattern);
 /*printf("**word %s\n", Word);*/

      hval = HashVal(fnt, size);
      wordidx = base + hval;

     
/*printf("idx %ld\n", wordidx);*/
      i = 0;
      while ((Windex[wordidx].length != 0) && (i <= maxc))
      {
        hval = (hval + 1) % size;
        wordidx = base + hval;

        i ++;
      };
      if (i > (maxc + 1))
      {
        printf("can't find index for word %s\n", Word);
/*printf("freq %d, base %ld, size %d, maxc %d\n", freq, base, size, maxc);*/

        exit(0);
      };
        
      Windex[wordidx].length = strlen(Word);
      Windex[wordidx].wdloc = idx;
 
      idx = idx + strlen(Word) + strlen(pattern) + 2;

    };
  
    total = total + freq;

    if ((total - tmp) > 1000)
    {
      printf("%ld words have been processed\n", total);
      tmp = total;
    };
  };
    

  printf("%ld  words have been processed\n\n", total);

  
  WriteSucc = fwrite(Windex, sizeof(Windex), 1, wdidx);
  if (! WriteSucc)
  {
    fprintf(stderr, "fail to write into %s\n", WORDIDX);
    exit(0);
  };



  fclose(wddat);
  fclose(bidx);
  fclose(wdidx);

}
  
