#include "syntx.h"

#define        NumofDoDgns    13
#define        NumofDoNext     5

extern struct Syntx_Term *sentence; 
extern int                sentence_len;
extern struct SPOC_Pos    sentence_spoc;
extern boolean            intrnl_dsply;





DIAGNOSIS_ARRAY do_dgns[NumofDoDgns + 1] = { 
                                                  "next(find_sub)",
                                                  "next(find_obj)",
                                                  "next(adv_phrs)",
                                                  "next(vb_phrs1)",
                                                  "next(vb_phrs2)",
                                                  "cmb_rht_one",
                                                  "cmb_rht_two",
                                                  "do_ph(does_vt)",
                                                  "do_ph(does_vi)",
                                                  "do_ph(do_vt)",
                                                  "do_ph(do_vi)",
                                                  "do_ph(did_vt)",
                                                  "do_ph(did_vi)",
                                                  "" 
                                               };   

static int        symptoms_idx;
SYMPTOM_ARRAY     symptoms[mmax(3*MAXPTRNS+2,MAXSYMP)];
  
void    do_phrase();
int     do_doP();
boolean doP_cntptrn();
boolean doP_cntwd();
boolean doP_rht1ptrn();
boolean doP_rht2ptrn();
boolean doP_rht1phrs();
boolean doP_rht2phrs();
int     doP_cmb_and_next();
void    doP_other_next();



/*----------------------------------------------------------------------

  do_phrase  --  control the action of do_doP

    input  -- pos:  the position where the action to be taken
              lklhd: the likelyhood at which the action will take
              who: indicate who invoke the function
    output -- none
 
-----------------------------------------------------------------------*/
void do_phrase(pos, lklhd, who)
int pos;
int lklhd;
int who;
{
  int doP_code, do_pos;

  if (intrnl_dsply) {
    begin_title("do_phrase", pos, lklhd);
  }

  load_prb("DoPhrase");

  if ((doP_code = do_doP(pos, lklhd, who, &do_pos)) == 0) {
    if (intrnl_dsply) {
      printf("no do phrases can be formed\n");
    }
    goto end;
  }

  switch (doP_code) {
    case 1:                    /* do phrase formed, next find sub or obj */

    case 2:                               /* suggest other actions first */
            break;

    default: stx_err("unexpected doP_code", __LINE__, __FILE__);
  }
                    
end:  ;
  if (intrnl_dsply) {
    end_title("do_phrase");
  }
}


/*---------------------------------------------------------------------

  do_doP  --  execute do_phrase.prg  

    input  -- pos: the position where the do_doP works on
              lklhd: the likelihood the do_doP works at
              who:   who issued do_phrase
    output -- do_pos: the position of the formed phrase

  function returns  0: no have phrase can be formed
                    1: do phrase formed, and find sub or obj next
                    2: suggest other actions first

----------------------------------------------------------------------*/
int do_doP(pos, lklhd, who, do_pos)
int pos, lklhd, who, *do_pos;
{
  DIAGNOSIS_ARRAY   dgns[NumofDoDgns + 1];
  char              dgns_var[VAR_MAX + 1],  ptrn[PTRN_PHRS_MAX+1],
                    ptrn_names[MAXPTRNS+1][PTRN_PHRS_MAX+1], phrs[9],
                    used_ptrn[3][PTRN_PHRS_MAX+1] = {"", "", ""},
                    word[WORD_MAX+1];
  int               i, cnt, rht1, rht2, lh, lklhds[MAXPTRNS],return_val=0;
  boolean           next[NumofDoNext];

  symptoms_idx = 0;
  cnt = pos;
  rht1 = pos + 1;
  rht2 = pos + 2;
  for (i = 0; i < NumofDoNext; i++) next[i] = FALSE;

/*  switch(who) {
    case FindPredicate: 
                        strcpy(symptoms[symptoms_idx++], "who(find_prd)");
                        break;
  
    default: stx_err("unexpected problem code", __LINE__, __FILE__);
  }
*/

  get_ptrn_names(sentence, sentence_len, cnt, ptrn_names, lklhds);
  i = 0;
  strcpy(ptrn, ptrn_names[i++]);
  while (!EQUAL(ptrn,"")) {
    if (doP_cntptrn(ptrn)) {
      sprintf(symptoms[symptoms_idx++], "cnt_ptn(%s)", ptrn);
      if (EQUAL(used_ptrn[0],"")) strcpy(used_ptrn[0], ptrn);
    }
    strcpy(ptrn, ptrn_names[i++]);
  }

  get_word(sentence, sentence_len, cnt, word);
  if (!EQUAL(word,"")) {
    if (doP_cntwd(word)) {
      if (word_check(word)==0) {
        sprintf(symptoms[symptoms_idx++], "cnt_wd(%s)", word);
      } else {
        sprintf(symptoms[symptoms_idx++], "cnt_wd(%s_)", word);
      }
    }
  }

  
  get_ptrn_names(sentence, sentence_len, rht1, ptrn_names, lklhds);
  i = 0;
  strcpy(ptrn, ptrn_names[i++]);
  while (!EQUAL(ptrn,"")) {
    if (doP_rht1ptrn(ptrn)) {
      sprintf(symptoms[symptoms_idx++], "rht1_ptn(%s)", ptrn);
      if (EQUAL(used_ptrn[1],"")) strcpy(used_ptrn[1], ptrn);
    }
    strcpy(ptrn, ptrn_names[i++]);
  }

  get_ptrn_names(sentence, sentence_len, rht2, ptrn_names, lklhds);
  i = 0;
  strcpy(ptrn, ptrn_names[i++]);
  while (!EQUAL(ptrn,"")) {
    if (doP_rht2ptrn(ptrn)) {
      sprintf(symptoms[symptoms_idx++], "rht2_ptn(%s)", ptrn);
      if (EQUAL(used_ptrn[2],"")) strcpy(used_ptrn[2], ptrn);
    }
    strcpy(ptrn, ptrn_names[i++]);
  }


  if (doP_rht1phrs(sentence, sentence_len, rht1, phrs)) 
    sprintf(symptoms[symptoms_idx++], "rht1_ph(%s)", phrs);

  if (doP_rht2phrs(sentence, sentence_len, rht2, phrs)) 
    sprintf(symptoms[symptoms_idx++], "rht2_ph(%s)", phrs);


  strcpy(symptoms[symptoms_idx],"");

  mst_smp(symptoms, name, state, type, value, errcde);
  sol_prb(name, state, type, value, errcde);
  if (errcde[0] != 0) {
    stx_err("failed to solve problem", __LINE__, __FILE__);
  }

  if EQUAL(state, "S") { 
    copy_dgns(dgns, do_dgns);
    get_dgn(dgns,name,state,type,value,errcde);
    if (value[0]) {                      /* has at least one true value */
      boolean cmb_rht_one = FALSE, cmb_rht_two = FALSE;
      char    phrase_name[PTRN_PHRS_MAX+1] = "";
      char    clss[MAXPHRASE][PTRN_PHRS_MAX+1]; 
      struct  Syntx_Term *stc; 
      int     stc_len;
      struct  SPOC_Pos stc_spoc;

      i = 0;
      strcpy(clss[0], used_ptrn[0]);
      strcpy(clss[1], used_ptrn[1]);
      strcpy(clss[2], used_ptrn[2]);

      while (! EQUAL(dgns[i],"")) {
        strcpy(dgns_var, dgns[i++]);

        if (EQUAL(dgns_var,"next(find_sub)")) { 
          next[0] = TRUE; 
          continue; 
        }

        if (EQUAL(dgns_var,"next(find_obj)")) { 
          next[1] = TRUE; 
          continue; 
        }

        if (EQUAL(dgns_var,"next(adv_phrs)")) { 
          next[2] = TRUE; 
          doP_other_next(sentence, &sentence_len, &sentence_spoc, 
                         cnt, next, lklhd);
          return_val = 2;
          continue; 
        }

        if (EQUAL(dgns_var,"next(vb_phrs1)")) { 
          next[3] = TRUE; 
          doP_other_next(sentence, &sentence_len, &sentence_spoc, 
                         cnt, next, lklhd);
          return_val = 2;
          continue; 
        }

        if (EQUAL(dgns_var,"next(vb_phrs2)")) { 
          next[4] = TRUE;
          doP_other_next(sentence, &sentence_len, &sentence_spoc, 
                         cnt, next, lklhd);
          return_val = 2; 
          continue; 
        }

        if (EQUAL(dgns_var,"cmb_rht_one")) { 
          cmb_rht_one = TRUE; 
          continue; 
        }

        if (EQUAL(dgns_var,"cmb_rht_two")) { 
          cmb_rht_two = TRUE; 
          continue; 
        }

        if (EQUAL(dgns_var,"do_ph(does_vt)")) { 
          stc = (struct Syntx_Term *)stc_cpy(&stc_len, &stc_spoc,
                                   sentence, sentence_len, &sentence_spoc);
          return_val = doP_cmb_and_next(stc, &stc_len, &stc_spoc,cnt,clss,
                       "does_vt",lklhd,cmb_rht_one,cmb_rht_two,next,TRUE);
          stc_dsp(stc);
          continue; 
        }

        if (EQUAL(dgns_var,"do_ph(does_vi)")) { 
          stc = (struct Syntx_Term *)stc_cpy(&stc_len, &stc_spoc,
                                   sentence, sentence_len, &sentence_spoc);
          return_val = doP_cmb_and_next(stc, &stc_len, &stc_spoc,cnt,clss,
                       "does_vi",lklhd,cmb_rht_one,cmb_rht_two,next,FALSE);
          stc_dsp(stc);
          continue; 
        }
        
        if (EQUAL(dgns_var,"do_ph(do_vt)")) { 
          stc = (struct Syntx_Term *)stc_cpy(&stc_len, &stc_spoc,
                                   sentence, sentence_len, &sentence_spoc);
          return_val = doP_cmb_and_next(stc, &stc_len, &stc_spoc,cnt,clss,
                       "do_vt",lklhd,cmb_rht_one,cmb_rht_two,next,TRUE);
          stc_dsp(stc);
          continue; 
        }

        if (EQUAL(dgns_var,"do_ph(do_vi)")) { 
          stc = (struct Syntx_Term *)stc_cpy(&stc_len, &stc_spoc,
                                   sentence, sentence_len, &sentence_spoc);
          return_val = doP_cmb_and_next(stc, &stc_len, &stc_spoc,cnt,clss,
                       "do_vi",lklhd,cmb_rht_one,cmb_rht_two,next,FALSE);
          stc_dsp(stc);
          continue; 
        }
        
        if (EQUAL(dgns_var,"do_ph(did_vt)")) { 
          stc = (struct Syntx_Term *)stc_cpy(&stc_len, &stc_spoc,
                                   sentence, sentence_len, &sentence_spoc);
          return_val = doP_cmb_and_next(stc, &stc_len, &stc_spoc,cnt,clss,
                       "did_vt",lklhd,cmb_rht_one,cmb_rht_two,next,TRUE);
          stc_dsp(stc);
          continue; 
        }

        if (EQUAL(dgns_var,"do_ph(did_vi)")) { 
          stc = (struct Syntx_Term *)stc_cpy(&stc_len, &stc_spoc,
                                   sentence, sentence_len, &sentence_spoc);
          return_val = doP_cmb_and_next(stc, &stc_len, &stc_spoc,cnt,clss,
                       "did_vi",lklhd,cmb_rht_one,cmb_rht_two,next,FALSE);
          stc_dsp(stc);
          continue; 
        }
      }
  
      *do_pos = pos;
    }
  }
  else stx_err("problem is unsatisfied", __LINE__, __FILE__);

  strcpy(state, "A");
  rst_prb(name, state, type, value, errcde);
  return return_val;
}


/*---------------------------------------------------------------------

  doP_cntptrn  --  check if the pattern is considered in the log file

    input  -- ptrn: current pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean doP_cntptrn(ptrn)
char *ptrn;
{
  char str[3];

  str[0] = ptrn[0];
  str[1] = ptrn[1];
  str[2] = '\0';

  if (EQUAL(str,"do")) return TRUE;
  return FALSE;
}

/*---------------------------------------------------------------------

  doP_cntwd  --  check if current word is considered in the log file

    input  -- word: current word to be checked

  function returns TRUE if word is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean doP_cntwd(word)
char *word;
{
  int  i, len;
  char ch;

  len = strlen(word);
  for (i = 0; i < len; i++) {
    if ((ch = word[i]) == '\'') {
      word[i] = '_';
    }
    else word[i] = tolower(ch);
  }

  if (EQUAL(word,"does")    OR
      EQUAL(word,"doesn_t"))   return TRUE; 

  return FALSE;
}

/*---------------------------------------------------------------------

  doP_rht1ptrn  --  check if right1 pattern is considered in the log file

    input  -- ptrn: right1 pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean doP_rht1ptrn(ptrn)
char *ptrn;
{
  if (EQUAL(ptrn,"vt_pl")  OR
      EQUAL(ptrn,"vi_pl")  OR
      EQUAL(ptrn,"adv")    OR
      EQUAL(ptrn,"adv_er"))     return TRUE;

  return FALSE;
}

/*---------------------------------------------------------------------

  doP_rht2ptrn  --  check if right2 pattern is considered in the log file

    input  -- ptrn: right2 pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean doP_rht2ptrn(ptrn)
char *ptrn;
{
  if (EQUAL(ptrn,"vt_pl")  OR
      EQUAL(ptrn,"vi_pl"))    return TRUE;

  return FALSE;
}

/*----------------------------------------------------------------------

  doP_rht1phrs  --  check if right1 phrase is considered in the log file

    input  -- stc:  a sentence
              slen: sentence length
              idx:  token index
    output -- phrs: phrase name

   function returns TRUE if it is considered in log file, FALSE otherwise

-----------------------------------------------------------------------*/
boolean doP_rht1phrs(stc, slen, idx, phrs)
struct Syntx_Term *stc;
int    slen;
int    idx;
char   *phrs;
{
  int  lh;

  get_phrs_name(stc, slen, idx, phrs, &lh);

  if (EQUAL(phrs,"")) return FALSE;

  if (EQUAL(phrs,"adv")    OR
      EQUAL(phrs,"adv_er") OR
      EQUAL(phrs,"vt_pl")  OR
      EQUAL(phrs,"vi_pl"))   return TRUE;

  return FALSE;
}


/*----------------------------------------------------------------------

  doP_rht2phrs  --  check if right2 phrase is considered in the log file

    input  -- stc:  a sentence
              slen: sentence length
              idx:  token index
    output -- phrs: phrase name

   function returns TRUE if it is considered in log file, FALSE otherwise

-----------------------------------------------------------------------*/
boolean doP_rht2phrs(stc, slen, idx, phrs)
struct Syntx_Term *stc;
int    slen;
int    idx;
char   *phrs;
{
  int  lh;

  get_phrs_name(stc, slen, idx, phrs, &lh);

  if (EQUAL(phrs,"")) return FALSE;

  if (EQUAL(phrs,"vt_pl")  OR
      EQUAL(phrs,"vi_pl"))   return TRUE;

  return FALSE;
}




/*---------------------------------------------------------------------

  doP_cmb_and_next  --  combine tokens and issue next command

    input  -- stc:    sentence
              slen:   sentence length
              spoc:   positions of SPOC
              cnt:    current position
              clss:   the classifications of the tokens to be combined
              phrase: the name of the combined phrase
              lh:     likelihood
              cmb1:   indicate combining cnt and right1
              cmb2:   indicate combining cnt, right1 and right2
              next:   indicate the next command to be executed
              vt:     indicate the phrase is a vt

    output -- function return 0: do nothing
                              1: do phrase formed, and find sub or obj next

------------------------------------------------------------------------*/
int doP_cmb_and_next(stc, slen, spoc, cnt, clss, phrase, lh, cmb1, cmb2, next,vt)
struct  Syntx_Term *stc; 
int     *slen;
struct  SPOC_Pos *spoc;
int     cnt;
char    clss[MAXPHRASE][PTRN_PHRS_MAX+1]; 
char    *phrase;
int     lh;
boolean cmb1;
boolean cmb2;
boolean next[NumofDoNext];
boolean vt;
{
  
  if (!cmb1 AND !cmb2) return 0;

  if (cmb1) { 
    if (intrnl_dsply) {
      printf("%d + %d  ==>  phrase '%s'\n\n", cnt, cnt+1, phrase);
    }
    cmb_token(stc, slen, spoc, cnt, cnt+1, clss, phrase, lh);
  }

  if (cmb2) { 
    if (intrnl_dsply) {
      printf("%d + %d + %d  ==>  phrase '%s'\n\n",cnt,cnt+1,cnt+2, phrase);
    }
    cmb_token(stc, slen, spoc, cnt, cnt+2, clss, phrase, lh);
  }

  if ((next[0]) AND !vt) {                         /* next[0] = find_sub */
    spoc->prd_pos = cnt;
    stc_push(stc, *slen, spoc, FindSubject, cnt-1, lh, DoPhrase);
    return 1;
  }

  if ((next[1]) AND vt) {                          /* next[1] = find_obj */
    spoc->prd_pos = cnt;
    stc_push(stc, *slen, spoc, FindObject, cnt+1, lh, DoPhrase);
    return 1;
  }
  
  return 0;
}

    

/*---------------------------------------------------------------------

  doP_other_next  --  issue the next other command

    input  -- stc:    sentence
              slen:   sentence length
              spoc:   positions of SPOC
              cnt:    current position
              next:   indicate the next command to be executed
              lh:     likelihood

    output -- none

------------------------------------------------------------------------*/
void doP_other_next(stc, slen, spoc, cnt, next, lh)
struct  Syntx_Term *stc; 
int     *slen;
struct  SPOC_Pos *spoc;
int     cnt;
boolean next[NumofDoNext];
int     lh;
{

  if (next[2]) {                                             /* adv_phrs */
    stc_push(stc, *slen, spoc, AdvPhrase, cnt+1, lh, DoPhrase);
  }
  if (next[3]) {                                             /* vb_phrs1 */
    stc_push(stc, *slen, spoc, VerbPhrase, cnt+1, lh, DoPhrase);
  }
  if (next[4]) {                                             /* vb_phrs2 */
    stc_push(stc, *slen, spoc, VerbPhrase, cnt+2, lh, DoPhrase);
  }
}
