#include "syntx.h"

#define        NumofFobjDgns    10
#define        NumofFobjSymp    60

extern struct Syntx_Term *sentence; 
extern int                sentence_len;
extern struct SPOC_Pos    sentence_spoc;
extern boolean            intrnl_dsply;


extern POSITION position[];





DIAGNOSIS_ARRAY fndobj_dgns[NumofFobjDgns + 1] = { 
                                                   "do_nobj(fifth)",
                                                   "do_nobj(fourth)",
                                                   "do_nobj(third)",
                                                   "do_nobj(second)",
                                                   "do_nobj(first)",
                                                   "do_pobj(fifth)",
                                                   "do_pobj(fourth)",
                                                   "do_pobj(third)",
                                                   "do_pobj(second)",
                                                   "do_pobj(first)",
                                                   ""
                                                 }; 



int           symptoms_idx;
SYMPTOM_ARRAY symptoms[mmax(NumofFobjSymp,MAXSYMP)];




void find_object();
void findobject();
void set_fobj_symps();
boolean Fndobj_hasptrn();
boolean Fndobj_haswd();




/*----------------------------------------------------------------------

  find_object  --  control the action of findobject

    input  -- pos: findobject starts at the pos
              lklhd: the likelyhood at which the action will take
              who:  the code of the block which issued this action
    output -- none
 
-----------------------------------------------------------------------*/
void find_object(pos, lklhd, who)
int pos;
int lklhd;
int who;
{
  int     suggest_action[OBJ_MAX], stack_ptr = 0, 
          obj_pos[OBJ_MAX], num_obj, i;
  boolean pos_suggested[OBJ_MAX];
  struct { int  pos; int  code; int  lh; } stack[OBJ_MAX];

  if (intrnl_dsply) {
    begin_title("find_object", -1, -1);
  }

  if (pos >= sentence_len) {
    save_stxerr("err_obj_missing", lklhd, sentence, sentence_len, 
                 &sentence_spoc);
    goto find_object_end;
  }

  for (i = 0; i < OBJ_MAX; i++) pos_suggested[i] = FALSE;

  find_obj_pos(sentence, sentence_len, pos, &num_obj, obj_pos);

  if (num_obj == 0) {
    save_stxerr("err_obj_missing", lklhd, sentence, sentence_len, 
                 &sentence_spoc);
    goto find_object_end;
  }

  if (num_obj == 1) {
    int idx, l, j;
    char word[WORD_MAX+1];

    idx = obj_pos[0];

    get_word(sentence, sentence_len, idx, word);
    l = strlen(word);
    for (j = 0; j < l; j++) word[j] = tolower(word[j]);

    if (EQUAL(word,"to")) {
      if (intrnl_dsply) {
        printf("suggests ToPhrase at %d in likelihood %d\n\n", idx, 100);
      }
      stc_push(sentence, sentence_len, &sentence_spoc, ToPhrase, 
               idx,100,FindObject);
      goto find_object_end;
    }

    if (has_objpron(sentence, sentence_len, idx)) {
      if (intrnl_dsply) {
       printf("suggests PronounPhrase at %d in likelihood %d\n\n",idx,100);
      }

      stc_push(sentence, sentence_len, &sentence_spoc, PronounPhrase, 
               idx, 100,FindObject);

      if (has_adjpron(sentence, sentence_len, idx)) {
        if (intrnl_dsply) {
          printf("suggests NounPhrase at %d in likelihood %d\n\n",idx,100);
        }

        stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase, 
                 idx, 100, FindObject);
      }

      goto find_object_end;
    }
    if (intrnl_dsply) {
      printf("suggests NounPhrase at %d in likelihood %d\n\n", idx, 100);
    }
    stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase, 
             idx, 100, FindObject);
    goto find_object_end;
  }

  load_prb("FindObject");
  set_fobj_symps(pos, num_obj, obj_pos);
  
  findobject(100, suggest_action);
  for (i = 0; i < OBJ_MAX; i++)  {
    if (suggest_action[i] != 0) {
      pos_suggested[i] = TRUE;
      stack[stack_ptr].pos = obj_pos[i];
      stack[stack_ptr].code = suggest_action[i];
      stack[stack_ptr++].lh = 100;
    }
  }

  findobject(85, suggest_action);
  for (i = 0; i < OBJ_MAX; i++)  {
    if ((suggest_action[i] != 0) AND (!pos_suggested[i])) {
      pos_suggested[i] = TRUE;
      stack[stack_ptr].pos = obj_pos[i];
      stack[stack_ptr].code = suggest_action[i];
      stack[stack_ptr++].lh = 85;
    }
  }

  findobject(10, suggest_action);
  for (i = 0; i < OBJ_MAX; i++)  {
    if ((suggest_action[i] != 0) AND (!pos_suggested[i])) {
      pos_suggested[i] = TRUE;
      stack[stack_ptr].pos = obj_pos[i];
      stack[stack_ptr].code = suggest_action[i];
      stack[stack_ptr++].lh = 10;
    }
  }
  strcpy(state, "A");
  rst_prb(name, state, type, value, errcde);

/*  for (i = stack_ptr-1; i >= 0; i--) { */
  for (i = 0; i < stack_ptr; i++) {
    switch (stack[i].code) {
      case 1:                                         /* do noun object */
              if (intrnl_dsply) {
                printf("suggests NounPhrase at %d in likelihood %d\n\n", 
                        stack[i].pos, stack[i].lh);
              }
              stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase, 
                       stack[i].pos, stack[i].lh, FindObject);
              break;

      case 2:                                      /* do pronoun object */
              if (intrnl_dsply) {
               printf("suggests PronounPhrase at %d in likelihood %d\n\n", 
                       stack[i].pos, stack[i].lh);
              }
              stc_push(sentence, sentence_len, &sentence_spoc, 
                       PronounPhrase,stack[i].pos,stack[i].lh,FindObject);
              break;

      case 3:                              /* do noun and pronoun object */
              if (intrnl_dsply) {
                printf("suggests NounPhrase and PronounPhrase at %d in likelihood %d\n\n", stack[i].pos, stack[i].lh);
              }
              stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase,
                       stack[i].pos, stack[i].lh, FindObject);
              stc_push(sentence, sentence_len, &sentence_spoc, 
                       PronounPhrase,stack[i].pos,stack[i].lh,FindObject);
              break;

      case 4:                                            /* do to object */
              if (intrnl_dsply) {
                printf("suggests ToPhrase at %d in likelihood %d\n\n",
                        stack[i].pos, stack[i].lh);
              }
              stc_push(sentence, sentence_len, &sentence_spoc, ToPhrase, 
                       stack[i].pos, stack[i].lh, FindObject);
              break;

      default: stx_err("unexpected fobj code", __LINE__, __FILE__);
    }
  }

find_object_end: 

  if (intrnl_dsply) {
    end_title("find_object");
  }

}


/*---------------------------------------------------------------------

  findobject  --  execute find_object.prg at the likelihood above lhd 

    input  -- lhd:   likelihood above which find_object.prg is executed
    output -- suggest: suggest[i] = 0  --  no action suggested on ith noun
                                    1  --  noun object suggested
                                    2  --  pronoun object suggested
                                    3  --  noun or pronoun object suggested
                                    4  --  to object suggested

----------------------------------------------------------------------*/
void findobject(lhd, suggest)
int lhd, suggest[OBJ_MAX];
{
  int    i;
  char   dgns_var[VAR_MAX + 1];
  DIAGNOSIS_ARRAY   dgns[NumofFobjDgns + 1];


  for (i = 0; i < OBJ_MAX; i++) suggest[i] = 0;
  if (lhd == 100) {
    strcpy(name, "fndobj??");
    value[0] = 1;
    value[1] = 85;
    strcpy(state, "D");
    mst_cls(name, state, type, value, errcde);
    if (errcde[0] != 0) 
      stx_err("errors occur in mst_cls", __LINE__, __FILE__);
  }
  else {
    strcpy(name, "fndobj??");
    value[0] = (long) lhd;
    value[1] = (long) lhd;
    strcpy(state, "A");
    mst_cls(name, state, type, value, errcde);
    if (errcde[0] != 0) 
      stx_err("errors occur in mst_cls", __LINE__, __FILE__);
  }
  sol_prb(name, state, type, value, errcde);
  if (errcde[0] != 0)
    stx_err("errors occur in sol_prb", __LINE__, __FILE__);
  if (state[0] == 'S') { 
    copy_dgns(dgns, fndobj_dgns);
    get_dgn(dgns,name,state,type,value,errcde);
    if (value[0] == 0) return;
    i = 0;
    while (! EQUAL(dgns[i],"")) {
      strcpy(dgns_var, dgns[i++]);
      if (EQUAL(dgns_var,"do_nobj(fifth)")) { 
        suggest[4] = suggest[4] + 1; continue; 
      }
      if (EQUAL(dgns_var,"do_nobj(fourth)")) { 
        suggest[3] = suggest[3] + 1; continue; 
      }
      if (EQUAL(dgns_var,"do_nobj(third)")) { 
        suggest[2] = suggest[2] + 1; continue; 
      }
      if (EQUAL(dgns_var,"do_nobj(second)")) { 
        suggest[1] = suggest[1] + 1; continue; 
      }
      if (EQUAL(dgns_var,"do_nobj(first)")) { 
        suggest[0] = suggest[0] + 1; continue; 
      }

      if (EQUAL(dgns_var,"do_pobj(fifth)")) { 
        suggest[4] = suggest[4] + 2; continue; 
      }
      if (EQUAL(dgns_var,"do_pobj(fourth)")) { 
        suggest[3] = suggest[3] + 2; continue; 
      }
      if (EQUAL(dgns_var,"do_pobj(third)")) { 
        suggest[2] = suggest[2] + 2; continue; 
      }
      if (EQUAL(dgns_var,"do_pobj(second)")) { 
        suggest[1] = suggest[1] + 2; continue; 
      }
      if (EQUAL(dgns_var,"do_pobj(first)")) { 
        suggest[0] = suggest[0] + 2; continue; 
      }

      if (EQUAL(dgns_var,"do_tobj(fifth)")) { 
        suggest[4] = suggest[4] + 4; continue; 
      }
      if (EQUAL(dgns_var,"do_tobj(fourth)")) {
        suggest[3] = suggest[3] + 4; continue; 
      }
      if (EQUAL(dgns_var,"do_tobj(third)")) { 
        suggest[2] = suggest[2] + 4; continue; 
      }
      if (EQUAL(dgns_var,"do_tobj(second)")) { 
        suggest[1] = suggest[1] + 4; continue; 
      }
      if (EQUAL(dgns_var,"do_tobj(first)")) { 
        suggest[0] = suggest[0] + 4; continue; 
      }
    }
  }
  else stx_err("problem is unsatisfied", __LINE__, __FILE__);
}




/*---------------------------------------------------------------------

  set_fobj_symps  --  set symptoms of objects into array 'symptoms'
  
    input  -- pos: considered range is starting at pos to the left
              num: the number of objects
              obj_pos: the position of objects
    output -- none

----------------------------------------------------------------------*/
void set_fobj_symps(pos, num, obj_pos)
int  pos, num, obj_pos[];
{
  int     i, j, lft, cnt, lklhds[MAXPTRNS], lh;
  char    ptrn[PTRN_PHRS_MAX+1], ptrn_names[MAXPTRNS+1][PTRN_PHRS_MAX+1];
  boolean lp_occur = FALSE, lp_noun = FALSE;
  char    word[WORD_MAX+1]; 


  symptoms_idx = 0;
  for (i = pos; i < obj_pos[0]; i++) { 
    if (has_prep(sentence, sentence_len, i, &lh)) {
      lp_occur = TRUE;
      break;
    }
  }

  for (i = 0; i < num; i++) {
    cnt = obj_pos[i];
    lft = cnt - 1;

    if (has_prep(sentence, sentence_len, lft, &lh)) {
      sprintf(symptoms[symptoms_idx++], "lft_prep(%s)", position[i]);
      if (!lp_occur) lp_occur = TRUE;
    }
    if (lp_occur) 
      sprintf(symptoms[symptoms_idx++], "lp_occur(%s)", position[i]);
    if (lp_noun)
      sprintf(symptoms[symptoms_idx++], "lp_noun(%s)", position[i]);

    get_ptrn_names(sentence, sentence_len, cnt, ptrn_names, lklhds);
    j = 0;
    strcpy(ptrn, ptrn_names[j++]);
    while (!EQUAL(ptrn,"")) {
      if (Fndobj_hasptrn(ptrn)) {
        sprintf(symptoms[symptoms_idx++], "has_ptrn(%s,%s)",
                position[i], ptrn);
        if (lp_occur) lp_noun = TRUE;
      }
      strcpy(ptrn, ptrn_names[j++]);
    }

    get_word(sentence, sentence_len, cnt, word);
    if (!EQUAL(word,"")) {
      if (Fndobj_haswd(word)) {
        sprintf(symptoms[symptoms_idx++], "has_wd(%s,%s)", 
                position[i], word);
      }
    }

    if (has_adjpron(sentence, sentence_len, cnt, &lh)) {
      sprintf(symptoms[symptoms_idx++], "has_ptrn(%s,pron_adj)",
              position[i]);
      if (lp_occur) lp_noun = TRUE;
    }
    if (has_objpron(sentence, sentence_len, cnt)) {
      sprintf(symptoms[symptoms_idx++], "has_ptrn(%s,pron_obj)",
              position[i]);
      if (lp_occur) lp_noun = TRUE;
    }

    if ((!lp_occur) AND (i < (num-1))) {
      for (j = obj_pos[i]+1; j < obj_pos[i+1]; j++) { 
        if (has_prep(sentence, sentence_len, j, &lh)) {
          lp_occur = TRUE;
          break;
        }
      }
    }
  }
  strcpy(symptoms[symptoms_idx],"");

  mst_smp(symptoms, name, state, type, value, errcde);
}


/*---------------------------------------------------------------------

  Fndobj_hasptrn  --  check if the pattern is considered in the log file

    input  -- ptrn: current pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean Fndobj_hasptrn(ptrn)
char *ptrn;
{
  if ((EQUAL(ptrn,"artcl_df")) OR
      (EQUAL(ptrn,"artcl_id")) OR
      (EQUAL(ptrn,"noun_sgl")) OR
      (EQUAL(ptrn,"noun_pl"))  OR
      (EQUAL(ptrn,"vt_ing"))   OR
      (EQUAL(ptrn,"vi_ing"))   OR
      (EQUAL(ptrn,"being")))   return TRUE;

  return FALSE;
}



/*---------------------------------------------------------------------

  Fndobj_haswd  --  check if current word is considered in the log file

    input  -- word: current word to be checked
    output -- none

  function returns TRUE if word is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean Fndobj_haswd(word)
char *word;
{
  int  i, len;

  len = strlen(word);
  for (i = 0; i < len; i++) word[i] = tolower(word[i]);

  if (EQUAL(word,"t0")) return TRUE;

  return FALSE;
}
