#include "syntx.h"

#define        NumofFprdDgns    5
#define        NumofFprdSymp    90

extern struct Syntx_Term *sentence; 
extern int                sentence_len;
extern struct SPOC_Pos    sentence_spoc;
extern boolean            intrnl_dsply;


typedef        char DISTANCE[9];



DIAGNOSIS_ARRAY whrdo_dgns[NumofFprdDgns + 1] = { 
                                                 "do_prdct(first)",
                                                 "do_prdct(second)",
                                                 "do_prdct(third)",
                                                 "do_prdct(fourth)",
                                                 "do_prdct(fifth)",
                                                 ""
                                               }; 
POSITION        position[5] = {
                                "first",
                                "second",
                                "third",
                                "fourth",
                                "fifth"
                              };

DISTANCE        distance[4] = {
                                "next", 
                                "near", 
                                "far", 
                                "very_far"
                              };




int           symptoms_idx;
SYMPTOM_ARRAY symptoms[mmax(NumofFprdSymp,MAXSYMP)];




void find_predicate();
int  findpredicate();
void count_lft_nouns();
void count_rht_nouns();
void set_fprd_symps();

boolean check_lnkvb();




/*----------------------------------------------------------------------

  find_predicate  --  control the action of findpredicate

    input  -- pos:  the position where the action to be taken
              lklhd: the likelyhood at which the action will take
              who:  the code of the block which issued this action
    output -- none
 
-----------------------------------------------------------------------*/
void find_predicate(pos, lklhd, who)
int pos;
int lklhd;
int who;
{
  struct Syntx_Term *stc;
  int               len, lhood, verb_pos, fprd_code, i, num, total_drop;
  struct  SPOC_Pos  stc_spoc;

# ifdef  TRACK
begin_title("findpredicate", -1, -1);
# endif

  load_prb("FindPredicate");

  fprd_code = findpredicate(lklhd, &verb_pos, &lhood);
  strcpy(state, "A");
  rst_prb(name, state, type, value, errcde);

  switch (fprd_code) {
    case 0:                             /* no actions can be determined */

# ifdef  TRACK
printf("no verbs can be determined\n\n");
# endif
            goto fprd_end;

    case 1:       /* suggest do_predicate on the pos which is one of the */
                                               /* several verb positions */

# ifdef  TRACK
printf("there are several choices, we select one in %d\n\n", verb_pos);
# endif

            stc = (struct Syntx_Term *)stc_cpy(&len, &stc_spoc, sentence,
                                              sentence_len,&sentence_spoc);
            if (drop_all_vb(stc, len, verb_pos, FALSE) != -1) {
              if (simplify_again(stc, len)) 
                stc_push(stc, len, &stc_spoc, FindPredicate, -1,
                         lklhd, FindPredicate);
            }
            stc_dsp(stc);

            total_drop = 0;
            for (i = 0 ; i < sentence_len; i++) {
              if (i == verb_pos) continue;
              if ((num = drop_all_vb(sentence, sentence_len, 
                                       i, FALSE)) == -1) goto fprd_end;
              total_drop = total_drop + num;
            }
            if ((num = keep_all_vtvi(sentence, sentence_len,
                                     verb_pos, FALSE)) == -1) goto fprd_end;
            total_drop = total_drop + num;
            if (total_drop > 0) {
              if (simplify_again(sentence, sentence_len)) {
                if (check_lnkvb(sentence, sentence_len, &sentence_spoc, 
                                verb_pos, lhood))
                  VerbPhrase_stc_push(sentence, sentence_len,
                           &sentence_spoc, verb_pos, FindPredicate, lklhd);
              }
            }
            else {
              if (check_lnkvb(sentence, sentence_len, &sentence_spoc,
                              verb_pos, lhood))
                VerbPhrase_stc_push(sentence, sentence_len,&sentence_spoc, 
                                    verb_pos, FindPredicate, lklhd);
            }
            goto fprd_end;

    case 2:                             /* suggest be_phrase on the pos */

# ifdef  TRACK
printf("find verb be, suggest be_phrase on %d\n\n", verb_pos);
# endif

            stc = (struct Syntx_Term *)stc_cpy(&len, &stc_spoc, sentence,
                                              sentence_len,&sentence_spoc);
            if (drop_be(stc, len, verb_pos, FALSE) != -1) {
              if (simplify_again(stc, len)) 
                stc_push(stc, len, &stc_spoc, FindPredicate, -1, 
                         lklhd, FindPredicate);
            }
            stc_dsp(stc);

            for (i = 0 ; i < sentence_len; i++) {
              if (i == verb_pos) continue;
              if (drop_all_vb(sentence, sentence_len, i, FALSE) == -1) 
                goto fprd_end;
            }

            if (keep_be(sentence, sentence_len, verb_pos, FALSE) == -1)
              goto fprd_end;
            stc_push(sentence, sentence_len, &sentence_spoc,
                     BePhrase, verb_pos, lhood, FindPredicate);
            goto fprd_end;

    case 3:                              /* suggest do_phrase on the pos */

# ifdef  TRACK
printf("find verb do, suggest do_phrase on %d\n\n", verb_pos);
# endif
            stc = (struct Syntx_Term *)stc_cpy(&len, &stc_spoc, sentence,
                                              sentence_len,&sentence_spoc);
            if (drop_do(stc, len, verb_pos, FALSE) != -1) {
              for (i = 0 ; i < len; i++) {
                if (i == verb_pos) continue;
                if (drop_all_vb(stc, len, i, FALSE) == -1) break;
              }
              if (i >= len) {
                if (simplify_again(stc, len))
                  stc_push(stc, len, &stc_spoc, FindPredicate, -1, 
                           lklhd, FindPredicate);
              }
            }
            stc_dsp(stc);

            if (keep_do(sentence, sentence_len, verb_pos, FALSE) == -1)
              goto fprd_end;
            stc_push(sentence, sentence_len, &sentence_spoc, DoPhrase, 
                     verb_pos, lhood, FindPredicate);
            goto fprd_end;

    case 4:                           /* suggest have_phrase on the pos */

# ifdef  TRACK
printf("find verb have, suggest have_phrase on %d\n\n", verb_pos);
# endif
            for (i = 0 ; i < sentence_len; i++) {
              if (i == verb_pos) continue;
              if (drop_all_vb(sentence, sentence_len, i, FALSE) == -1) 
                goto fprd_end;
            }

            stc = (struct Syntx_Term *)stc_cpy(&len, &stc_spoc, sentence,
                                              sentence_len,&sentence_spoc);
            if (drop_have(stc, len, verb_pos, FALSE) != -1) {
              if (simplify_again(stc, len))
                stc_push(stc, len, &stc_spoc, FindPredicate, -1, 
                         lklhd, FindPredicate);
            }
            stc_dsp(stc);

            if (keep_have(sentence, sentence_len, verb_pos, FALSE) == -1)
              goto fprd_end;
            stc_push(sentence, sentence_len, &sentence_spoc, HavePhrase, 
                     verb_pos, lhood, FindPredicate);
            goto fprd_end;

    case 5:                            /* suggest aux_phrase on the pos */

# ifdef  TRACK
printf("find aux, suggest aux_phrase on %d\n\n", verb_pos);
# endif

            stc = (struct Syntx_Term *)stc_cpy(&len, &stc_spoc, sentence,
                                              sentence_len,&sentence_spoc);
            if (drop_aux(stc, len, verb_pos, FALSE) != -1) {
              if (simplify_again(stc, len))
                stc_push(stc, len, &stc_spoc, FindPredicate, -1, 
                         lklhd, FindPredicate);
            }
            stc_dsp(stc);
            if (keep_aux(sentence, sentence_len, verb_pos, FALSE) == -1)
              goto fprd_end;
            stc_push(sentence, sentence_len, &sentence_spoc, AuxPhrase,
                     verb_pos, lhood, FindPredicate);
            goto fprd_end;

    case 6:                          /* suggest pronvb_phrase on the pos */

# ifdef  TRACK
printf("find pronvb, suggest pronvb_phrase on %d\n\n", verb_pos);
# endif

            PronvbPhrase_stc_push(sentence, sentence_len, &sentence_spoc,
                                  verb_pos, FindPredicate, lklhd);
            goto fprd_end;

    case 7: /* suggest verb_phrase on the pos which contains verb only*/

# ifdef  TRACK
printf("verb only at %d, suggest verb_phrase\n\n", verb_pos);
# endif

            total_drop = 0;
            for (i = 0; i < sentence_len; i++) {
              if (i == verb_pos) continue;
              if ((num = drop_all_vb(sentence, sentence_len, 
                                       i, FALSE)) == -1) goto fprd_end;
              total_drop = total_drop + num;
            }
            if (total_drop > 0) {
              if (simplify_again(sentence, sentence_len)) {
                if (check_lnkvb(sentence, sentence_len, &sentence_spoc,
                                verb_pos, lhood))
                 VerbPhrase_stc_push(sentence,sentence_len,&sentence_spoc,
                                     verb_pos, FindPredicate, lklhd);
              }
            }
            else {
              if (check_lnkvb(sentence, sentence_len, &sentence_spoc,
                              verb_pos, lhood))
                VerbPhrase_stc_push(sentence, sentence_len,&sentence_spoc,
                                    verb_pos, FindPredicate, lklhd);
            }
            goto fprd_end;

    case 8: /* suggest verb_phrase on the pos which is the only verb pos*/

# ifdef  TRACK
printf("%d is the only verb pos, suggest verb_phrase\n\n", verb_pos);
# endif

            if ((num = keep_all_vtvi(sentence, sentence_len, 
                                     verb_pos, FALSE)) == -1) goto fprd_end;
            if (num > 0) {
              if (simplify_again(sentence, sentence_len)) {
                if (check_lnkvb(sentence, sentence_len, &sentence_spoc,
                                verb_pos, lhood))
                 VerbPhrase_stc_push(sentence,sentence_len,&sentence_spoc,
                                     verb_pos, FindPredicate, lklhd);
              }
            }
            else {
              if (check_lnkvb(sentence, sentence_len, &sentence_spoc,
                              verb_pos, lhood))
                VerbPhrase_stc_push(sentence, sentence_len,&sentence_spoc,
                                    verb_pos, FindPredicate, lklhd);
            }
            goto fprd_end;

    default: stx_err("unexpected fprd_code", __LINE__, __FILE__);
  } /* ens of switch */


fprd_end:  ;

# ifdef  TRACK
end_title("findpredicate");
# endif

}


/*---------------------------------------------------------------------

  findpredicate  --  determine where to do the predicate analysis 

    input  -- lh:    likelihood at which find_predicate is suggested
    output -- pos:   the position at which the action is suggested
              lklhd: the action is determined at likelihood lklhd

   function returns 0: no actions can be determined
                    1: suggest verb_phrase on the pos which is one of the
                       several verb positions
                    2: suggest be_phrase on the pos
                    3: suggest do_phrase on the pos
                    4: suggest have_phrase on the pos
                    5. suggest aux_phrase on the pos
                    6. suggest pronvb_phrase on the pos
                    7. suggest verb_phrase on the pos which contains  
                       verb only
                    8. suggest verb_phrase on the pos which is the only
                       verb position

----------------------------------------------------------------------*/
int findpredicate(lh, pos, lklhd)
int lh, *pos, *lklhd;
{
  struct VerbPos vbpos[VERB_MAX];
  int    num_verbs, num_nouns, action_code, idx, i, nounpos[NOUN_MAX],
         start_level;
  char   dgns_var[VAR_MAX + 1], lft_noun[5], rht_noun[5];
  DIAGNOSIS_ARRAY   dgns[NumofFprdDgns + 1];


  symptoms_idx = 0;
  action_code = find_verb_pos(sentence, sentence_len, &num_verbs, vbpos);
  switch (action_code) {
    case 0:
    case 2:
    case 3: 
    case 4:
    case 5:
    case 6: 
    case 7:
    case 8:
            *pos = vbpos[0].index;
            *lklhd = lh;
            return action_code;

    case 1:                         /* several verb positions are found */
            find_noun_pos(sentence, sentence_len, &num_nouns, nounpos);
            for (i = 0; i < num_verbs; i++) {
              int  vb_idx;

              vb_idx = vbpos[i].index;
              count_lft_nouns(nounpos, num_nouns, vb_idx, lft_noun);
              count_rht_nouns(nounpos, num_nouns, vb_idx, rht_noun);
              set_fprd_symps(position[i], lft_noun, vbpos[i], rht_noun);
            }

            strcpy(symptoms[symptoms_idx],"");
            mst_smp(symptoms, name, state, type, value, errcde);

            strcpy(name, "where???");
            start_level = lklhd_level(lh);
            if (start_level < RARELY) {
              value[0] = (long) class_likelihood[RARELY];
              value[1] = (long) class_likelihood[start_level+1]; 
              strcpy(state, "D");
              mst_cls(name, state, type, value, errcde);
              if (errcde[0] != 0) 
                stx_err("errors occur in mst_cls", __LINE__, __FILE__);
            }
  
            for (i = (start_level+1); i <= (RARELY+1); i++) {
              sol_prb(name, state, type, value, errcde);
              if (errcde[0] != 0)
                stx_err("errors occur in sol_prb", __LINE__, __FILE__);

              if (state[0] == 'S') { 
                copy_dgns(dgns, whrdo_dgns);
                get_dgn(dgns,name,state,type,value,errcde);

                if (value[0] == 0) {/* no diagnositic variables are true */
                  if(i == (RARELY+1)) return 0;
          
                  value[0] = (long) class_likelihood[i];
                  value[1] = (long) class_likelihood[i];
                  strcpy(name, "where???");
                  strcpy(state, "A");
                  mst_cls(name, state, type, value, errcde);
                  if (errcde[0] != 0)
                    stx_err("errors occur in mst_cls", __LINE__, __FILE__);
                }
                else {
                  strcpy(dgns_var, dgns[0]);
                  if (EQUAL(dgns_var,"do_prdct(first)")) {
                    *pos = vbpos[0].index;
                    *lklhd = class_likelihood[i-1];
                    return 1;
                  }
                  if (EQUAL(dgns_var,"do_prdct(second)")) {
                    *pos = vbpos[1].index;
                    *lklhd = class_likelihood[i-1];
                    return 1;
                  }
                  if (EQUAL(dgns_var,"do_prdct(third)")) {
                    *pos = vbpos[2].index;
                    *lklhd = class_likelihood[i-1];
                    return 1;
                  }
                  if (EQUAL(dgns_var,"do_prdct(fourth)")) {
                    *pos = vbpos[3].index;
                    *lklhd = class_likelihood[i-1];
                    return 1;
                  }
                  if (EQUAL(dgns_var,"do_prdct(fifth)")) {
                    *pos = vbpos[4].index;
                    *lklhd = class_likelihood[i-1];
                    return 1;
                  }
                }
              } 
              else { /* state[0] != 'S' */
                stx_err("problem is unsatisfied", __LINE__, __FILE__);
              }
            }  /* end of for */
            return 0;

    default: stx_err("unexpected action code", __LINE__, __FILE__);

  } /* end of switch */
}

        
/*---------------------------------------------------------------------

  count_lft_nouns  --  count nouns to the left of a verb

    input  -- nouns: an array containing the indexs of nouns in a sentence
              num_nouns: the number of nouns in a sentence
              verb_idx: the index of the verb in a sentence
    output -- lft_noun: a binary string of length four, say "abcd", 

                a = '1' -- there is a noun next to the left of the verb;
                b = '1' -- there is a noun near to the left of the verb;
                c = '1' -- there is a noun far to the left of the verb;
                d = '1' -- there is a noun very far to the left of the 
                           verb;

-----------------------------------------------------------------------*/
void count_lft_nouns(nouns, num_nouns, verb_idx, lft_noun)
int  *nouns, num_nouns, verb_idx;
char *lft_noun;
{
  int   i, num_to_left, lft_len;

  strcpy(lft_noun, "0000");

  if ((num_nouns == 0) OR (verb_idx == 0)) return;

  for (i = 0; i < num_nouns; i++) {
    if (nouns[i] >= verb_idx) { break; }
  }
  num_to_left = i;

  if (num_to_left == 0) return;

  /* next to left is a noun*/
  if (nouns[num_to_left - 1] == (verb_idx - 1)) { 
    lft_noun[0] = '1';
    num_to_left--;
  } 
  
  lft_len = verb_idx - 1;
  if (num_to_left == lft_len) { 
    switch (num_to_left) {
      case 1:  
      case 2:  lft_noun[1] = '1';
               return;
      case 3:  lft_noun[1] = '1';
               lft_noun[2] = '1';
               return;
      default: lft_noun[1] = '1';
               lft_noun[2] = '1';
               lft_noun[3] = '1';
               return;
    }
  }

  if (lft_len >= 3) {
    int  far, near, idx;

    far = lft_len / 3;
    near = 2 * lft_len / 3;

    for (i = 0; i < num_to_left; i++) {
      idx = nouns[i];
      if ((idx >= 0) AND (idx < far)) { 
        lft_noun[3] = '1'; 
        continue;
      }
      if ((idx >= far) AND (idx < near)) { 
        lft_noun[2] = '1'; 
        continue;
      }
      if ((idx >= near) AND (idx < lft_len)) { 
        lft_noun[1] = '1'; 
        continue;
      }
    }

    return;
  }

  lft_noun[1] = '1';
}

 
/*---------------------------------------------------------------------

  count_rht_nouns  --  count nouns to the right of a verb

    input  -- nouns: an array containing the indexs of nouns in a sentence
              num_nouns: the number of nouns in a sentence
              verb_idx: the index of the verb in a sentence
    output -- rht_noun: a binary string of length four, say "abcd",
 
                a = '1' -- there is a noun next to the right of the verb;
                b = '1' -- there is a noun near to the right of the verb;
                c = '1' -- there is a noun far to the right of the verb;
                d = '1' -- there is a noun very far to the right of the verb;

-----------------------------------------------------------------------*/
void count_rht_nouns(nouns, num_nouns, verb_idx, rht_noun)
int  *nouns, num_nouns, verb_idx;
char *rht_noun;
{
  int   i, num_to_right, rht_len;
  
  strcpy(rht_noun, "0000");

  if ((num_nouns == 0) OR (verb_idx == (sentence_len - 1)))          
    return;

  for (i = num_nouns - 1; i >= 0; i--) {
    if (nouns[i] <= verb_idx) { break; }
  }
  num_to_right = num_nouns - i -1;

  if (num_to_right == 0) return;

  if (nouns[i + 1] == (verb_idx + 1)) { /* next to right is a noun*/
    rht_noun[0] = '1';
    num_to_right--;
  } 
  
  rht_len = sentence_len - verb_idx - 2;
  if (num_to_right == rht_len) { 
    switch (num_to_right) {
      case 1:  
      case 2:  rht_noun[1] = '1';
               return;
      case 3:  rht_noun[1] = '1';
               rht_noun[2] = '1';
               return;
      default: rht_noun[1] = '1';
               rht_noun[2] = '1';
               rht_noun[3] = '1';
               return;
    }
  }

  if (rht_len >= 3) {
    int  far, near, start, idx, bound;

    start = verb_idx + 2;
    near = rht_len / 3 + start;
    far = 2 * rht_len / 3 + start;

    bound = num_nouns - num_to_right - 1;
    for (i = num_nouns - 1; i > bound; i--) {
      idx = nouns[i];
      if ((idx >= start) AND (idx < near)) { 
        rht_noun[1] = '1'; 
        continue;
      }
      if ((idx >= near) AND (idx < far)) { 
        rht_noun[2] = '1';
        continue;
      }
      if ((idx >= far) AND (idx < sentence_len)) { 
        rht_noun[3] = '1';
        continue;
      }
    }

    return;
  }

  rht_noun[1] = '1';
}


/*---------------------------------------------------------------------

  set_fprd_symps  --  set symptoms of a verb into array 'symptoms'
  
    input  -- pos: the position of the verb in sentence
              lft_noun: the distances of nouns left to the verb
              vb_pos:   the position of the verb
              rht_noun: the distances of nouns right to the verb

    output -- none

----------------------------------------------------------------------*/
void set_fprd_symps(pos, lft_noun, vb_pos, rht_noun)
char  *pos, *lft_noun;
struct VerbPos vb_pos;
char  *rht_noun;
{
  int    i, intlhd;
  char   symp[VAR_MAX + 1], strlhd[5];

  if (vb_pos.vt) {
    intlhd_to_strlhd(vb_pos.vt_lhd, strlhd);
    sprintf(symp, "has_vt(%s,k%s)", pos, strlhd);
    strcpy(symptoms[symptoms_idx++], symp);
  }
  if (vb_pos.vi) {
    intlhd_to_strlhd(vb_pos.vi_lhd, strlhd);
    sprintf(symp, "has_vi(%s,k%s)", pos, strlhd);
    strcpy(symptoms[symptoms_idx++], symp);
  }

  for (i = 0; i < 4; i++) {
    if (lft_noun[i] == '1') {
      sprintf(symp, "lft_sub(%s,%s)", pos, distance[i]);
      strcpy(symptoms[symptoms_idx++], symp);
    }
  }

  for (i = 0; i < 4; i++) {
    if (rht_noun[i] == '1') {
      sprintf(symp, "rht_obj(%s,%s)", pos, distance[i]);
      strcpy(symptoms[symptoms_idx++], symp);
    }
  }
}



/*-------------------------------------------------------------------
  
  check_lnkvb  --  check the possibility of doing lnkvb_phrase, push 
                   the corresponding sentence into stack

    input  -- stc: the sentence
              len: sentence length
              spoc:  positions of SPOC
              vbpos: the verb position
              lhd: likelihood at which the action suggested
    output -- none

  function return TRUE if vbpos has patterns other than lnkvb, 
  FALSE otherwise.

--------------------------------------------------------------------*/
boolean check_lnkvb(stc, len, spoc, vbpos, lhd)
struct Syntx_Term *stc;
int  len;
struct SPOC_Pos *spoc;
int  vbpos, lhd;
{
  struct Syntx_Term *stc_tmp;
  int  len_tmp, lh;
  struct SPOC_Pos spoc_tmp;

  if (has_lnkvb(stc, len, vbpos, &lh)) {
    stc_tmp = (struct Syntx_Term *)stc_cpy(&len_tmp, &spoc_tmp, 
                                           stc, len, spoc);
    if (keep_lnkvb(stc_tmp, len_tmp, vbpos, FALSE) != -1) 
      stc_push(stc_tmp, len_tmp, &spoc_tmp, VerbPhrase, 
               vbpos, lhd, FindPredicate);
      if (drop_lnkvb(stc, len, vbpos, FALSE) == -1) {
        stc_dsp(stc_tmp); return FALSE;
      }
    stc_dsp(stc_tmp);
  }
  return TRUE;
}
