#include "syntx.h"

#define        NumofFsubDgns    10
#define        NumofFsubSymp    60

extern struct Syntx_Term *sentence; 
extern int                sentence_len;
extern struct SPOC_Pos    sentence_spoc;
extern boolean            intrnl_dsply;

extern POSITION position[];





DIAGNOSIS_ARRAY fndsub_dgns[NumofFsubDgns + 1] = { 
                                                   "do_nsub(fifth)",
                                                   "do_nsub(fourth)",
                                                   "do_nsub(third)",
                                                   "do_nsub(second)",
                                                   "do_nsub(first)",
                                                   "do_psub(fifth)",
                                                   "do_psub(fourth)",
                                                   "do_psub(third)",
                                                   "do_psub(second)",
                                                   "do_psub(first)",
                                                   ""
                                                 }; 



int           symptoms_idx;
SYMPTOM_ARRAY symptoms[mmax(NumofFsubSymp,MAXSYMP)];




void find_subject();
void findsubject();
void set_fsub_symps();
boolean Fndsub_hasptrn();
boolean Fndsub_haswd();




/*----------------------------------------------------------------------

  find_subject  --  control the action of findsubject

    input  -- pos: findsubject starts from 0 to pos
              lklhd: the likelyhood at which the action will take
              who:  the code of the block which issued this action
    output -- none
 
-----------------------------------------------------------------------*/
void find_subject(pos, lklhd, who)
int pos;
int lklhd;
int who;
{
  int     suggest_action[SUB_MAX], stack_ptr = 0, 
          sub_pos[SUB_MAX], num_sub, i;
  boolean pos_suggested[SUB_MAX];
  struct { int  pos; int  code; int  lh; } stack[SUB_MAX];

  if (intrnl_dsply) {
    begin_title("find_subject", -1, -1);
  }

  if (sentence_spoc.sub_pos != -1) {
    if (intrnl_dsply) {
      printf("subject has already been fixed\n");
    }
    stc_push(sentence, sentence_len, &sentence_spoc, FindModifier, 0, 
             lklhd, FindSubject);
    goto find_subject_end;
  }


  if (pos < 0) {
    stc_push(sentence, sentence_len, &sentence_spoc, FindModifier, 0, 
             lklhd, FindSubject);
    goto find_subject_end;
  }

  for (i = 0; i < SUB_MAX; i++) pos_suggested[i] = FALSE;

  find_sub_pos(sentence, sentence_len, pos, &num_sub, sub_pos);

  if (num_sub == 0) {
    stc_push(sentence, sentence_len, &sentence_spoc, SPOChecker, 0, lklhd, 
             FindSubject);
    goto find_subject_end;
  }

  if (num_sub == 1) {
    int idx, l, j;
    char word[WORD_MAX+1];

    idx = sub_pos[0];

    get_word(sentence, sentence_len, idx, word);
    l = strlen(word);
    for (j = 0; j < l; j++) word[j] = tolower(word[j]);

    if (EQUAL(word,"to")) {
      if (intrnl_dsply) {
        printf("suggests ToPhrase at %d in likelihood %d\n\n", idx, 100);
      }
      stc_push(sentence, sentence_len, &sentence_spoc, ToPhrase, 
               idx,100,FindSubject);
      goto find_subject_end;
    }

    if (has_subpron(sentence, sentence_len, idx)) {
      if (intrnl_dsply) {
       printf("suggests PronounPhrase at %d in likelihood %d\n\n",idx,100);
      }

      stc_push(sentence, sentence_len, &sentence_spoc, PronounPhrase, 
               idx,100,FindSubject);

      if (has_adjpron(sentence, sentence_len, idx)) {

      if (intrnl_dsply) {
        printf("suggests NounPhrase at %d in likelihood %d\n\n", idx, 100);
      }

        stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase, idx, 
                 100,FindSubject);
      }

      goto find_subject_end;
    }
  
    if (intrnl_dsply) {
      printf("suggests NounPhrase at %d in likelihood %d\n\n", idx, 100);
    }
    stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase, idx, 100,
             FindSubject);
    goto find_subject_end;
  }

  load_prb("FindSubject");
  set_fsub_symps(pos, num_sub, sub_pos);
  
  findsubject(100, suggest_action);
  for (i = 0; i < SUB_MAX; i++)  {
    if (suggest_action[i] != 0) {
      pos_suggested[i] = TRUE;
      stack[stack_ptr].pos = sub_pos[i];
      stack[stack_ptr].code = suggest_action[i];
      stack[stack_ptr++].lh = 100;
    }
  }

  findsubject(85, suggest_action);
  for (i = 0; i < SUB_MAX; i++)  {
    if ((suggest_action[i] != 0) AND (!pos_suggested[i])) {
      pos_suggested[i] = TRUE;
      stack[stack_ptr].pos = sub_pos[i];
      stack[stack_ptr].code = suggest_action[i];
      stack[stack_ptr++].lh = 85;
    }
  }

  findsubject(10, suggest_action);
  for (i = 0; i < SUB_MAX; i++)  {
    if ((suggest_action[i] != 0) AND (!pos_suggested[i])) {
      pos_suggested[i] = TRUE;
      stack[stack_ptr].pos = sub_pos[i];
      stack[stack_ptr].code = suggest_action[i];
      stack[stack_ptr++].lh = 10;
    }
  }
  strcpy(state, "A");
  rst_prb(name, state, type, value, errcde);

  for (i = stack_ptr-1; i >= 0; i--) {
    switch (stack[i].code) {
      case 1:                                         /* do noun subject */
              if (intrnl_dsply) {
                printf("suggests NounPhrase at %d in likelihood %d\n\n",
                        stack[i].pos, stack[i].lh);
              }
              stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase,
                       stack[i].pos, stack[i].lh, FindSubject);
              break;

      case 2:                                      /* do pronoun subject */
              if (intrnl_dsply) {
               printf("suggests PronounPhrase at %d in likelihood %d\n\n",
                       stack[i].pos, stack[i].lh);
              }
              stc_push(sentence, sentence_len, &sentence_spoc,
                       PronounPhrase,stack[i].pos,stack[i].lh,FindSubject);
              break;

      case 3:                             /* do noun and pronoun subject */
              if (intrnl_dsply) {
                printf("suggests NounPhrase and PronounPhrase at %d in likelihood %d\n\n", stack[i].pos, stack[i].lh);
              }
              stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase,
                       stack[i].pos, stack[i].lh, FindSubject);
              stc_push(sentence, sentence_len, &sentence_spoc, 
                       PronounPhrase,stack[i].pos,stack[i].lh,FindSubject);
              break;

      case 4:                                           /* do to subject */
              if (intrnl_dsply) {
                printf("suggests ToPhrase at %d in likelihood %d\n\n", 
                        stack[i].pos, stack[i].lh);
              }
              stc_push(sentence, sentence_len, &sentence_spoc, ToPhrase, 
                       stack[i].pos, stack[i].lh, FindSubject);
              break;

      default: stx_err("unexpected fsub code", __LINE__, __FILE__);
    }
  }

find_subject_end:  ;

  if (intrnl_dsply) {
    end_title("find_subject");
  }
}


/*---------------------------------------------------------------------

  findsubject  --  execute find_subject.prg at the likelihood above lhd 

    input  -- lhd:   likelihood above which find_subject.prg is executed
    output -- suggest: suggest[i] = 0 -- no action suggested on ith noun
                                    1 -- noun subject suggested
                                    2 -- pronoun subject suggested
                                    3 -- noun or pronoun subject suggested
                                    4 -- to subject suggested

----------------------------------------------------------------------*/
void findsubject(lhd, suggest)
int lhd, suggest[SUB_MAX];
{
  int    i;
  char   dgns_var[VAR_MAX + 1];
  DIAGNOSIS_ARRAY   dgns[NumofFsubDgns + 1];


  for (i = 0; i < SUB_MAX; i++) suggest[i] = 0;
  if (lhd == 100) {
    strcpy(name, "fndsub??");
    value[0] = 1;
    value[1] = 85;
    strcpy(state, "D");
    mst_cls(name, state, type, value, errcde);
    if (errcde[0] != 0) 
      stx_err("errors occur in mst_cls", __LINE__, __FILE__);
  }
  else {
    strcpy(name, "fndsub??");
    value[0] = (long) lhd;
    value[1] = (long) lhd;
    strcpy(state, "A");
    mst_cls(name, state, type, value, errcde);
    if (errcde[0] != 0) 
      stx_err("errors occur in mst_cls", __LINE__, __FILE__);
  }
  sol_prb(name, state, type, value, errcde);
  if (errcde[0] != 0)
    stx_err("errors occur in sol_prb", __LINE__, __FILE__);
  if (state[0] == 'S') { 
    copy_dgns(dgns, fndsub_dgns);
    get_dgn(dgns,name,state,type,value,errcde);
    if (value[0] == 0) return;
    i = 0;
    while (! EQUAL(dgns[i],"")) {
      strcpy(dgns_var, dgns[i++]);
      if (EQUAL(dgns_var,"do_nsub(fifth)")) { 
        suggest[4] = suggest[4] + 1; continue; 
      }
      if (EQUAL(dgns_var,"do_nsub(fourth)")) { 
        suggest[3] = suggest[3] + 1; continue; 
      }
      if (EQUAL(dgns_var,"do_nsub(third)")) {
        suggest[2] = suggest[2] + 1; continue; 
      }
      if (EQUAL(dgns_var,"do_nsub(second)")) {
        suggest[1] = suggest[1] + 1; continue; 
      }
      if (EQUAL(dgns_var,"do_nsub(first)")) {
        suggest[0] = suggest[0] + 1; continue; 
      }

      if (EQUAL(dgns_var,"do_psub(fifth)")) { 
        suggest[4] = suggest[4] + 2; continue; 
      }
      if (EQUAL(dgns_var,"do_psub(fourth)")) {
        suggest[3] = suggest[3] + 2; continue; 
      }
      if (EQUAL(dgns_var,"do_psub(third)")) { 
        suggest[2] = suggest[2] + 2; continue; 
      }
      if (EQUAL(dgns_var,"do_psub(second)")) { 
        suggest[1] = suggest[1] + 2; continue; 
      }
      if (EQUAL(dgns_var,"do_psub(first)")) { 
        suggest[0] = suggest[0] + 2; continue; 
      }

      if (EQUAL(dgns_var,"do_tsub(fifth)")) { 
        suggest[4] = suggest[4] + 4; continue; 
      }
      if (EQUAL(dgns_var,"do_tsub(fourth)")) {
        suggest[3] = suggest[3] + 4; continue; 
      }
      if (EQUAL(dgns_var,"do_tsub(third)")) { 
        suggest[2] = suggest[2] + 4; continue; 
      }
      if (EQUAL(dgns_var,"do_tsub(second)")) { 
        suggest[1] = suggest[1] + 4; continue; 
      }
      if (EQUAL(dgns_var,"do_tsub(first)")) { 
        suggest[0] = suggest[0] + 4; continue; 
      }
    }
  }
  else stx_err("problem is unsatisfied", __LINE__, __FILE__);
}




/*---------------------------------------------------------------------

  set_fsub_symps  --  set symptoms of subjects into array 'symptoms'
  
    input  -- pos: considered range is starting at 0 to pos
              num: the number of subjects
              sub_pos: the position of subjects
    output -- none

----------------------------------------------------------------------*/
void set_fsub_symps(pos, num, sub_pos)
int  pos, num, sub_pos[];
{
  int     i, j, lft, cnt, lklhds[MAXPTRNS], lh;
  char    ptrn[PTRN_PHRS_MAX+1], ptrn_names[MAXPTRNS+1][PTRN_PHRS_MAX+1];
  boolean lp_occur = FALSE, lp_noun = FALSE; 
  char    word[WORD_MAX+1];


  symptoms_idx = 0;
  for (i = 0; i < sub_pos[0]; i++) { 
    if (has_prep(sentence, sentence_len, i, &lh)) {
      lp_occur = TRUE;
      break;
    }
  }

  for (i = 0; i < num; i++) {
    cnt = sub_pos[i];
    lft = cnt - 1;

    if (has_prep(sentence, sentence_len, lft, &lh)) {
      sprintf(symptoms[symptoms_idx++], "lft_prep(%s)", position[i]);
      if (!lp_occur) lp_occur = TRUE;
    }
    if (lp_occur) 
      sprintf(symptoms[symptoms_idx++], "lp_occur(%s)", position[i]);
    if (lp_noun)
      sprintf(symptoms[symptoms_idx++], "lp_noun(%s)", position[i]);

    get_ptrn_names(sentence, sentence_len, cnt, ptrn_names, lklhds);
    j = 0;
    strcpy(ptrn, ptrn_names[j++]);
    while (!EQUAL(ptrn,"")) {
      if (Fndsub_hasptrn(ptrn)) {
        sprintf(symptoms[symptoms_idx++], "has_ptrn(%s,%s)",
                position[i], ptrn);
        if (lp_occur) lp_noun = TRUE;
      }
      strcpy(ptrn, ptrn_names[j++]);
    }

    get_word(sentence, sentence_len, cnt, word);
    if (!EQUAL(word,"")) {
      if (Fndsub_haswd(word)) {
        sprintf(symptoms[symptoms_idx++], "has_wd(%s,%s)", 
                position[i], word);
      }
    }

    if (has_adjpron(sentence, sentence_len, cnt, &lh)) {
      sprintf(symptoms[symptoms_idx++], "has_ptrn(%s,pron_adj)",
              position[i]);
      if (lp_occur) lp_noun = TRUE;
    }
    if (has_subpron(sentence, sentence_len, cnt)) {
      sprintf(symptoms[symptoms_idx++], "has_ptrn(%s,pron_sub)",
              position[i]);
      if (lp_occur) lp_noun = TRUE;
    }

    if ((!lp_occur) AND (i < (num-1))) {
      for (j = sub_pos[i]+1; j < sub_pos[i+1]; j++) { 
        if (has_prep(sentence, sentence_len, j, &lh)) {
          lp_occur = TRUE;
          break;
        }
      }
    }
  }
  strcpy(symptoms[symptoms_idx],"");

  mst_smp(symptoms, name, state, type, value, errcde);
}


/*---------------------------------------------------------------------

  Fndsub_hasptrn  --  check if the pattern is considered in the log file

    input  -- ptrn: current pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean Fndsub_hasptrn(ptrn)
char *ptrn;
{
  if ((EQUAL(ptrn,"artcl_df")) OR
      (EQUAL(ptrn,"artcl_id")) OR
      (EQUAL(ptrn,"noun_sgl")) OR
      (EQUAL(ptrn,"noun_pl"))  OR
      (EQUAL(ptrn,"vt_ing"))   OR
      (EQUAL(ptrn,"vi_ing"))   OR
      (EQUAL(ptrn,"being")))   return TRUE;

  return FALSE;
}



/*---------------------------------------------------------------------

  Fndsub_haswd  --  check if current word is considered in the log file

    input  -- word: current word to be checked
    output -- none

  function returns TRUE if word is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean Fndsub_haswd(word)
char *word;
{
  int  i, len;

  len = strlen(word);
  for (i = 0; i < len; i++) word[i] = tolower(word[i]);

  if (EQUAL(word,"t0")) return TRUE;

  return FALSE;
}

