#include "syntx.h"

#define        NumofHaveDgns    30
#define        NumofHaveNext    19

extern struct Syntx_Term *sentence; 
extern int                sentence_len;
extern struct SPOC_Pos    sentence_spoc;
extern boolean            intrnl_dsply;




DIAGNOSIS_ARRAY have_dgns[NumofHaveDgns + 1] = { 
                                                  "next(find_sub)",
                                                  "next(find_obj)",
                                                  "next(adv_phrs)",
                                                  "next(vb_phrs1)",
                                                  "next(vb_phrs2)",
                                                  "next(be_phrs1)",
                                                  "next(be_phrs2)",
                                                  "next(aux_phrs)",
                                                  "next(X_H_V)",
                                                  "next(X_H_VB1)",
                                                  "next(X_H_VB2)",
                                                  "next(X_H_B1)",
                                                  "next(X_H_B2)",
                                                  "next(pv_phrs)",
                                                  "next(PV_H_V)",
                                                  "next(PV_H_VB1)",
                                                  "next(PV_H_VB2)",
                                                  "next(PV_H_B1)",
                                                  "next(PV_H_B2)",
                                                  "cmb_rht_one",
                                                  "cmb_rht_two",
                                                  "have_ph(hs_vt)",
                                                  "have_ph(hs_vi)",
                                                  "have_ph(hs_be)",
                                                  "have_ph(hv_vt)",
                                                  "have_ph(hv_vi)",
                                                  "have_ph(hv_be)",
                                                  "have_ph(hd_vt)",
                                                  "have_ph(hd_vi)",
                                                  "have_ph(hd_be)",
                                                  "" 
                                               };   

static int        symptoms_idx;
SYMPTOM_ARRAY     symptoms[mmax(3*MAXPTRNS+2,MAXSYMP)];
  
void    have_phrase();
int     do_haveP();
boolean haveP_cntptrn();
boolean haveP_cntwd();
boolean haveP_rht1ptrn();
boolean haveP_rht2ptrn();
boolean haveP_rht1phrs();
boolean haveP_rht2phrs();
int     haveP_cmb_and_next();
void    haveP_other_next();



/*----------------------------------------------------------------------

  have_phrase  --  control the action of do_haveP

    input  -- pos:  the position where the action to be taken
              lklhd: the likelyhood at which the action will take
              who: indicate who invoke the function
    output -- none
 
-----------------------------------------------------------------------*/
void have_phrase(pos, lklhd, who)
int pos;
int lklhd;
int who;
{
  int hvP_code, have_pos;

  if (intrnl_dsply) {
    begin_title("have_phrase", pos, lklhd);
  }

  load_prb("HavePhrase");

  if ((hvP_code = do_haveP(pos, lklhd, who, &have_pos)) == 0) {
    if (intrnl_dsply) {
      printf("no have phrases can be formed\n");
    }
    goto end;
  }

  switch (hvP_code) {
    case 1:                  /* have phrase formed, next find sub or obj */
           /* predicate_pos = have_pos; */
            break;
    case 2:                              /* have phrase formed, next aux */
    case 3:                               /* suggest other actions first */
            break;

    default: stx_err("unexpected hvP_code", __LINE__, __FILE__);
  }
                    
end: 
  if (intrnl_dsply) {
    end_title("have_phrase");
  }
}


/*---------------------------------------------------------------------

  do_haveP  --  execute have_phrase.prg  

    input  -- pos: the position where the do_haveP works on
              lklhd: the likelihood the do_haveP works at
              who:   who issued have_phrase
    output -- have_pos: the position of the formed phrase

  function returns  0: no have phrase can be formed
                    1: have phrase formed, and find sub or obj next
                    2: have phrase formed, and find aux next 
                    3: suggest other actions first

----------------------------------------------------------------------*/
int do_haveP(pos, lklhd, who, have_pos)
int pos, lklhd, who, *have_pos;
{
  DIAGNOSIS_ARRAY   dgns[NumofHaveDgns + 1];
  char              dgns_var[VAR_MAX + 1],  ptrn[PTRN_PHRS_MAX+1],
                    ptrn_names[MAXPTRNS+1][PTRN_PHRS_MAX+1], phrs[9],
                    used_ptrn[3][PTRN_PHRS_MAX+1] = {"", "", ""},
                    word[WORD_MAX+1];
  int               i, cnt, rht1, rht2, lh, lklhds[MAXPTRNS],return_val=0;
  boolean           next[NumofHaveNext];

  symptoms_idx = 0;
  cnt = pos;
  rht1 = pos + 1;
  rht2 = pos + 2;
  for (i = 0; i < NumofHaveNext; i++) next[i] = FALSE;

  switch(who) {
    case FindPredicate: 
                        strcpy(symptoms[symptoms_idx++], "who(find_prd)");
                        break;
  
    case AuxPhrase: 
                        strcpy(symptoms[symptoms_idx++], "who(aux_phrs)");
                        break;

    case AdvPhrase: 
                        strcpy(symptoms[symptoms_idx++], "who(adv_phrs)");
                        break;

    case VerbPhrase: 
                        strcpy(symptoms[symptoms_idx++], "who(vb_phrs)");
                        break;

    case BePhrase: 
                        strcpy(symptoms[symptoms_idx++], "who(be_phrs)");
                        break;

    case AuxHaveAdv: 
                        strcpy(symptoms[symptoms_idx++], "who(X_H_V)");
                        break;

    case AuxHaveVerb: 
                        strcpy(symptoms[symptoms_idx++], "who(X_H_VB)");
                        break;

    case AuxHaveBe: 
                        strcpy(symptoms[symptoms_idx++], "who(X_H_B)");
                        break;

    case PronvbPhrase: 
                        strcpy(symptoms[symptoms_idx++], "who(pv_phrs)");
                        break;

    case PvHaveAdv: 
                        strcpy(symptoms[symptoms_idx++], "who(PV_H_V)");
                        break;

    case PvHaveVerb: 
                        strcpy(symptoms[symptoms_idx++], "who(PV_H_VB)");
                        break;

    case PvHaveBe: 
                        strcpy(symptoms[symptoms_idx++], "who(PV_H_B)");
                        break;

    default: stx_err("unexpected problem code", __LINE__, __FILE__);
  }


  get_ptrn_names(sentence, sentence_len, cnt, ptrn_names, lklhds);
  i = 0;
  strcpy(ptrn, ptrn_names[i++]);
  while (!EQUAL(ptrn,"")) {
    if (haveP_cntptrn(ptrn)) {
      sprintf(symptoms[symptoms_idx++], "cnt_ptn(%s)", ptrn);
      if (EQUAL(used_ptrn[0],"")) strcpy(used_ptrn[0], ptrn);
    }
    strcpy(ptrn, ptrn_names[i++]);
  }

  get_word(sentence, sentence_len, cnt, word);
  if (!EQUAL(word,"")) {
    if (haveP_cntwd(word)) {
      if (word_check(word)==0) {
        sprintf(symptoms[symptoms_idx++], "cnt_wd(%s)", word);
      } else {
        sprintf(symptoms[symptoms_idx++], "cnt_wd(%s_)", word);
      }
    }
  }

  
  get_ptrn_names(sentence, sentence_len, rht1, ptrn_names, lklhds);
  i = 0;
  strcpy(ptrn, ptrn_names[i++]);
  while (!EQUAL(ptrn,"")) {
    if (haveP_rht1ptrn(ptrn)) {
      sprintf(symptoms[symptoms_idx++], "rht1_ptn(%s)", ptrn);
      if (EQUAL(used_ptrn[1],"")) strcpy(used_ptrn[1], ptrn);
    }
    strcpy(ptrn, ptrn_names[i++]);
  }

  get_ptrn_names(sentence, sentence_len, rht2, ptrn_names, lklhds);
  i = 0;
  strcpy(ptrn, ptrn_names[i++]);
  while (!EQUAL(ptrn,"")) {
    if (haveP_rht2ptrn(ptrn)) {
      sprintf(symptoms[symptoms_idx++], "rht2_ptn(%s)", ptrn);
      if (EQUAL(used_ptrn[2],"")) strcpy(used_ptrn[2], ptrn);
    }
    strcpy(ptrn, ptrn_names[i++]);
  }


  if (haveP_rht1phrs(sentence, sentence_len, rht1, phrs)) 
    sprintf(symptoms[symptoms_idx++], "rht1_ph(%s)", phrs);

  if (haveP_rht2phrs(sentence, sentence_len, rht2, phrs)) 
    sprintf(symptoms[symptoms_idx++], "rht2_ph(%s)", phrs);


  strcpy(symptoms[symptoms_idx],"");

  mst_smp(symptoms, name, state, type, value, errcde);
  sol_prb(name, state, type, value, errcde);
  if (errcde[0] != 0) {
    stx_err("failed to solve problem", __LINE__, __FILE__);
  }

  if EQUAL(state, "S") { 
    copy_dgns(dgns, have_dgns);
    get_dgn(dgns,name,state,type,value,errcde);
    if (value[0]) {                      /* has at least one true value */
      boolean cmb_rht_one = FALSE, cmb_rht_two = FALSE;
      char    clss[MAXPHRASE][PTRN_PHRS_MAX+1]; 
      struct  Syntx_Term *stc; 
      int     stc_len;
      struct  SPOC_Pos stc_spoc;

      i = 0;
      strcpy(clss[0], used_ptrn[0]);
      strcpy(clss[1], used_ptrn[1]);
      strcpy(clss[2], used_ptrn[2]);

      while (! EQUAL(dgns[i],"")) {
        strcpy(dgns_var, dgns[i++]);

        if (EQUAL(dgns_var,"next(find_sub)")) { 
          next[0] = TRUE; 
          continue; 
        }

        if (EQUAL(dgns_var,"next(find_obj)")) { 
          next[1] = TRUE; 
          continue; 
        }

        if (EQUAL(dgns_var,"next(adv_phrs)")) { 
          next[2] = TRUE; 
          haveP_other_next(sentence, &sentence_len, &sentence_spoc,
                           cnt, next, lklhd);
          return_val = 3;
          continue; 
        }

        if (EQUAL(dgns_var,"next(vb_phrs1)")) { 
          next[3] = TRUE; 
          haveP_other_next(sentence, &sentence_len, &sentence_spoc,
                           cnt, next, lklhd);
          return_val = 3;
          continue; 
        }

        if (EQUAL(dgns_var,"next(vb_phrs2)")) { 
          next[4] = TRUE;
          haveP_other_next(sentence, &sentence_len, &sentence_spoc,
                           cnt, next, lklhd);
          return_val = 3; 
          continue; 
        }

        if (EQUAL(dgns_var,"next(be_phrs1)")) { 
          next[5] = TRUE;
          haveP_other_next(sentence, &sentence_len, &sentence_spoc,
                           cnt, next, lklhd);
          return_val = 3; 
          continue; 
        }

        if (EQUAL(dgns_var,"next(be_phrs2)")) { 
          next[6] = TRUE; 
          haveP_other_next(sentence, &sentence_len, &sentence_spoc,
                           cnt, next, lklhd);
          return_val = 3;
          continue; 
        }

        if (EQUAL(dgns_var,"next(aux_phrs)")) { 
          next[7] = TRUE; 
          continue; 
        }

        if (EQUAL(dgns_var,"next(X_H_V)")) { 
          next[8] = TRUE; 
          haveP_other_next(sentence, &sentence_len, &sentence_spoc,
                           cnt, next, lklhd);
          return_val = 3;
          continue; 
        }

        if (EQUAL(dgns_var,"next(X_H_VB1)")) { 
          next[9] = TRUE; 
          haveP_other_next(sentence, &sentence_len, &sentence_spoc,
                           cnt, next, lklhd);
          return_val = 3;
          continue; 
        }

        if (EQUAL(dgns_var,"next(X_H_VB2)")) { 
          next[10] = TRUE; 
          haveP_other_next(sentence, &sentence_len, &sentence_spoc,
                           cnt, next, lklhd);
          return_val = 3;
          continue; 
        }

        if (EQUAL(dgns_var,"next(X_H_B1)")) { 
          next[11] = TRUE; 
          haveP_other_next(sentence, &sentence_len, &sentence_spoc,
                           cnt, next, lklhd);
          return_val = 3;
          continue; 
        }

        if (EQUAL(dgns_var,"next(X_H_B2)")) { 
          next[12] = TRUE; 
          haveP_other_next(sentence, &sentence_len, &sentence_spoc,
                           cnt, next, lklhd);
          return_val = 3;
          continue; 
        }

        if (EQUAL(dgns_var,"next(pv_phrs)")) { 
          next[13] = TRUE; 
          continue; 
        }

        if (EQUAL(dgns_var,"next(PV_H_V)")) { 
          next[14] = TRUE; 
          haveP_other_next(sentence, &sentence_len, &sentence_spoc,
                           cnt, next, lklhd);
          return_val = 3;
          continue; 
        }

        if (EQUAL(dgns_var,"next(PV_H_VB1)")) { 
          next[15] = TRUE; 
          haveP_other_next(sentence, &sentence_len, &sentence_spoc,
                           cnt, next, lklhd);
          return_val = 3;
          continue; 
        }

        if (EQUAL(dgns_var,"next(PV_H_VB2)")) { 
          next[16] = TRUE; 
          haveP_other_next(sentence, &sentence_len, &sentence_spoc,
                           cnt, next, lklhd);
          return_val = 3;
          continue; 
        }

        if (EQUAL(dgns_var,"next(PV_H_B1)")) { 
          next[17] = TRUE; 
          haveP_other_next(sentence, &sentence_len, &sentence_spoc,
                           cnt, next, lklhd);
          return_val = 3;
          continue; 
        }

        if (EQUAL(dgns_var,"next(PV_H_B2)")) { 
          next[18] = TRUE; 
          haveP_other_next(sentence, &sentence_len, &sentence_spoc,
                           cnt, next, lklhd);
          return_val = 3;
          continue; 
        }

        if (EQUAL(dgns_var,"cmb_rht_one")) { 
          cmb_rht_one = TRUE; 
          continue; 
        }

        if (EQUAL(dgns_var,"cmb_rht_two")) { 
          cmb_rht_two = TRUE; 
          continue; 
        }

        if (EQUAL(dgns_var,"have_ph(hs_vt)")) { 
          stc = (struct Syntx_Term *)stc_cpy(&stc_len, &stc_spoc,
                                   sentence, sentence_len, &sentence_spoc);
          return_val = haveP_cmb_and_next(stc,&stc_len,&stc_spoc,cnt,clss, 
                      "hs_vt",lklhd, cmb_rht_one, cmb_rht_two, next, TRUE);
          stc_dsp(stc);
          continue; 
        }

        if (EQUAL(dgns_var,"have_ph(hs_vi)")) { 
          stc = (struct Syntx_Term *)stc_cpy(&stc_len, &stc_spoc,
                                   sentence, sentence_len, &sentence_spoc);
          return_val = haveP_cmb_and_next(stc,&stc_len,&stc_spoc,cnt,clss, 
                       "hs_vi",lklhd, cmb_rht_one, cmb_rht_two,next,FALSE);
          stc_dsp(stc);
          continue; 
        }
        
        if (EQUAL(dgns_var,"have_ph(hs_be)")) { 
          stc = (struct Syntx_Term *)stc_cpy(&stc_len, &stc_spoc,
                                   sentence, sentence_len, &sentence_spoc);
          return_val = haveP_cmb_and_next(stc,&stc_len,&stc_spoc,cnt,clss,
                       "hs_be",lklhd, cmb_rht_one, cmb_rht_two,next,FALSE);
          stc_dsp(stc);
          continue; 
        }

        if (EQUAL(dgns_var,"have_ph(hv_vt)")) { 
          stc = (struct Syntx_Term *)stc_cpy(&stc_len, &stc_spoc,
                                   sentence, sentence_len, &sentence_spoc);
          return_val = haveP_cmb_and_next(stc,&stc_len,&stc_spoc,cnt,clss,
                       "hv_vt", lklhd, cmb_rht_one, cmb_rht_two,next,TRUE);
          stc_dsp(stc);
          continue; 
        }

        if (EQUAL(dgns_var,"have_ph(hv_vi)")) { 
          stc = (struct Syntx_Term *)stc_cpy(&stc_len, &stc_spoc,
                                   sentence, sentence_len, &sentence_spoc);
          return_val = haveP_cmb_and_next(stc,&stc_len,&stc_spoc,cnt,clss,
                       "hv_vi", lklhd, cmb_rht_one,cmb_rht_two,next,FALSE);
          stc_dsp(stc);
          continue; 
        }
        
        if (EQUAL(dgns_var,"have_ph(hv_be)")) { 
          stc = (struct Syntx_Term *)stc_cpy(&stc_len, &stc_spoc,
                                   sentence, sentence_len, &sentence_spoc);
          return_val = haveP_cmb_and_next(stc,&stc_len,&stc_spoc,cnt,clss,
                       "hv_be", lklhd, cmb_rht_one,cmb_rht_two,next,FALSE);
          stc_dsp(stc);
          continue; 
        }

        if (EQUAL(dgns_var,"have_ph(hd_vt)")) { 
          stc = (struct Syntx_Term *)stc_cpy(&stc_len, &stc_spoc,
                                   sentence, sentence_len, &sentence_spoc);
          return_val = haveP_cmb_and_next(stc,&stc_len,&stc_spoc,cnt,clss,
                       "hd_vt", lklhd, cmb_rht_one, cmb_rht_two,next,TRUE);
          stc_dsp(stc);
          continue; 
        }

        if (EQUAL(dgns_var,"have_ph(hd_vi)")) { 
          stc = (struct Syntx_Term *)stc_cpy(&stc_len, &stc_spoc,
                                   sentence, sentence_len, &sentence_spoc);
          return_val = haveP_cmb_and_next(stc,&stc_len,&stc_spoc,cnt,clss,
                       "hd_vi", lklhd, cmb_rht_one,cmb_rht_two,next,FALSE);
          stc_dsp(stc);
          continue; 
        }
        
        if (EQUAL(dgns_var,"have_ph(hd_be)")) { 
          stc = (struct Syntx_Term *)stc_cpy(&stc_len, &stc_spoc,
                                   sentence, sentence_len, &sentence_spoc);
          return_val = haveP_cmb_and_next(stc,&stc_len,&stc_spoc,cnt,clss,
                       "hd_be", lklhd, cmb_rht_one,cmb_rht_two,next,FALSE);
          stc_dsp(stc);
          continue; 
        }
      }
  
      *have_pos = pos;
    }
  }
  else stx_err("problem is unsatisfied", __LINE__, __FILE__);

  strcpy(state, "A");
  rst_prb(name, state, type, value, errcde);
  return return_val;
}


/*---------------------------------------------------------------------

  haveP_cntptrn  --  check if the pattern is considered in the log file

    input  -- ptrn: current pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean haveP_cntptrn(ptrn)
char *ptrn;
{
  char str[3];

  str[0] = ptrn[0];
  str[1] = ptrn[1];
  str[2] = '\0';

  if (EQUAL(str,"hv")) return TRUE;
  return FALSE;
}

/*---------------------------------------------------------------------

  haveP_cntwd  --  check if current word is considered in the log file

    input  -- word: current word to be checked

  function returns TRUE if word is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean haveP_cntwd(word)
char *word;
{
  int  i, len;
  char ch;

  len = strlen(word);
  for (i = 0; i < len; i++) {
    if ((ch = word[i]) == '\'') {
      word[i] = '_';
    }
    else word[i] = tolower(ch);
  }

  if (EQUAL(word,"has")    OR
      EQUAL(word,"hasn_t"))   return TRUE; 

  return FALSE;
}

/*---------------------------------------------------------------------

  haveP_rht1ptrn  --  check if right1 pattern is considered in the log file

    input  -- ptrn: right1 pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean haveP_rht1ptrn(ptrn)
char *ptrn;
{
  if (EQUAL(ptrn,"vt_pprt")  OR
      EQUAL(ptrn,"vi_pprt")  OR
      EQUAL(ptrn,"been")     OR
      EQUAL(ptrn,"adv")      OR
      EQUAL(ptrn,"adv_er"))     return TRUE;

  return FALSE;
}

/*---------------------------------------------------------------------

  haveP_rht2ptrn  --  check if right2 pattern is considered in the log file

    input  -- ptrn: right2 pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean haveP_rht2ptrn(ptrn)
char *ptrn;
{
  if (EQUAL(ptrn,"vt_pprt")  OR
      EQUAL(ptrn,"vi_pprt")  OR
      EQUAL(ptrn,"been"))       return TRUE;

  return FALSE;
}

/*----------------------------------------------------------------------

  haveP_rht1phrs  --  check if right1 phrase is considered in the log file

    input  -- stc:  a sentence
              slen: sentence length
              idx:  token index
    output -- phrs: phrase name

   function returns TRUE if it is considered in log file, FALSE otherwise

-----------------------------------------------------------------------*/
boolean haveP_rht1phrs(stc, slen, idx, phrs)
struct Syntx_Term *stc;
int    slen;
int    idx;
char   *phrs;
{
  int  lh;
  char str[4];

  get_phrs_name(stc, slen, idx, phrs, &lh);

  if (EQUAL(phrs,"")) return FALSE;

  str[0] = phrs[0];
  str[1] = phrs[1];
  str[2] = phrs[2];
  str[3] = '\0';

  if (EQUAL(str,"bee")) return TRUE;
  if (EQUAL(phrs,"adv")     OR
      EQUAL(phrs,"adv_er")  OR
      EQUAL(phrs,"vt_pprt") OR
      EQUAL(phrs,"vi_pprt"))   return TRUE;

  return FALSE;
}


/*----------------------------------------------------------------------

  haveP_rht2phrs  --  check if right2 phrase is considered in the log file

    input  -- stc:  a sentence
              slen: sentence length
              idx:  token index
    output -- phrs: phrase name

   function returns TRUE if it is considered in log file, FALSE otherwise

-----------------------------------------------------------------------*/
boolean haveP_rht2phrs(stc, slen, idx, phrs)
struct Syntx_Term *stc;
int    slen;
int    idx;
char   *phrs;
{
  int  lh;
  char str[4];

  get_phrs_name(stc, slen, idx, phrs, &lh);

  if (EQUAL(phrs,"")) return FALSE;

  str[0] = phrs[0];
  str[1] = phrs[1];
  str[2] = phrs[2];
  str[3] = '\0';

  if (EQUAL(str,"bee")) return TRUE;
  if (EQUAL(phrs,"vt_pprt") OR
      EQUAL(phrs,"vi_pprt"))   return TRUE;

  return FALSE;
}




/*---------------------------------------------------------------------

  haveP_cmb_and_next  --  combine tokens and issue next command

    input  -- stc:    sentence
              slen:   sentence length
              spoc:   positions of SPOC
              cnt:    current position
              clss:   the classifications of the tokens to be combined
              phrase: the name of the combined phrase
              lh:     likelihood
              cmb1:   indicate combining cnt and right1
              cmb2:   indicate combining cnt, right1 and right2
              next:   indicate the next command to be executed
              vt:     indicate the phrase is a vt

    output -- function return 0: do nothing
                              1: have phrase formed, and find sub or obj 
                                 next
                              2: have phrase formed, and find aux next 
 

------------------------------------------------------------------------*/
int haveP_cmb_and_next(stc, slen, spoc, cnt, clss, phrase, lh, cmb1, cmb2, next, vt)
struct  Syntx_Term *stc; 
int     *slen;
struct  SPOC_Pos *spoc;
int     cnt;
char    clss[MAXPHRASE][PTRN_PHRS_MAX+1]; 
char    *phrase;
int     lh;
boolean cmb1;
boolean cmb2;
boolean next[NumofHaveNext];
boolean vt;
{
  
  if (!cmb1 AND !cmb2) return 0;

  if (cmb1) { 
    if (intrnl_dsply) {
      printf("%d + %d  ==>  phrase '%s'\n\n", cnt, cnt+1, phrase);
    }     
   
    cmb_token(stc, slen, spoc, cnt, cnt+1, clss, phrase, lh);
  }

  if (cmb2) { 
    if (intrnl_dsply) {
      printf("%d + %d + %d  ==>  phrase '%s'\n\n",cnt,cnt+1,cnt+2, phrase);
    }
  
    cmb_token(stc, slen, spoc, cnt, cnt+2, clss, phrase, lh);
  }

  if ((next[0]) AND !vt) {                         /* next[0] = find_sub */
    spoc->prd_pos = cnt;
    stc_push(stc, *slen, spoc, FindSubject, cnt-1, lh, HavePhrase);
    return 1;
  }

  if ((next[1]) AND vt) {                          /* next[1] = find_obj */
    spoc->prd_pos = cnt;
    stc_push(stc, *slen, spoc, FindObject, cnt+1, lh, HavePhrase);
    return 1;
  }
  
  if (next[7]) {                                   /* next[7] = aux_phrs */
    if (is_word(sentence, sentence_len, cnt-1)) { 
      stc_push(stc, *slen, spoc, AuxPhrase, cnt-1, lh, HavePhrase);
    }
    else stc_push(stc, *slen, spoc, AuxPhrase, cnt-2, lh, HavePhrase);
    return 2;
  }

  if (next[13]) {                                  /* next[13] = pv_phrs */
    if (is_word(sentence, sentence_len, cnt-1)) { 
      stc_push(stc, *slen, spoc, PronvbPhrase, cnt-1, lh, HavePhrase);
    }
    else stc_push(stc, *slen, spoc, PronvbPhrase, cnt-2, lh, HavePhrase);
    return 2;
  }
  return 0;
}

    

/*---------------------------------------------------------------------

  haveP_other_next  --  issue the next other command

    input  -- stc:    sentence
              slen:   sentence length
              spoc:   positions of SPOC
              cnt:    current position
              next:   indicate the next command to be executed
              lh:     likelihood

    output -- none

------------------------------------------------------------------------*/
void haveP_other_next(stc, slen, spoc, cnt, next, lh)
struct  Syntx_Term *stc; 
int     *slen;
struct  SPOC_Pos *spoc;
int     cnt;
boolean next[NumofHaveNext];
int     lh;
{

  if (next[2]) {                                             /* adv_phrs */
    stc_push(stc, *slen, spoc, AdvPhrase, cnt+1, lh, HavePhrase);
    next[2] = FALSE;
  }
  if (next[3]) {                                             /* vb_phrs1 */
    stc_push(stc, *slen, spoc, VerbPhrase, cnt+1, lh, HavePhrase);
    next[3] = FALSE;
  }
  if (next[4]) {                                             /* vb_phrs2 */
    stc_push(stc, *slen, spoc, VerbPhrase, cnt+2, lh, HavePhrase);
    next[4] = FALSE;
  }
  if (next[5]) {                                             /* be_phrs1 */
    stc_push(stc, *slen, spoc, BePhrase, cnt+1, lh, HavePhrase);
    next[5] = FALSE;
  }
  if (next[6]) {                                             /* be_phrs2 */
    stc_push(stc, *slen, spoc, BePhrase, cnt+2, lh, HavePhrase);
    next[6] = FALSE;
  }
  if (next[8]) {                                                /* X_H_V */
    stc_push(stc, *slen, spoc, AdvPhrase, cnt+1, lh, AuxHave);
    next[8] = FALSE;
  }
  if (next[9]) {                                              /* X_H_VB1 */
    stc_push(stc, *slen, spoc, VerbPhrase, cnt+1, lh, AuxHave);
    next[9] = FALSE;
  }
  if (next[10]) {                                             /* X_H_VB2 */
    stc_push(stc, *slen, spoc, VerbPhrase, cnt+2, lh, AuxHave);
    next[10] = FALSE;
  }
  if (next[11]) {                                              /* X_H_B1 */
    stc_push(stc, *slen, spoc, BePhrase, cnt+1, lh, AuxHave);
    next[11] = FALSE;
  }
  if (next[12]) {                                              /* X_H_B2 */
    stc_push(stc, *slen, spoc, BePhrase, cnt+2, lh, AuxHave);
    next[12] = FALSE;
  }
  if (next[14]) {                                              /* PV_H_V */
    stc_push(stc, *slen, spoc, AdvPhrase, cnt+1, lh, PvHave);
    next[14] = FALSE;
  }
  if (next[15]) {                                            /* PV_H_VB1 */
    stc_push(stc, *slen, spoc, VerbPhrase, cnt+1, lh, PvHave);
    next[15] = FALSE;
  }
  if (next[16]) {                                            /* PV_H_VB2 */
    stc_push(stc, *slen, spoc, VerbPhrase, cnt+2, lh, PvHave);
    next[16] = FALSE;
  }
  if (next[17]) {                                             /* PV_H_B1 */
    stc_push(stc, *slen, spoc, BePhrase, cnt+1, lh, PvHave);
    next[17] = FALSE;
  }
  if (next[18]) {                                             /* PV_H_B2 */
    stc_push(stc, *slen, spoc, BePhrase, cnt+2, lh, PvHave);
    next[18] = FALSE;
  }
}
