#include "syntx.h"

extern int     *original_sentence; 
extern int     original_sentence_len; 
extern int     obverr_start, obverr_end;

/**##############**/
extern int       qnterr_start, qnterr_end;
extern boolean   quant_error;
extern char      qnterr_msg[];

extern int       prnerr_start, prnerr_end;
extern boolean   sucprn_error;
extern char      prnerr_msg[];

/**##############**/

/**@@@@@@@@@7/99@@@@@@@@**/
char              pronoun_noun_msg[100];
int               pronoun_noun_start, pronoun_noun_end;
extern boolean    pronoun_noun_error;
/**@@@@@@end7/99@@@@@@@@**/

extern boolean syntx_intprt;
extern boolean syntx_giveup;
extern boolean obvious_error;
extern char    obverr_msg[];
extern boolean fatal_error;
extern boolean syntx_error;
extern int     system_status;
extern char    sentence_punc;
extern long    text_line;
extern int     *raw_sentence;  
extern int     raw_sentence_len;
extern boolean stxerr_confirmed;
extern char    text_name[];
extern boolean intrnl_dsply;
extern boolean display_syntx_msg;
extern int     stxerr_count;

extern struct  User_Word  *user_dict;
extern FILE    *syntx_msg;

extern int     Triple[4];


char    fatalerr_msg[100];
boolean try_find_error = FALSE;


void    talk_to_user();
boolean ask_user();
void    print_orgstc();
void    print_rawsentence();
void    formate_msg();
void    remind_user();




/*---------------------------------------------------------------------

  talk_to_user  --  talk to user after processing a sentence

    input  -- none
    output -- none

----------------------------------------------------------------------*/
void talk_to_user()
{
  char msg[100];  

  if (system_status == FindError) {
    if (obvious_error) {
      print_rawsentence(obverr_msg, obverr_start, obverr_end);
      if (ask_user()) save_triple(Triple);
      return;
    }
    /**#########################**/
    else     
    if (quant_error) 
      {
         print_rawsentence(qnterr_msg, qnterr_start, qnterr_end);
         if (ask_user()) save_triple(Triple);
         return;
      }
      
      else     
    if (sucprn_error) 
      {
         print_rawsentence(prnerr_msg, prnerr_start, prnerr_end);
         if (ask_user()) save_triple(Triple);
         return;
      }
      
    /**#########################**/
    
    /**@@@@@@@@@7/99@@@@@@@@**/
    else
    if (pronoun_noun_error) 
      {
       print_rawsentence(pronoun_noun_msg,pronoun_noun_start,pronoun_noun_end);
       if (ask_user()) save_triple(Triple);
       return;
      }
    /**@@@@@@end7/99@@@@@@@@**/

    else { /* no errors were found */
      if (intrnl_dsply) {
        print_orgstc();
        printf("-- no errors were found\n\n");
      }

      save_stc();
      return;
    }
  }


/* following is the case where system_status == FindIntprt */

begin:

  if (obvious_error) {
     print_rawsentence(obverr_msg, obverr_start, obverr_end);
     if (ask_user()) save_triple(Triple);
     return;
   }
 
  /**#########################**/
    if (quant_error) 
      {
         print_rawsentence(qnterr_msg, qnterr_start, qnterr_end);
         if (ask_user()) save_triple(Triple);
         return;
      }
      
       if (sucprn_error) 
      {
         print_rawsentence(prnerr_msg, prnerr_start, prnerr_end);
         if (ask_user()) save_triple(Triple);
         return;
      }
  /**#########################**/
  
   /**@@@@@@@@@7/99@@@@@@@@**/

    if (pronoun_noun_error) 
      {
       print_rawsentence(pronoun_noun_msg,pronoun_noun_start,pronoun_noun_end);
       if (ask_user()) save_triple(Triple);
       return;
      }
    /**@@@@@@end7/99@@@@@@@@**/

 
  if (fatal_error) {
    print_rawsentence(fatalerr_msg, -1, -1);
    ask_user();
    return;
  }

  if (syntx_giveup) {
    if (intrnl_dsply) {
      print_orgstc();
      printf("-- the sentence is too tough for me, I give up!\n\n");
    }
    save_stc();
    return;
  }

  if (syntx_intprt) {
    if (intrnl_dsply) {
      print_orgstc();
      printf("-- an interpretation was found\n\n");
    }
    save_stc();
    return;
  }

  if (syntx_error) {
    get_errmsg(msg);
    if (EQUAL(msg,"") AND (!try_find_error)) {
      if (intrnl_dsply) {
        print_orgstc();
        printf("-- other error was found, try to find the error\n\n");
      }
      find_errtype();
      try_find_error = TRUE;
      goto begin;
    }
    if (EQUAL(msg,"")) {
      print_rawsentence("some syntax error was found", -1, -1);
    }
    else {
      print_rawsentence(msg, -1, -1);
    }
    try_find_error = FALSE;
    ask_user();
    return;
  }

  if (intrnl_dsply) {
    print_orgstc();
    stx_err("Goofy sentence, no errors, no interpretation, and no giveup", __LINE__, __FILE__);
  }
  save_stc();

}

/*---------------------------------------------------------------------

  ask_user  --  ask user if want to accept the sentence

    input  -- none
    output -- none

  function returns TRUE if user accept the sentence, FALSE otherwise.

----------------------------------------------------------------------*/
boolean ask_user()
{
  char  ans[20], ch;
  int   i;

  if (!display_syntx_msg) return FALSE;

  printf("Accept or reject   | type 'a' to accept or 'r' to reject.\n");
  printf("sentence.          | (If 'r', user must correct sentence in %s.)\n\n", text_name);
  printf("SELECT >> ");

  scanf("%s", ans);
  ch = getchar();

check_ans:

  if ((EQUAL(ans,"a")) OR (EQUAL(ans,"A"))) {

    printf("\nAccept sentence.   | press return to confirm,");
    printf("\n                   | or type 'r' to reject.\n\n");
    printf("CONFIRM >> ");
    ch = getchar();
    while (ch == ' ') ch = getchar();
    if (ch == '\n') { save_stc(); return TRUE; }
    i = 0;
    while (ch != '\n') { ans[i++] = ch; ch = getchar(); }
    ans[i] = '\0';
    goto check_ans;
  }
  else {
    printf("\nReject sentence.   | press return to confirm,");
    printf("\n                   | or type 'a' to accept.\n\n");
    printf("CONFIRM >> ");
    ch = getchar();
    while (ch == ' ') ch = getchar();
    if (ch == '\n') { stxerr_confirmed = TRUE; return FALSE; }
    i = 0;
    while (ch != '\n') { ans[i++] = ch; ch = getchar(); }
    ans[i] = '\0';
    goto check_ans;
  }
}

/*---------------------------------------------------------------------

  print_rawsentence  --  print raw sentence

    input  -- msg:  the error message
              beg:  the begining position of the error
              end:  the end position of the error
    output -- none

----------------------------------------------------------------------*/
void print_rawsentence(msg, beg, end)
char *msg;
int  beg, end;
{
  int  i, code;
  char word[WORD_MAX+1];
  char errmsg[100];
  FILE *output;

  if (!display_syntx_msg) { output = syntx_msg; stxerr_count++; } 
  else { output = stdout; }

  fprintf(output,
       "\n\n----------------------------------------------------------\n");
  fprintf(output, "Syntax error(s) in line %d: \n\n", text_line);
  fprintf(output, "... ");
  for (i = 0; i < (raw_sentence_len-1); i++) {
    code = raw_sentence[i];
    if (code < 0) { fprintf(output, "%c", -code); }
    else {
      fprintf(output, "%s", user_dict[code].word);
    }
  }
  if ((code = raw_sentence[i]) != -10) fprintf(output, "%c", -code);
  fprintf(output, " ...\n\n");

  formate_msg(msg, errmsg);
  fprintf(output, "Error: %s   ", errmsg);
  if ((beg >= 0) AND (end >= 0)) {
    if (beg != 0) { 
      fprintf(output, "around '... "); 
    }
    else { 
      fprintf(output, "around '"); 
    }

    fprintf(output, "%s ", user_dict[original_sentence[beg]].word);
    for (i = beg+1; i < end; i++) {
      strcpy(word, user_dict[original_sentence[i]].word);
      if (EQUAL(word,"UNDEF")) { fprintf(output, "... "); }
      else { fprintf(output, "%s ", word); }
    }
    fprintf(output, "%s", user_dict[original_sentence[i]].word);

    if (end != (original_sentence_len - 1)) fprintf(output, " ...");
    fprintf(output, "'\n");
  }
  else {
    if (beg >= 0) { 
      if (beg != 0) { 
        fprintf(output, "around '... "); 
      }
      else { 
        fprintf(output, "around '"); 
      }
      fprintf(output, "%s", user_dict[original_sentence[beg]].word);
      if (beg != (original_sentence_len - 1)) fprintf(output, " ...");
      fprintf(output, "'\n");
    }
    else fprintf(output, "\n");
  }

  fprintf(output, "----------------------------------------------------------\n\n");
}
/*void print_rawsentence(msg, beg, end)
char *msg;
int  beg, end;
{
  int  i, code;
  char word[WORD_MAX+1];
  char errmsg[100];

  printf("\n\n----------------------------------------------------------\n");
  printf("Syntax error(s) in line %d: \n\n", text_line);
  printf("... ");
  for (i = 0; i < (raw_sentence_len-1); i++) {
    code = raw_sentence[i];
    if (code < 0) { printf("%c", -code); }
    else {
      printf("%s", user_dict[code].word);
    }
  }
  if ((code = raw_sentence[i]) != -10) printf("%c", -code);
  printf(" ...\n\n");

  formate_msg(msg, errmsg);
  printf("Error: %s   ", errmsg);
  if ((beg >= 0) AND (end >= 0)) {
    if (beg != 0) { 
      printf("around '... "); 
    }
    else { 
      printf("around '"); 
    }

    printf("%s ", user_dict[original_sentence[beg]].word);
    for (i = beg+1; i < end; i++) {
      strcpy(word, user_dict[original_sentence[i]].word);
      if (EQUAL(word,"UNDEF")) { printf("... "); }
      else { printf("%s ", word); }
    }
    printf("%s", user_dict[original_sentence[i]].word);

    if (end != (original_sentence_len - 1)) printf(" ...");
    printf("'\n");
  }
  else {
    if (beg >= 0) { 
      if (beg != 0) { 
        printf("around '... "); 
      }
      else { 
        printf("around '"); 
      }
      printf("%s", user_dict[original_sentence[beg]].word);
      if (beg != (original_sentence_len - 1)) printf(" ...");
      printf("'\n");
    }
    else printf("\n");
  }

  printf("----------------------------------------------------------\n\n");
}*/


/*---------------------------------------------------------------------

  print_orgstc  --  print original sentence

    input  -- none
    output -- none

----------------------------------------------------------------------*/
void print_orgstc()
{
  int  i, code;

  printf("\n\n----------------------------------------------------------\n");
  for (i = 0; i < (original_sentence_len-1); i++) {
    printf("%s ", user_dict[original_sentence[i]].word);
  }
  printf("%s%c\n", user_dict[original_sentence[i]].word, sentence_punc);
  printf("----------------------------------------------------------\n\n");
}



/*----------------------------------------------------------------------
 
  formate_msg  --  formate the error message to print out

    input  -- msg1: message to be formated
    output -- msg2: formated messgae

-----------------------------------------------------------------------*/
void formate_msg(msg1, msg2)
char *msg1, *msg2;
{
  if EQUAL(msg1,"err_dupl_word") {
    strcpy(msg2, "DUPLICATE WORD");
    return;
  }

  if EQUAL(msg1,"err_dupl_pattern") {
    strcpy(msg2, "IMPROPER WORD USAGE");
    return;
  }

  if EQUAL(msg1,"err_dupl_aux") {
    strcpy(msg2, "TOO MANY AUXILIARIES");
    return;
  }

  if EQUAL(msg1,"err_double_comp") {
    strcpy(msg2, "DOUBLE COMPARATIVES");
    return;
  }

  if EQUAL(msg1,"err_omit_word") {
    strcpy(msg2, "MISSING 'the' IN FRONT OF A SUPERLATIVE.");
    return;
  }

  if EQUAL(msg1,"err_becauseof_nomnpron") {
    strcpy(msg2, "NOMINATIVE PRONOUN AFTER 'OF'");
    return;
  }

  if (EQUAL(msg1,"err_no_prdct")       OR
      EQUAL(msg1,"err_prdct_missing"))    {
    strcpy(msg2, "MISSING PREDICATE");
    return;
  }

  if EQUAL(msg1,"err_adjpron_artcl") {
    strcpy(msg2, "ARTICLE AFTER ADJECTIVE PRONOUN");
    return;
  }

  if EQUAL(msg1,"err_artcl_nonnoun") {
    strcpy(msg2, "MISSING WORD AFTER ARTICLE");
    return;
  }

  if EQUAL(msg1,"err_artcl_pron") {
    strcpy(msg2, "PRONOUN AFTER ARTICLE");
    return;
  }

  if EQUAL(msg1,"err_either_neither") {
    strcpy(msg2, "INCORRECT USE OF (N)EITHER ... (N)OR ...");
    return;
  }

  if EQUAL(msg1,"err_whom_who") {
    strcpy(msg2, "INCORRECT USE OF WHO (WHOM)");
    return;
  }

  if EQUAL(msg1,"err_its") {
    strcpy(msg2, "'its' ('it's') IS USED AS 'it's' ('its')");
    return;
  }

  if EQUAL(msg1,"err_prep") {
    strcpy(msg2, "INCORRECT USE OF PREPOSITION");
    return;
  }

  if (EQUAL(msg1,"err_there_is")          OR
      EQUAL(msg1,"err_subprdct_disagree") OR
      EQUAL(msg1,"err_compl_disagree")    OR
      EQUAL(msg1,"err_sub_disagree_prdct"))      {
    strcpy(msg2, "SUBJECT DISAGREES WITH PREDICATE");
    return;
  }

  if EQUAL(msg1,"err_quantity") {
    strcpy(msg2, "INCORRECT USE OF QUANTITATIVE MODIFIER");
    return;
  }

  if EQUAL(msg1,"err_a_an") {
    strcpy(msg2, "'a' ('an') USED AS 'an' ('a')");
    return;
  }

  if (EQUAL(msg1,"err_vi_obj")     OR
      EQUAL(msg1,"err_vi_object"))    {
    strcpy(msg2, "INTRANSITIVE PREDICATE HAS AN OBJECT");
    return;
  }

  if EQUAL(msg1,"err_tophrase") {
    strcpy(msg2, "WRONG WORD AFTER 'to'");
    return;
  }

  if EQUAL(msg1,"err_be_complement") {
    strcpy(msg2, "IMPROPER USE OF ADVERB");
    return;
  }

  if (EQUAL(msg1,"err_have_tense")    OR
      EQUAL(msg1,"err_do_tense")      OR
      EQUAL(msg1,"err_verb_tense")    OR
      EQUAL(msg1,"err_wrong_vbtense"))   {
    strcpy(msg2, "WRONG VERB TENSE");
    return;
  }

  if EQUAL(msg1,"err_aux_tense") {
    strcpy(msg2, "WRONG AUXILIARY TENSE");
    return;
  }

  if EQUAL(msg1,"err_prep_as_conj") {
    strcpy(msg2, "PREPOSITION USED AS A CONJUNCTION");
    return;
  }

  if EQUAL(msg1,"err_cmb_sub") {
    strcpy(msg2, "WRONG PRONOUN CASE");
    return;
  }

  if EQUAL(msg1,"err_double_negative") {
    strcpy(msg2, "DOUBLE NEGATIVES");
    return;
  }

  if EQUAL(msg1,"err_redundancies") {
    strcpy(msg2, "REDUNDANCIES");
    return;
  }

  if EQUAL(msg1,"err_wrong_comp") {
    strcpy(msg2, "IMPROPER COMPARISON");
    return;
  }

  if EQUAL(msg1,"err_double_prep") {
    strcpy(msg2, "TOO MANY PREPOSITIONS");
    return;
  }

  if EQUAL(msg1,"err_misc") {
    strcpy(msg2, "IMPROPER PHRASE");
    return;
  }

  if (EQUAL(msg1,"err_obj_missing")     OR
      EQUAL(msg1,"err_object_missing"))    {
    strcpy(msg2, "MISSING OBJECT");
    return;
  }

  if EQUAL(msg1,"err_double_sub") {
    strcpy(msg2, "TOO MANY SUBJECTS");
    return;
  }

  if EQUAL(msg1,"err_double_compl") {
    strcpy(msg2, "TOO MANY COMPLEMENTS");
    return;
  }

  if EQUAL(msg1,"err_compl_missing") {
    strcpy(msg2, "MISSING COMPLEMENT");
    return;
  }

  if EQUAL(msg1,"err_be_objpron") {
    strcpy(msg2, "IMPROPER PRONOUN");
    return;
  }

  if EQUAL(msg1,"err_subject_missing") {
    strcpy(msg2, "MISSING SUBJECT");
    return;
  }

  if EQUAL(msg1,"err_sub_prdct_obj_disorder") {
    strcpy(msg2, "IMPROPER ORDER OF SUBJECT, PREDICATE, AND OBJECT");
    return;
  }
  
 /**##########################**/
 if EQUAL(msg1,"qntfr_dtrmnr") {
    strcpy(msg2, "SUCCESSIVE DETERMINERS OR QUANTIFIERS");
    return;
  }
  
  if EQUAL(msg1,"succ_pronoun") {
    strcpy(msg2, "SUCCESSIVE PRONOUNS");
    return;
  }
 /**##########################**/

 /**@@@@@@@@@7/99@@@@@@@@**/
 if EQUAL(msg1,"err_pronoun_noun") {
    strcpy(msg2, "PRONOUN [ADJECTIVE/ADVERB] NOUN ");
    return;
  }

 /**@@@@@@end7/99@@@@@@@@**/

 
  strcpy(msg2, msg1);
}



/*--------------------------------------------------------------------

  remind_user  --  tell user the text is syntactical correct, or remind
                   user to correct the syntax errors.

    input  -- none
    output -- none

----------------------------------------------------------------------*/
void remind_user()
{
  char cmd[130];

  if ((!display_syntx_msg) AND
      (stxerr_count > 0))     {
    printf("\n\n\nSyntax error(s) has been found. \n");
    printf("Correct the error(s), and do Spell Checking again!\n");
    goto mv;
  }
    
  if (stxerr_confirmed) {
    printf("\n\n\nSyntax error(s) has been confirmed. \n");
    printf("Correct the error(s), and do Spell Checking again!\n");
  }
  else {
    printf("\n\nNo syntax error has been found\n");
  }
  
mv:

  sprintf(cmd, "mv -f %s.stx %s.sem", text_name, text_name);
  system(cmd);
  printf("\n\nUpdating files ... DO NOT ABORT!\n\n");
}

    






