/*-----------------------------------------------------
* macro.h
* Copyright 1994 by Leibniz
*
* Header file for macro.c.
*
* CAUTION: This libray is compatible ONLY with
*          Version 4.0 or later
*
-----------------------------------------------------*/

/*-----------------------------------------------------
* Remove comments to activate debug option.
* i.e. define DEBUG
-----------------------------------------------------*/
/*#define DEBUG*/

/*-----------------------------------------------------
* Array of clause names.
-----------------------------------------------------*/
typedef struct {
    char  name[58+1];
    short status;
} CLAUSE_ARRAY;


/*-----------------------------------------------------
* Array of symptomatic names.
-----------------------------------------------------*/
typedef char SYMPTOM_ARRAY[58+1];

/*-----------------------------------------------------
* Array of diagnostic names.
-----------------------------------------------------*/
typedef char DIAGNOSIS_ARRAY[58+1];

/*-----------------------------------------------------
* Array of .prg file names.
-----------------------------------------------------*/
typedef char PRGNAME_ARRAY[256+1];



/*-----------------------------------------------------
* Hash table structure.
-----------------------------------------------------*/
# define HASHSIZE 1001

struct nlist {
    struct nlist *next;
    char *name;
    short index;
};




/*-----------------------------------------------------------
  table structure for .prg file name and hash table address
-------------------------------------------------------------*/

struct prg_hash {
  char            *prg_name;
  struct nlist    *hash_table[HASHSIZE];
  struct prg_hash *next;
};

/*-----------------------------------------------------
* List of all functions in macro.c
-----------------------------------------------------*/
void asg_dev();
void asg_smp();
void beg_prb();
void del_prb();
void get_cgn();
void get_dgn();
void get_dim();
void get_gol();
void get_pml();
void get_val();
void inz_prb();
void max_sat();
void min_unsat();
void mst_cls();
void mst_gol();
void mst_prb();
void mst_var();
void ret_prb();
void rst_prb();
void sol_prb();
void sto_prb();
void sts_cls();
void sts_prb();
void sts_sto();
void sts_var();
void var_idx();

/*-----------------------------------------------------
* Functions below for internal use only.
-----------------------------------------------------*/
int           dup_hshtbl();
unsigned      hash();
int           has_wildcard();
struct nlist *install();
void          load_hshtbl();
struct nlist *lookup();
void          mac_err();
void          mke_hst();
void          num_var();
void          reset_hashtable();
void          store_hshtbl();
void          store_reset_hshtbl();

/*----------------------------------------------------*/
/**last record of macro.h******************************/
