#include "syntx.h"

#define        NumofNounDgns    23
#define        NumofNounNext    16

extern struct Syntx_Term *sentence; 
extern int                sentence_len;
extern struct SPOC_Pos    sentence_spoc;
extern boolean            intrnl_dsply;



DIAGNOSIS_ARRAY noun_dgns[NumofNounDgns + 1] = { 
                                                 "cmb_lft",
                                                 "cmb_rht",
                                                 "next(find_mdf)",
                                                 "next(find_sub)",
                                                 "next(prep_prs)",
                                                 "next(S_N_A)",
                                                 "next(O_N_A)",
                                                 "next(M_N_A)",
                                                 "next(P_N_A)",
                                                 "next(S_N_A_N)",
                                                 "next(O_N_A_N)",
                                                 "next(M_N_A_N)",
                                                 "next(P_N_A_N)",
                                                 "next(SNANN)",
                                                 "next(ONANN)",
                                                 "next(MNANN)",
                                                 "next(PNANN)",
                                                 "next(cont_mdf)",
                                                 "is_phrs(noun_sgl)",
                                                 "is_phrs(noun_pl)",
                                                 "is_phrs(vt_ing)",
                                                 "is_phrs(vi_ing)",
                                                 "is_phrs(being)",
                                                 "" 
                                               };   


static int        symptoms_idx;
SYMPTOM_ARRAY     symptoms[mmax(3*MAXPTRNS+3,MAXSYMP)];
  
void    noun_phrase();
int     do_nounP();

boolean nounP_lftptrn();
boolean nounP_cntptrn();
boolean nounP_rhtptrn();

boolean nounP_lftphrs();
boolean nounP_rhtphrs();


/*----------------------------------------------------------------------

  noun_phrase  --  control the action of do_nounP

    input  -- pos:  the position where the action to be taken
              lklhd: the likelyhood at which the action will take
              who: indicate who invoke the function    
    output -- none
 
-----------------------------------------------------------------------*/
void noun_phrase(pos, lklhd, who)
int pos;
int lklhd;
int who;
{
  int  nounP_code, nounpos, old_nounpos, i, slen_bak;
  boolean next[NumofNounNext];
  struct Syntx_Term *stc_bak;
  struct SPOC_Pos    spoc_bak;

  if (intrnl_dsply) {
    begin_title("noun_phrase", pos, lklhd);
  }

  load_prb("NounPhrase");

  stc_bak = (struct Syntx_Term *)stc_cpy(&slen_bak, &spoc_bak, 
                                   sentence, sentence_len, &sentence_spoc);

  
  if ((nounP_code = do_nounP(pos, lklhd, who, &nounpos, next)) == 0) {
    if (intrnl_dsply) {
      printf("no noun phrases can be formed\n");
    }
    goto end_noun_phrase;
  }




  switch(nounP_code) {
    case 2:                                  /* noun_pl phrase is formed */
    case 3:                                   /* vt_ing phrase is formed */
    case 4:                                   /* vi_ing phrase is formed */
    case 5:                                    /* being phrase is formed */
    case 6:           /* no phrases are formed, but suggests some action */
            break;

    case 1:                                 /* noun_sgl phrase is formed */

            old_nounpos = nounpos;
            break;

    default: stx_err("unexpected code by do_nounP", __LINE__, __FILE__);
  }

save_next:

  if (next[3]) {                                        /* next(S_N_A) */
    stc_push(stc_bak, slen_bak, &spoc_bak, AdjPhrase,pos+1,lklhd, SubNoun);
  }

  if (next[4]) {                                        /* next(O_N_A) */
    stc_push(stc_bak, slen_bak, &spoc_bak, AdjPhrase,pos+1,lklhd, ObjNoun);
  }

  if (next[12]) {                                        /* next(M_N_A) */
    stc_push(stc_bak, slen_bak, &spoc_bak, AdjPhrase,pos+1,lklhd, MdfNoun);
  }

  if (next[5]) {                                       /* next(P_N_A) */
    stc_push(stc_bak, slen_bak, &spoc_bak, AdjPhrase,pos+1,lklhd,PrepNoun);
  }

  if (next[6]) {                                        /* next(S_N_A_N) */
    stc_push(stc_bak,slen_bak,&spoc_bak,NounPhrase,pos+2,lklhd,SubNounAdj);
  }

  if (next[7]) {                                        /* next(O_N_A_N) */
    stc_push(stc_bak,slen_bak,&spoc_bak,NounPhrase,pos+2,lklhd,ObjNounAdj);
  }

  if (next[13]) {                                      /* next(M_N_A_N) */
    stc_push(stc_bak,slen_bak,&spoc_bak,NounPhrase,pos+2,lklhd,MdfNounAdj);
  }
  
  if (next[8]) {                                       /* next(P_N_A_N) */
    stc_push(stc_bak, slen_bak, &spoc_bak, NounPhrase, pos+2, lklhd, 
             PrepNounAdj);
  }

  if (next[9]) {                                       /* next(SNANN) */
    stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase, 
             nounpos-1, lklhd, SubNounAdjNoun);
  }

  if (next[10]) {                                      /* next(ONANN) */
    stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase, 
             nounpos-1, lklhd, ObjNounAdjNoun);
  }

  if (next[14]) {                                      /* next(MNANN) */
    stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase, 
             nounpos-1, lklhd, MdfNounAdjNoun);
  }

  if (next[11]) {                                      /* next(PNANN) */
    stc_push(sentence, sentence_len, &sentence_spoc, NounPhrase, 
             nounpos-1, lklhd, PrepNounAdjNoun);
  }

  if (next[0]) {                                       /* next(find_mdf) */
    sentence_spoc.sub_pos = nounpos;
    stc_push(sentence, sentence_len, &sentence_spoc, FindModifier, 0,
             lklhd, NounPhrase);
  }

  if (next[1]) {                                       /* next(find_sub) */
    sentence_spoc.obj_pos = nounpos;
    stc_push(sentence,sentence_len,&sentence_spoc, FindSubject, 
             sentence_spoc.prd_pos-1,lklhd, NounPhrase);
  }

  if (next[2]) {                                       /* next(prep_prs) */
    stc_push(sentence,sentence_len,&sentence_spoc, 
             PrepPhrase,nounpos-1,lklhd, NounPhrase);
  }

  if (next[15]) {                                      /* next(cont_mdf) */
    stc_push(sentence, sentence_len, &sentence_spoc, FindModifier, 
             nounpos+1, lklhd, NounPhrase);
  }

  if (nounP_code == 1) {                    /* noun_sgl phrase is formed */

    nounP_code=do_nounP(old_nounpos+1,lklhd,who,&nounpos,next);
    if ((nounP_code != 0) AND (nounP_code != 6)) {
      old_nounpos = nounpos;
      goto save_next;
    }
  }
      
end_noun_phrase:
  stc_dsp(stc_bak);
  if (intrnl_dsply) {
    end_title("noun_phrase");
  }
}


/*---------------------------------------------------------------------

  do_nounP  --  execute noun_phrase.prg  

    input  -- pos: the position where the do_nounP works on
              lklhd: the likelihood at which do_nounP works 
              who:   who issued noun_phrase
    output -- nounpos: the position of the formed phrase
              next:     suggested next action
                next[0]  = TRUE --> find_mdf
                next[1]  = TRUE --> find_sub
                next[2]  = TRUE --> prep_prs
                next[3]  = TRUE --> S_N_A
                next[4]  = TRUE --> O_N_A
                next[5]  = TRUE --> P_N_A
                next[6]  = TRUE --> S_N_A_N
                next[7]  = TRUE --> O_N_A_N
                next[8]  = TRUE --> P_N_A_N
                next[9]  = TRUE --> SNANN
                next[10] = TRUE --> ONANN
                next[11] = TRUE --> PNANN
                next[12] = TRUE --> M_N_A
                next[13] = TRUE --> M_N_A_N
                next[14] = TRUE --> MNANN
                next[15] = TRUE --> cont_mdf


  function returns 0: no noun phrase can be formed
                   1: noun_sgl phrase is formed
                   2: noun_pl phrase is formed
                   3: vt_ing phrase is formed
                   4: vi_ing phrase is formed
                   5: being phrase is formed
                   6: no phrases are formed, but suggests some action

----------------------------------------------------------------------*/
int do_nounP(pos, lklhd, who, nounpos, next)
int pos, lklhd, who, *nounpos;
boolean next[NumofNounNext];
{
  DIAGNOSIS_ARRAY   dgns[NumofNounDgns + 1];
  char              dgns_var[VAR_MAX + 1],  ptrn[PTRN_PHRS_MAX+1],
                    ptrn_names[MAXPTRNS+1][PTRN_PHRS_MAX+1],
                    used_ptrn[3][PTRN_PHRS_MAX+1] = {"", "", ""};
  int               i, lft, rht, cnt, lh, lklhds[MAXPTRNS], return_val;
  boolean           find_mdf = FALSE, find_sub = FALSE, prep_prs = FALSE,
                    S_N_A = FALSE, O_N_A = FALSE, P_N_A = FALSE,
                    S_N_A_N = FALSE, O_N_A_N = FALSE, P_N_A_N = FALSE,
                    SNANN = FALSE, ONANN = FALSE, PNANN = FALSE,
                    M_N_A = FALSE, M_N_A_N = FALSE, MNANN = FALSE,
                    cont_mdf = FALSE;


  if ((pos < 0) OR (pos >= sentence_len)) return 0;

  symptoms_idx = 0;
  cnt = pos;
  lft = pos - 1;
  rht = pos + 1;

  switch(who) {
    case FindSubject: 
                        strcpy(symptoms[symptoms_idx++], "who(find_sub)");
                        break;
  
    case FindObject: 
                        strcpy(symptoms[symptoms_idx++], "who(find_obj)");
                        break;

    case FindModifier: 
                        strcpy(symptoms[symptoms_idx++], "who(find_mdf)");
                        break;

    case PrepPhrase: 
                        strcpy(symptoms[symptoms_idx++], "who(prep_prs)");
                        break;
  
    case PrepAdj:       strcpy(symptoms[symptoms_idx++], "who(P_A)");
                        break;
  
    case SubNounAdj:  
                        strcpy(symptoms[symptoms_idx++], "who(S_N_A)");
                        break;

    case ObjNounAdj:  
                        strcpy(symptoms[symptoms_idx++], "who(O_N_A)");
                        break;

    case MdfNounAdj:  
                        strcpy(symptoms[symptoms_idx++], "who(M_N_A)");
                        break;

    case PrepNounAdj:  
                        strcpy(symptoms[symptoms_idx++], "who(P_N_A)");
                        break;

    case SubNounAdjNoun: 
                        strcpy(symptoms[symptoms_idx++], "who(S_N_A_N)");
                        break;

    case ObjNounAdjNoun: 
                        strcpy(symptoms[symptoms_idx++], "who(O_N_A_N)");
                        break;

    case MdfNounAdjNoun: 
                        strcpy(symptoms[symptoms_idx++], "who(M_N_A_N)");
                        break;

    case PrepNounAdjNoun: 
                        strcpy(symptoms[symptoms_idx++], "who(P_N_A_N)");
                        break;

    default: stx_err("unexpected problem code", __LINE__, __FILE__);
  }

  if (is_word(sentence, sentence_len, lft)) {
    get_ptrn_names(sentence, sentence_len, lft, ptrn_names, lklhds);
    i = 0;
    strcpy(ptrn, ptrn_names[i++]);
    while (!EQUAL(ptrn,"")) {
      if (nounP_lftptrn(ptrn)) {
        sprintf(symptoms[symptoms_idx++], "lft_ptrn(%s)", ptrn);
        if (EQUAL(used_ptrn[0],"")) strcpy(used_ptrn[0], ptrn);
      }
      strcpy(ptrn, ptrn_names[i++]);
    }
  }
  else {
    char lft_phrs[PTRN_PHRS_MAX+11];

    if ((lft != sentence_spoc.sub_pos) AND (lft != sentence_spoc.obj_pos))
    {
      if (nounP_lftphrs(sentence, sentence_len, lft, lft_phrs))  
        sprintf(symptoms[symptoms_idx++], lft_phrs);
    }
  }


  get_ptrn_names(sentence, sentence_len, cnt, ptrn_names, lklhds);
  i = 0;
  strcpy(ptrn, ptrn_names[i++]);
  while (!EQUAL(ptrn,"")) {
    if (nounP_cntptrn(ptrn)) {
      sprintf(symptoms[symptoms_idx++], "cnt_ptrn(%s)", ptrn);
      if (EQUAL(used_ptrn[1],"")) strcpy(used_ptrn[1], ptrn);
    }
    strcpy(ptrn, ptrn_names[i++]);
  }
  if (has_adjpron(sentence, sentence_len, cnt, &lh)) {
    sprintf(symptoms[symptoms_idx++], "cnt_ptrn(pron_adj)");
    strcpy(used_ptrn[1], "pron_adj");
  }


  if (is_word(sentence, sentence_len, rht)) {
    get_ptrn_names(sentence, sentence_len, rht, ptrn_names, lklhds);
    i = 0;
    strcpy(ptrn, ptrn_names[i++]);
    while (!EQUAL(ptrn,"")) {
      if (nounP_rhtptrn(ptrn)) {
        sprintf(symptoms[symptoms_idx++], "rht_ptrn(%s)", ptrn);
        if (EQUAL(used_ptrn[2],"")) strcpy(used_ptrn[2], ptrn);
      }
      strcpy(ptrn, ptrn_names[i++]);
    }
  }
  else {
    char rht_phrs[PTRN_PHRS_MAX+11];
    boolean lftstop;

    if ((rht != sentence_spoc.sub_pos) AND (rht != sentence_spoc.obj_pos))
    {
      if (nounP_rhtphrs(sentence, sentence_len, rht, rht_phrs,&lftstop)) { 
        sprintf(symptoms[symptoms_idx++], rht_phrs);
        if (lftstop) sprintf(symptoms[symptoms_idx++], "rht_lftstop");
      }
    }
  }
  strcpy(symptoms[symptoms_idx],"");


  mst_smp(symptoms, name, state, type, value, errcde);
  sol_prb(name, state, type, value, errcde);
  if (errcde[0] != 0) {
    stx_err("failed to solve problem", __LINE__, __FILE__);
  }

  if EQUAL(state, "S") { 
    copy_dgns(dgns, noun_dgns);
    get_dgn(dgns,name,state,type,value,errcde);
    if (value[0]) {                      /* has at least one true value */
      boolean cmb_lft = FALSE, cmb_rht = FALSE, has_next = FALSE;
      char    phrase_name[PTRN_PHRS_MAX+1] = "";
      char    clss[MAXPHRASE][PTRN_PHRS_MAX+1]; 

      i = 0;
      while (! EQUAL(dgns[i],"")) {
        strcpy(dgns_var, dgns[i++]);

        if (EQUAL(dgns_var,"cmb_lft")) { cmb_lft = TRUE; continue; }
        if (EQUAL(dgns_var,"cmb_rht")) { cmb_rht = TRUE; continue; }

        if (EQUAL(dgns_var,"next(find_mdf)")) { 
          find_mdf = TRUE;
          has_next = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(find_sub)")) { 
          find_sub = TRUE;
          has_next = TRUE;  
          continue; 
        }
        if (EQUAL(dgns_var,"next(prep_prs)")) { 
          prep_prs = TRUE;
          has_next = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(S_N_A)")) { 
          S_N_A = TRUE;
          has_next = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(O_N_A)")) { 
          O_N_A = TRUE;
          has_next = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(M_N_A)")) { 
          M_N_A = TRUE;
          has_next = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(P_N_A)")) { 
          P_N_A = TRUE;
          has_next = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(S_N_A_N)")) { 
          S_N_A_N = TRUE;
          has_next = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(O_N_A_N)")) { 
          O_N_A_N = TRUE;
          has_next = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(M_N_A_N)")) { 
          M_N_A_N = TRUE;
          has_next = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(P_N_A_N)")) { 
          P_N_A_N = TRUE;
          has_next = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(SNANN)")) { 
          SNANN = TRUE;
          has_next = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(ONANN)")) { 
          ONANN = TRUE;
          has_next = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(MNANN)")) { 
          MNANN = TRUE;
          has_next = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(PNANN)")) { 
          PNANN = TRUE;
          has_next = TRUE; 
          continue; 
        }
        if (EQUAL(dgns_var,"next(cont_mdf)")) { 
          cont_mdf = TRUE;
          has_next = TRUE; 
          continue; 
        }

        if (EQUAL(dgns_var,"is_phrs(noun_sgl)")) { 
          strcpy(phrase_name, "noun_sgl");
          return_val = 1;
          continue;
        }
        if (EQUAL(dgns_var,"is_phrs(noun_pl)")) { 
          strcpy(phrase_name, "noun_pl");
          return_val = 2;
          continue;
        }
        if (EQUAL(dgns_var,"is_phrs(vt_ing)")) { 
          strcpy(phrase_name, "vt_ing");
          return_val = 3;
          continue;
        }
        if (EQUAL(dgns_var,"is_phrs(vi_ing)")) { 
          strcpy(phrase_name, "vi_ing");
          return_val = 4;
          continue;
        }
        if (EQUAL(dgns_var,"is_phrs(being)")) { 
          strcpy(phrase_name, "being");
          return_val = 5;
          continue;
        }
      }
      if (EQUAL(phrase_name,"")) { 
        if (has_next) { return_val = 6; }
        else { return_val = 0; }
        goto endof_donounP; 
      }
  
      *nounpos = pos;
      if ((!cmb_lft) AND (!cmb_rht)) {
        if (intrnl_dsply) {
          printf("%d ==>  phrase '%s'\n\n", cnt, phrase_name);
        }     
        strcpy(clss[0], phrase_name);
        cmb_token(sentence, &sentence_len, &sentence_spoc, cnt, cnt, clss, 
                  phrase_name, lklhd);
        goto endof_donounP;
      }

      if ((cmb_lft) AND (cmb_rht)){ 
        if (intrnl_dsply) {
          printf("%d + %d + %d  ==>  phrase '%s'\n\n", lft, cnt, rht, 
                 phrase_name);
        }
        strcpy(clss[0], used_ptrn[0]);
        strcpy(clss[1], used_ptrn[1]);
        strcpy(clss[2], phrase_name);
        cmb_token(sentence, &sentence_len, &sentence_spoc, lft, rht, clss,
                  phrase_name, lklhd);
        *nounpos = *nounpos - 1;
        goto endof_donounP;
      }
      if (cmb_lft) { 
        if (intrnl_dsply) {
          printf("%d + %d  ==>  phrase '%s'\n\n", lft, cnt, phrase_name);
        }    
        strcpy(clss[0], used_ptrn[0]);
        strcpy(clss[1], phrase_name);
        cmb_token(sentence, &sentence_len, &sentence_spoc, lft, cnt, clss, 
                  phrase_name, lklhd);
        *nounpos = *nounpos - 1;
        goto endof_donounP;
      }
      if (cmb_rht) { 
        if (intrnl_dsply) {
          printf("%d + %d  ==>  phrase '%s'\n\n", cnt, rht, phrase_name);
        }
        strcpy(clss[0], used_ptrn[1]);
        strcpy(clss[1], phrase_name);
        cmb_token(sentence, &sentence_len, &sentence_spoc, cnt, rht, clss, 
                  phrase_name, lklhd);
      }
      goto endof_donounP;
    }
  }
  else stx_err("problem is unsatisfied", __LINE__, __FILE__);
  
  return_val = 0;

endof_donounP:

  next[0] = find_mdf;
  next[1] = find_sub;
  next[2] = prep_prs;
  next[3] = S_N_A;
  next[4] = O_N_A;
  next[5] = P_N_A;
  next[6] = S_N_A_N;
  next[7] = O_N_A_N;
  next[8] = P_N_A_N;
  next[9] = SNANN;
  next[10] = ONANN;
  next[11] = PNANN;
  next[12] = M_N_A;
  next[13] = M_N_A_N;
  next[14] = MNANN;
  next[15] = cont_mdf;

  strcpy(state, "A");
  rst_prb(name, state, type, value, errcde);
  return return_val;
}

/*---------------------------------------------------------------------

  nounP_lftptrn  --  check if left pattern is considered in the log file

    input  -- ptrn: left pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean nounP_lftptrn(ptrn)
char *ptrn;
{
  if ((EQUAL(ptrn,"adj"))      OR
      (EQUAL(ptrn,"adj_er"))   OR
      (EQUAL(ptrn,"noun_sgl")) OR
      (EQUAL(ptrn,"vt_pprt"))  OR
      (EQUAL(ptrn,"vi_pprt"))  OR
      (EQUAL(ptrn,"vt_ing"))   OR
      (EQUAL(ptrn,"vi_ing")))     return TRUE;

  return FALSE;
}

/*---------------------------------------------------------------------

  nounP_cntptrn  --  check if the pattern is considered in the log file

    input  -- ptrn: current pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean nounP_cntptrn(ptrn)
char *ptrn;
{
  if ((EQUAL(ptrn,"artcl_df")) OR
      (EQUAL(ptrn,"artcl_id")) OR
      (EQUAL(ptrn,"noun_sgl")) OR
      (EQUAL(ptrn,"noun_pl"))  OR
      (EQUAL(ptrn,"vt_ing"))   OR
      (EQUAL(ptrn,"vi_ing"))   OR
      (EQUAL(ptrn,"being")))   return TRUE;

  return FALSE;
}

/*---------------------------------------------------------------------

  nounP_rhtptrn  --  check if right pattern is considered in the log file

    input  -- ptrn: right pattern name to be checked
    output -- none

  function returns TRUE if ptrn is considered in log file, FALSE otherwise

------------------------------------------------------------------------*/
boolean nounP_rhtptrn(ptrn)
char *ptrn;
{
  if ((EQUAL(ptrn,"adj"))      OR
      (EQUAL(ptrn,"adj_er"))   OR
      (EQUAL(ptrn,"adv"))      OR
      (EQUAL(ptrn,"vt_pprt"))  OR
      (EQUAL(ptrn,"vi_pprt"))  OR
      (EQUAL(ptrn,"vt_ing"))   OR
      (EQUAL(ptrn,"vi_ing"))   OR
      (EQUAL(ptrn,"being"))    OR
      (EQUAL(ptrn,"noun_sgl")) OR
      (EQUAL(ptrn,"noun_pl")))    return TRUE;

  return FALSE;
}


/*----------------------------------------------------------------------

  nounP_lftphrs  --  check if left phrase is considered in the log file

    input  -- stc:  a sentence
              slen: sentence length
              idx:  token index
    output -- lft_phrs: "lft_phrs(XXX)"

   function returns TRUE if it is considered in log file, FALSE otherwise

-----------------------------------------------------------------------*/
boolean nounP_lftphrs(stc, slen, idx, lft_phrs)
struct Syntx_Term *stc;
int    slen;
int    idx;
char   *lft_phrs;
{
  int  lh;


  if (has_phrase(stc, slen, idx, "noun_sgl", &lh)) {
    sprintf(lft_phrs, "lft_phrs(noun_sgl)");
    return TRUE;
  }
  if (has_phrase(stc, slen, idx, "adj", &lh)) {
    sprintf(lft_phrs, "lft_phrs(adj)");
    return TRUE;
  }
  if (has_phrase(stc, slen, idx, "adj_er", &lh)) {
    sprintf(lft_phrs, "lft_phrs(adj_er)");
    return TRUE;
  }
  if (has_phrase(stc, slen, idx, "adj_est", &lh)) {
    sprintf(lft_phrs, "lft_phrs(adj_est)");
    return TRUE;
  }
  if (has_phrase(stc, slen, idx, "vt_ing", &lh)) {
    sprintf(lft_phrs, "lft_phrs(vt_ing)");
    return TRUE;
  }
  if (has_phrase(stc, slen, idx, "vi_ing", &lh)) {
    sprintf(lft_phrs, "lft_phrs(vi_ing)");
    return TRUE;
  }
  if (has_phrase(stc, slen, idx, "vt_pprt", &lh)) {
    sprintf(lft_phrs, "lft_phrs(vt_pprt)");
    return TRUE;
  }
  if (has_phrase(stc, slen, idx, "vi_pprt", &lh)) {
    sprintf(lft_phrs, "lft_phrs(vi_pprt)");
    return TRUE;
  }
  return FALSE;

}


/*----------------------------------------------------------------------

  nounP_rhtphrs  --  check if right phrase is considered in the log file

    input  -- stc:  a sentence
              slen: sentence length
              idx:  token index
    output -- rht_phrs: "rht_phrs(XXX)"
              lftstop: indicate if the phrase is left stop

   function returns TRUE if it is considered in log file, FALSE otherwise

-----------------------------------------------------------------------*/
boolean nounP_rhtphrs(stc, slen, idx, rht_phrs, lftstop)
struct Syntx_Term *stc;
int    slen;
int    idx;
char   *rht_phrs;
boolean *lftstop;
{
  int  lh;

  *lftstop = left_stop_noun(stc, slen, idx);

  if (has_phrase(stc, slen, idx, "noun_sgl", &lh)) {
    sprintf(rht_phrs, "rht_phrs(noun_sgl)");
    return TRUE;
  }
  if (has_phrase(stc, slen, idx, "noun_pl", &lh)) {
    sprintf(rht_phrs, "rht_phrs(noun_pl)");
    return TRUE;
  }
  if (has_phrase(stc, slen, idx, "vt_ing", &lh)) {
    sprintf(rht_phrs, "rht_phrs(vt_ing)");
    return TRUE;
  }
  if (has_phrase(stc, slen, idx, "vi_ing", &lh)) {
    sprintf(rht_phrs, "rht_phrs(vi_ing)");
    return TRUE;
  }
  if (has_phrase(stc, slen, idx, "being", &lh)) {
    sprintf(rht_phrs, "rht_phrs(being)");
    return TRUE;
  }
  if (has_phrase(stc, slen, idx, "adj", &lh)) {
    sprintf(rht_phrs, "rht_phrs(adj)");
    return TRUE;
  }
  if (has_phrase(stc, slen, idx, "adj_er", &lh)) {
    sprintf(rht_phrs, "rht_phrs(adj_er)");
    return TRUE;
  }
  if (has_phrase(stc, slen, idx, "vt_pprt", &lh)) {
    sprintf(rht_phrs, "rht_phrs(vt_pprt)");
    return TRUE;
  }
  if (has_phrase(stc, slen, idx, "vi_pprt", &lh)) {
    sprintf(rht_phrs, "rht_phrs(vi_pprt)");
    return TRUE;
  }
  return FALSE;
}
