  

#include  <sys/time.h>
#include <stdlib.h>
#include <string.h>
                                                             
#include     "create.h"
#include     "HashFnct.h"
 
#define   WORDDAT   "word.dat"
#define   WORDIDX   "word.idx"
#define   BIDX      "bckt.idx"



struct   BcktIdxEnt  Bindex[SIZEOFWORDBK];
struct   WordIdxEnt  Windex[WDIDXSIZE];
char                 prefix[PREFIXLEN + 1];
char                 Wdata[SIZEOFWDDAT];



FILE  *wddat, *wdidx, *bidx;


int  GetBcktIdx()


{

  unsigned   i, val;
  



  val = BcktHash(prefix);
  i = 0;
/*printf("hashvalue1 %d\n", val);*/
/*printf("prefix %s\n", wordbk[val].bcktnm);*/
  while ((strcmp(Bindex[val].bcktnm, prefix) != 0) && (i <= MAXBKCONFLICT))
  {
    if (Bindex[val].bcktnm[0] == '\0')
    {
      i = MAXBKCONFLICT;
    };

    val = (val + 1) % SIZEOFWORDBK;
    i++;
  };

  if (i > MAXBKCONFLICT)
  {
    return(-1);
  }
  else
  {
    return(val);
  };
}







unsigned  HashVal(Word, fnct, size)

char      Word[];
char      fnct;
unsigned  size;


{
  unsigned  val; 
 
  
  switch(fnct)
  {
    case '1':  val = WordHash1(Word, size);
               break;
    case '2':  val = WordHash2(Word, size);
               break;
    case '3':  val = WordHash3(Word, size);
               break;
    case '4':  val = WordHash4(Word, size);
               break;
    case '5':  val = WordHash5(Word, size);
               break;

  };


  return(val);
 
}

                 


void  Open_Dict()

{


  printf("\nOpen the dictionary and load hash tables from disk ...\n\n");
 

  if ((wddat = fopen(WORDDAT, READ)) == NULL)
  {
    fprintf(stderr, "fail to open the %s \n", WORDDAT);
    exit(0);
  };

  ReadSucc = fread(Wdata, sizeof(Wdata), 1, wddat);
  if (! ReadSucc)
  {
    fprintf(stderr, "fail to read from %s\n", WORDDAT);
    exit(0);
  };





  if ((bidx = fopen(BIDX, READ)) == NULL)
  {
    fprintf(stderr, "fail to open the %s \n", BIDX);
    exit(0);
  };

  ReadSucc = fread(Bindex, sizeof(Bindex), 1, bidx);
  if (! ReadSucc)
  {
    fprintf(stderr, "fail to read from %s\n", BIDX);
    exit(0);
  };





  if ((wdidx = fopen(WORDIDX, READ)) == NULL)
  {
    fprintf(stderr, "fail to open the %s \n", WORDIDX);
    exit(0);
  };

  ReadSucc = fread(Windex, sizeof(Windex), 1, wdidx);
  if (! ReadSucc)
  {
    fprintf(stderr, "fail to read from %s\n", WORDIDX);
    exit(0);
  };

}






void   Close_Dict()

{

  printf("\nclose the dictionary ...\n\n");

  fclose(wddat);
  fclose(bidx);
  fclose(wdidx);

}






boolean  Find_Word(Word, pattern, tm)

char      Word[], pattern[];
long      tm[];



{ 
  int                i, bcktidx, j, maxc;
  unsigned long int  wordidx, base, idx;
  char               ch, fnt;
  unsigned           freq, size, len, hval;
  struct timeval     before, after;
  boolean            found;
  char               Word1[MAXWORDLEN + 1];


  found = FALSE;

  if (gettimeofday(&before, NULL) != 0) 
  {
    printf("fail to get the time before execution\n");
    exit(0);
  };


  strncpy(prefix, Word, PREFIXLEN);
  while ((i = strlen(prefix)) < PREFIXLEN)
  {
    prefix[i] = ' ';
    prefix[i + 1] = '\0';
  };


  if ((bcktidx = GetBcktIdx()) == -1)
  {
/*   printf("word '%s' is not in the dictionary\n", Word);*/
/* printf("there is no prefix %s in %s for word %s\n", prefix, BIDX,Word);*/
    
    if (gettimeofday(&after, NULL) != 0) 
    {
      printf("fail to get the time after execution\n");
      exit(0);
    };
  
    tm[0] = after.tv_usec - before.tv_usec;
    if (tm[0] < 0)
    {
      tm[0] = tm[0] + 1000000;
    };

  /*  printf("The time used to search the word: %d milliseconds.\n", tm[0]);*/
 
  }
  else
  {
    freq = Bindex[bcktidx].freq;
    base = Bindex[bcktidx].bkloc;
    size = Bindex[bcktidx].bksize;
    fnt = Bindex[bcktidx].fnct;
    maxc = Bindex[bcktidx].maxcnft;
   

    hval = HashVal(Word, fnt, size);
    wordidx = base + hval;
    len = strlen(Word);
 
    for (i = 0; i <= maxc; i ++)
    {
      if (len != Windex[wordidx].length)
      {
        hval = (hval + 1) % size;
        wordidx = base + hval;

      }
      else
      {
        idx = Windex[wordidx].wdloc;
        j = 0;

        while (Wdata[idx] != ' ')
        {
          Word1[j++] = Wdata[idx++];
        };
        Word1[j] = '\0';

        
/*printf("word1 %s  pattern %s \n", Word1, pattern);*/

        if (strcmp(Word, Word1) == 0)
        {
         /* printf("'%s' is found:  %s   %s\n", Word, Word1, pattern);*/
          idx ++;
          j = 0;
          while (Wdata[idx] != '\n')
          {
            pattern[j++] = Wdata[idx++];
          };
          pattern[j] = '\0';

          found = TRUE;
          break;
        }
        else
        {
          hval = (hval + 1) % size;
          wordidx = base + hval;
        };

      };
    };

  

   
 
    if (gettimeofday(&after, NULL) != 0) 
    {
      printf("fail to get the time after execution\n");
      exit(0);
    };
  
    tm[0] = after.tv_usec - before.tv_usec;
    if (tm[0] < 0)
    {
      tm[0] = tm[0] + 1000000;
    };


  /*  printf("The time used to search the word: %d milliseconds.\n", tm[0]);*/

   
  };

  return(found);
    

}
  


main()

{ 


  char      Word[MAXWORDLEN + 1], pattern[10];
  unsigned  tm[1];


  Open_Dict();

  printf("please input the word to be searched ( # to quit )\n\n");
  scanf("%s", Word);

  while (strcmp(Word, "#") != 0)
  {

    if(Find_Word(Word, pattern, tm))
    {
      printf("'%s' is found; pattern: %s\n", Word, pattern);
    }
    else
    {
      printf("'%s' is not found.\n", Word);
    };

    printf("The time used to search the word: %d musec.\n", tm[0]);
          
    printf("\nplease input the word to be searched ( # to quit )\n\n");
    scanf("%s", Word);
  
  };
    

 Close_Dict();

}
  
