
#include     <stdio.h>

#define      MAXWORDLEN     80     /* Maximum length of a word */

#define      MAXVARLEN      27     /* Maximum length of a var */

#define      MAXPTRNS       10   /* Maximum number of patterns in a word */

#define      SIZEOFWDDAT    2705130 /* size of word.dat */

#define      SIZEOFWORDBK   30000 /* size of bckt.idx */

#define      WDIDXSIZE      676470 /* size of word.idx */       

#define      MAXBKCONFLICT  6      /* max # of conflicts when search bckt name*/

#define      TRUE           1      /* Boolean value TRUE */

#define      FALSE          0      /* Boolean value FALSE */ 

#define      PREFIXLEN      3      /* length of prefix considered */

#define      SUFFIXLEN      4      /* length of suffix considered */

#define      PRETAILLEN     4      /* prefix length of a word tail considered */

#define      ISWFIDX        232

#define      NOTWFIDX       242

#define      QUNT_MAX       7

#define      ONEWD_MAX      15000 /* max number of entries allowed in onewddat*/

/**#define      INNERTEXT_MAX  300000 ***/
#define      INNERTEXT_MAX  500000 /* max length allowed in iner_text.dat */

#define      WRONGWD_MAX    7000 /* max number of wrong words allowed in text */

#define      ITPRT_MAX      3 /* max number of interpretation */

#define      SPELLING       1  /* error code for violate spelling */

#define      REPEAT         2  /* error code for repeating letters */

#define      TRANSP         3  /* error code for transpositon of letters */

#define      SPC_TRSP       4  /*error code for space transpositon of letters */

#define      NEIGHB         5  /* error code for typing as a neighbour letter*/

#define      INSERT         6  /* error code for inserting a neighb letter */

#define      OMIT           7  /* error code for omitting letter */

#define      DE_DI          8  /* error code for typing 'de' as 'di' */

#define      DI_DE          9  /* error code for typing 'di' as 'de' */

#define      EI_IE          10  /* error code for typing 'ei' as 'ie' */

#define      IE_EI          11  /* error code for typing 'ie' as 'ei' */

#define      RETAIN_E       12  /* error code for retaining silent e */

#define      LOWER_LTR      13  /* error code for lower 1st letter of the 
                                   beginning word in a sentence */

#define      EXCLUDED_WD    14  /* error for using excluded word */

/**&&&&&&&&&7/99&&&&&&&&**/
#define      USR_RPLCMNT    15  /*error:word has usr suggested replcemnt wrd */
/**&&&&&&end7/99&&&&&&&&**/



#define      DCMDCT_MAX     20000 /* max size of document dictionary */

#define      RCNTERR_MAX    30  /*number of most recent errors kept as history*/

#define      READWRITE      "r+"

#define      READ           "r" 

#define      WRITE          "w"

#define      VERSION11      "<Version 1.1>"   /* the version of user dict*/

#define      VERSION20      "<Version 2.0>"

#define      EXTRALTMAX     40      /* max number of extral alternatives */

 




typedef      unsigned short boolean;




struct BcktIdxEnt    

         {

           char              bcktnm[PREFIXLEN + 1];  /* bucket name */
           unsigned long int bkloc;  /* bucket location */
           unsigned          freq;  /* number of words in the bucket */
           unsigned          bksize;  /* the size of the bucket */
           char              fnct; /* the hash function used in the bucket */
           int               maxcnft; /* max hash conflicts in the bucket */

         };  /* entry of the file "bckt.idx" */





struct WordIdxEnt 

         {

           unsigned          length; /* length of the word */
           unsigned long int wdloc; /* location in "word.dat" */
           unsigned          idmnum; /* number of related idioms, not used */
           unsigned long int idmloc; /* location in "idiom.idx", not used */

         };  /* entry of the file "word.idx" */

   



struct OneWord    
 
         {

           char word[MAXWORDLEN + 1];  /* word */
           char root[MAXWORDLEN + 1];  /* root of word */
           char suffix[5];             /* suffix of word */
           char pttrn[MAXPTRNS+1];     /* classification of word */
           char Txt_Alt;     /* 'T' for text word, 'A' for altenate */
           char Fnd_Not;     /* 'F' for found in dictionary, 'N' otherwise */
           int  is_wf;       /* code of being some word form */
           int  not_wf;      /* code of not being some word form */
           int  errtype;     /* error code, 0 means no error */
           int  ptr1;    /* pointer to 1st altenate, -1 means no altenate */
           int  ptr2;    /* pointer to 2st altenate, -1 means no altenate */
           int  ptr3;    /* pointer to 3st altenate, -1 means no altenate */
                      
         };  /* entry of the working dictionary */




               
struct UserWd    

         {

           char word[MAXWORDLEN + 1];  /* word */
           char root[MAXWORDLEN + 1];  /* root of word */
           char suffix[5];             /* suffix of word */
           char pttrns[MAXPTRNS+1];    /* classifications of word */
           int  ptrn_likelihood[MAXPTRNS+1]; /* the likelihoods of ptrns */
           int  is_wf;                 /* code of being some word form */
           int  not_wf;              /* code of not being some word form */
                       
         };  /* entry of user word dictionary */






struct WrongWord   

         { 
                         
          int      code;   /* wrong word code */
          int      pos;    /* the location of the wrong word in text */ 

         };  /* entry of wrong word list for a text */




   
struct DictIndex    
 
         { 

           char     word[MAXWORDLEN + 1]; /* word */
           int      count;   /* the number of the occurance of the word */
           int      code;    /* word inner code */
           boolean  red;     /* red/black flag */
           int      left;    /* pointer to left child */
           int      right;   /* pointer to right child */

         };  /* entry of dictionary index used for user and working 
                dictionary; actually this is the entry of a red-black tree
                used for searching words in user or working dictionary */




