#include    "spell_cnst.h"
#include    "ctype.h"
#include    "spell_global.h"

#include "spellroutines.h"



extern boolean text_changed; 

char  old_textname[120] = ""; /* indicate the most recent text file name
*/
long  wd_count;           /* indicate how many words have been processed
*/


FILE  *text_file;


/*----------------------------------------------------------------------
  
  has_text  --  ask user to type the name of text file to be processed.

    input  -- none
    output -- returns TRUE if user submitted a file name, FALSE if user
              quits the system.

-----------------------------------------------------------------------*/
boolean has_text()
{
  char    ch;

begin:

  if ( get_default_text_name() ) 
    {   printf(
        "\nName of text file\n");
        printf("   Press return for '%s'"
              " (=most recent name)\n",
                default_text_name);
        printf("   'q' to quit\n");  
    }
   else
    {   printf("\nName of text file ('q' to quit)\n");
               
     };
        
  fflush(stdin);
  printf("\nSPELLING >> ");
  ch = getchar();
    if (ch == '\n') {  /*** use the default name ***/
                       strcpy(text_name,default_text_name);
                     }
      else {   int   i; 
               
              text_name[0] = ch;     
              i=1;
              do{
                  ch=getchar();
                 text_name[i++] = ch;
                } while( ch != '\n' );
              text_name[--i] = '\0';
              if( strcmp(text_name,"q") == 0 ) return FALSE;
            }
  
  while (strcmp(text_name, "q") != 0) {
    
    

    if ((text_file = fopen(text_name, READ)) == NULL) {
      printf("Error while opening text file %s, file may not exist\n",
              text_name);
      printf("Check the file name and try again\n\n");
    if ( get_default_text_name() ) 
      {   printf("\nName of text file ( press return for most recent name '%s',\n",
                  default_text_name);
          printf("                   'q' to quit).\n");  
       }
     else
      {   printf("\nName of text file ('q' to quit)\n");
                
       };
  fflush(stdin);
  printf("\nSPELLING >> ");
  ch = getchar();
    if (ch == '\n') {  /*** use the default name ***/
                       strcpy(text_name,default_text_name);
                     }
      else {   int   i; 
               
              text_name[0] = ch;     
              i=1;
              do{
                  ch=getchar();
                 text_name[i++] = ch;
                } while( ch != '\n' );
              text_name[--i] = '\0';
              if( strcmp(text_name,"q") == 0 ) return FALSE;
            }
            continue;
    }

    save_default_text_name();

    read_params(FALSE);
    read_usrfiles();

    if (accept_unknown) {
      char  ans[80];

printf("\n\n!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
      printf("!                                                     !\n");
      printf("!                      CAUTION                        !\n");
      printf("!                                                     !\n");
      printf("!  Do you really want to accept all unknown words of  !\n");
      printf("!  this file as correct?                              !\n");
      printf("!                                                     !\n");
      printf("!  Yes -- type 'y' and press return;                  !\n");
      printf("!  No  -- change params.dat file and press return to  !\n");
      printf("!         restart.                                    !\n");
      printf("!                                                     !\n");

printf("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!\n");
      printf("\n>> ");
      gets(ans);
      if ((strcmp(ans, "y") != 0) && (strcmp(ans, "Y") != 0)) goto begin;
    }

    return TRUE;
  }
  return FALSE;
}

/*----------------------------------------------------------------------*/

    
/*---------------------------------------------------------------------

  spell_checking  --  run spell checking on the text.

    input  -- none
    output -- none

---------------------------------------------------------------------*/
void spell_checking()
{
  retprb("FindWdForm");

  innertext_ptr = 0;
  innertxtout_ptr = 0;
  wrongwd_ptr = 0;
  wd_count = 1;

  printf("\n******************************************************\n");
  printf("*     Find Word Forms (one dot below = 50 words)     *\n");
  printf("******************************************************\n\n");

  while (!feof(text_file)) {

    fetch_and_check();
  }

  fclose(text_file);

  upper_head = FALSE;
  all_upper = FALSE;

  fix_words();

  printf("\n\nUpdating files ... DO NOT ABORT!\n\n");

/* disabled updating of text Dec, 2016 */
/*      to avoid output errors of text list */
/*      this is a temporary fix */
/*
  if (text_changed) {
      printf("\nCAUTION:  The file %s has been corrected. Therefore any copy\n", text_name); 
      printf("          displayed by your text editor is out of date. Make sure\n");
      printf("          that any further editing is done on the corrected file.\n\n");
  }
*/

/*  write_text(); */

/* revised CAUTION statement since text has not been changed: */
  if (text_changed) {
      printf("\nCAUTION:  The file %s has been NOT been corrected.\n",
               text_name); 
      printf("          The above corrections must be made manually.\n");
      printf("          The rerun spell checker on the file to make\n");
      printf("          sure that all corrections were properly made .\n\n");
  }


 
  write_innertext(); 

  dctn_init(dcm_dct, dcmdct_head, &dcmdct_ptr, &onewddat_ptr);
  copy_usrdct();

  write_usrfiles();
    
  printf("\n\n");
}



/*---------------------------------------------------------------------

  fetch_and_check  --  fetch a word from text_file, do spell checking on 
                       it.

    input  -- none
    output -- none

-----------------------------------------------------------------------*/
void fetch_and_check()
{
  char    ch;
  
/**&&&&&&&&&7/99&&&&&&&&**/
  char      wrd2[MAXWORDLEN + 1];
/**&&&&&&end7/99&&&&&&&&**/


  ch = getc(text_file);

  if (isalnum(ch)) {
    char    ch1, t0, token[MAXWORDLEN + 1], pttrn[MAXPTRNS+1];
    int     len, wordcode, ptr, i, apstrph_num, apstrph_pos;
    boolean is_dot, has_apstrph, emb_apstrph, found_word;
   
    upper_head = FALSE;
    all_upper = FALSE;
    is_dot = FALSE;
    has_apstrph = FALSE;
    emb_apstrph = FALSE;

    apstrph_num = 0;
    len = 0;
    ch1 = ' ';
    while(((isalnum(ch)) || (ch == '-') || 
           (ch == '\'')  || ((ch == '.') && (ch1 != ch)))  && 
          (!feof(text_file))) {

      ch1 = ch;
      if (ch == '\'') emb_apstrph = TRUE;
      if (len < MAXWORDLEN) { token[len++] = ch; ch = getc(text_file); }
      else {
        int i;
 
        for (i = 0; i < len; i++) {
          innertext[innertext_ptr++] = -token[i];
          innertx_buf_check();
        }
        while(((isalnum(ch)) || (ch == '-') || 
               (ch == '\'')  || ((ch == '.') && (ch1 != ch)))  && 
              (!feof(text_file))) {

          ch1 = ch;
          innertext[innertext_ptr++] = -ch;
          innertx_buf_check();
          ch = getc(text_file);
        }
        goto end_of_word;
      }
    }

    if ((has_apstrph = (token[len -1] == '\''))) {
      int  j;
   
      apstrph_num = 1;
      for (j = len - 2; j >= 0; j--) {
        if (token[j] != '\'') break;
        apstrph_num++;
      }
      len = len - apstrph_num;
      token[len] = '\0';
    }

    if ((is_dot = (token[len -1] == '.'))) { token[--len] = '\0'; }
    else token[len] = '\0';

    if (emb_apstrph) {
      for (apstrph_pos = 0; apstrph_pos < len; apstrph_pos++)
        if (token[apstrph_pos] == '\'') break;
      if (apstrph_pos == len) emb_apstrph = FALSE;
    }

    t0 = token[0];
    if (has_alpha(token)) {
      if ((wd_count % 50) == 0) fputc('.', stderr);
      wd_count ++;


      /* processing if the token is an excluded word */

      if (is_excluded_word(token)) {                 /* an excluded word
*/
        wrongwd[wrongwd_ptr].code = onewddat_ptr;
        wrongwd[wrongwd_ptr++].pos = innertext_ptr;
        wrongwd_buf_check();
        dcmdct_insert(token,
onewddat_ptr,dcm_dct,dcmdct_head,&dcmdct_ptr);
        inner_form(token, " ", " ", " ", 'T', 'N', 0, 0,EXCLUDED_WD);
        store_dot(is_dot);
        store_apstrph(has_apstrph, apstrph_num);
        goto end_of_word;
      }

      /* processing if the token is already in the user dictionary */

      if ((ptr = dcmdct_search1(token, dcm_dct, dcmdct_head)) != -1) {
        if (dcm_dct[ptr].count <= 0) dcm_dct[ptr].count = 1;
        dcm_dct[ptr].count++;
        innertext[innertext_ptr++] = dcm_dct[ptr].code;
        innertx_buf_check();
        store_dot(is_dot);
        store_apstrph(has_apstrph, apstrph_num);
        goto end_of_word;
      } 

      /**&&&&&&&&&7/99&&&&&&&&**/
      /* processing if the token has a user suggested replacement word */

      if (is_usr_replcmnt_word(token,wrd2)) {   /* token has user suggested 
                                                   replacement */
        wrongwd[wrongwd_ptr].code = onewddat_ptr;
        wrongwd[wrongwd_ptr++].pos = innertext_ptr;
        wrongwd_buf_check();
        dcmdct_insert(token,onewddat_ptr,dcm_dct,dcmdct_head,&dcmdct_ptr);
        inner_form(token, " ", " ", " ", 'T', 'N', 0, 0,USR_RPLCMNT);
        store_dot(is_dot);
        store_apstrph(has_apstrph, apstrph_num);
        goto end_of_word;
      }

     /**&&&&&&end7/99&&&&&&&&**/


      /* check the token against the general dictionary */

      wordcode = onewddat_ptr;

      Txt_Alt = 'T';
      Textwd = -1;
      itprt = 0;
      upper_head = isupper(t0);

      found_word = Find_Word(token, pttrn);
      if (found_word) { Fnd_Not = 'F'; }
      else {
        Fnd_Not = 'N';
        if (upper_head && (islower(token[1]))) {
          token[0] = tolower(t0);
          found_word = Find_Word(token, pttrn);
          if (found_word) Fnd_Not = 'F';
        }
        else {
          all_upper = TRUE;
          for (i = 0; i < len; i++)
            if (! isupper(token[i])) { all_upper = FALSE; break; }
          if (all_upper) {
            for (i = 0; i < len; i++) { token[i] = tolower(token[i]); }
            found_word = Find_Word(token, pttrn);
            if (found_word) Fnd_Not = 'F';
          }
        }
      }

      /* find possible word form of token */

      Find_wdform(token);

      if (itprt == 0) { /* no any word form has been found */
        if (found_word) {
          inner_form(token, " ", " ", pttrn, Txt_Alt, Fnd_Not, 0, 0, 0);
          Txt_Alt = 'A';
        }
        else { /* word was not found, try "token +'.'", token w/ apstrph
*/


          /* try "token + '.' */

          if (is_dot) {
            if (upper_head) token[0] = toupper(token[0]);
            strcat(token, ".");

            /* token w/ '.' is in the user dictionary */

            if ((ptr = dcmdct_search1(token,dcm_dct,dcmdct_head)) != -1) {
              if (dcm_dct[ptr].count <= 0) dcm_dct[ptr].count = 1;
              dcm_dct[ptr].count++;
              innertext[innertext_ptr++] = dcm_dct[ptr].code;
              innertx_buf_check();
              store_apstrph(has_apstrph, apstrph_num);
              goto end_of_word;
            }

            /* token w/ '.' is in the general dictionary */

            if (Find_Word(token, pttrn)) {
              inner_form(token, " ", " ", pttrn, 'T', 'F', 0, 0, 0);
              dcmdct_insert(token,wordcode,dcm_dct,dcmdct_head,
                            &dcmdct_ptr);
              goto end_of_word;
            }


            /* token w/ '.' can't be found */

            token[len] = '\0'; 
            goto save_wrongwd;
          }          


          /* try token w/ apostraphes */

          if (emb_apstrph) { 
            char token1[MAXWORDLEN + 1];
            int  j, k = 0;

            if (upper_head) token[0] = toupper(token[0]);

            for (j = apstrph_pos + 1; j < len; j++) token1[k++] =
token[j];
            token1[k] = '\0';
            token[apstrph_pos] = '\0';

            if ((ptr = dcmdct_search1(token,dcm_dct,dcmdct_head)) != -1) {
              if (dcm_dct[ptr].count <= 0) dcm_dct[ptr].count = 1;
              dcm_dct[ptr].count++;
              innertext[innertext_ptr++] = dcm_dct[ptr].code;
              innertx_buf_check();
              innertext[innertext_ptr++] = -39;
              innertx_buf_check();
              goto check2nd;
            }

            if (is_number(token)) {
              wordcode = onewddat_ptr;
              if (strcmp(token,"1") == 0) {
                inner_form(token," "," ","Yan", 'T', 'F', 0, 0, 0);
              } 
              else inner_form(token," "," ","ZaN", 'T', 'F', 0, 0, 0);
              dcmdct_insert(token, wordcode, dcm_dct, dcmdct_head, 
                            &dcmdct_ptr);
              goto check2nd;
            }

            if (Find_Word(token, pttrn)) {
              inner_form(token, " ", " ", pttrn, 'T', 'F', 0, 0, 0);
              dcmdct_insert(token, wordcode, dcm_dct, dcmdct_head,
                            &dcmdct_ptr);
              innertext[innertext_ptr++] = -39;
              innertx_buf_check();
              goto check2nd;
            }

            if (upper_head && (islower(token[1]))) {
              token[0] = tolower(token[0]);
              if (Find_Word(token, pttrn)) {
                inner_form(token, " ", " ", pttrn, 'T', 'F', 0, 0, 0);
                dcmdct_insert(token, wordcode, dcm_dct, 
                              dcmdct_head, &dcmdct_ptr);
                innertext[innertext_ptr++] = -39;
                innertx_buf_check();
                goto check2nd;
              }
            }

            wrongwd[wrongwd_ptr].code = onewddat_ptr ;
            wrongwd[wrongwd_ptr++].pos = innertext_ptr;
            wrongwd_buf_check();
            inner_form(token, " ", " ", " ", Txt_Alt, Fnd_Not,0,0,0);
            Txt_Alt = 'A';
            dcmdct_insert(token, wordcode, dcm_dct, dcmdct_head,
                          &dcmdct_ptr);
            innertext[innertext_ptr++] = -39;
            innertx_buf_check();

check2nd:   upper_head = isupper(token1[0]);
            if ((ptr = dcmdct_search1(token1,dcm_dct,dcmdct_head)) != -1){
              if (dcm_dct[ptr].count <= 0) dcm_dct[ptr].count = 1;
              dcm_dct[ptr].count++;
              innertext[innertext_ptr++] = dcm_dct[ptr].code;
              innertx_buf_check();
              store_apstrph(has_apstrph, apstrph_num);        
              goto end_of_word;
            }

            if (is_number(token1)) {
              wordcode = onewddat_ptr;
              if (strcmp(token1,"1") == 0) {
                inner_form(token1," "," ","Yan",'T', 'F', 0, 0, 0);
              } 
              else {
                inner_form(token1," "," ","ZaN",'T', 'F', 0, 0, 0);
              } 

              dcmdct_insert(token1, wordcode, dcm_dct,dcmdct_head, 
                            &dcmdct_ptr);
           
              goto end_of_word;
            }

            if (Find_Word(token1, pttrn)) {
              inner_form(token1, " ", " ", pttrn, 'T', 'F', 0, 0, 0);
              dcmdct_insert(token1, wordcode, dcm_dct, dcmdct_head,
                            &dcmdct_ptr);
              store_apstrph(has_apstrph, apstrph_num);        
              goto end_of_word;
            }

            if (upper_head && (islower(token1[1]))) {
              token1[0] = tolower(token1[0]);
              if (Find_Word(token1, pttrn)) {
                inner_form(token1, " ", " ", pttrn, 'T', 'F', 0, 0, 0);
                dcmdct_insert(token1, wordcode, dcm_dct, 
                              dcmdct_head, &dcmdct_ptr);
                store_apstrph(has_apstrph, apstrph_num);        
                goto end_of_word;
              }
            }

            wrongwd[wrongwd_ptr].code = onewddat_ptr ;
            wrongwd[wrongwd_ptr++].pos = innertext_ptr;
            wrongwd_buf_check();
            inner_form(token1, " ", " ", " ", Txt_Alt, Fnd_Not,0,0,0);
            Txt_Alt = 'A';
            dcmdct_insert(token1, wordcode, dcm_dct, dcmdct_head,
                          &dcmdct_ptr);
            store_apstrph(has_apstrph, apstrph_num);        
            goto end_of_word;
          }  /* end of (emb_apstrph == TRUE) */

save_wrongwd:

          wrongwd[wrongwd_ptr].code = onewddat_ptr ;
          wrongwd[wrongwd_ptr++].pos = innertext_ptr;
          wrongwd_buf_check();
          inner_form(token, " ", " ", " ", Txt_Alt, Fnd_Not, 0, 0, 0);
          Txt_Alt = 'A';
        } /* end of "found_word == FALSE"  */
      } /* end of "itprt == 0" */
      
      dcmdct_insert(token, wordcode, dcm_dct, dcmdct_head, &dcmdct_ptr);
      store_dot(is_dot);
      store_apstrph(has_apstrph, apstrph_num);
    } /* end of "has_alpha(token) == TRUE" */
    else { /* "has_alpha(token) == FALSE" */

      /* following is the addendum to deal with number */
      
      itprt = 0;

      if (is_number(token)) {
        if ((wd_count % 50) == 0) fputc('.', stderr);
        wd_count ++;

        if ((ptr = dcmdct_search1(token,dcm_dct,dcmdct_head))!= -1) {
          if (dcm_dct[ptr].count <= 0) dcm_dct[ptr].count = 1;
          dcm_dct[ptr].count++;
          innertext[innertext_ptr++] = dcm_dct[ptr].code;
          innertx_buf_check();
          store_dot(is_dot);
          goto end_of_word;
        }
        wordcode = onewddat_ptr;
        if (strcmp(token,"1") == 0) {
          inner_form(token, " ", " ", "Yan", 'T', 'F', 0, 0, 0);
        } 
        else inner_form(token, " ", " ", "ZaN", 'T', 'F', 0, 0, 0);
        dcmdct_insert(token, wordcode, dcm_dct, dcmdct_head, &dcmdct_ptr);
        store_dot(is_dot);
        goto end_of_word;
      }
      /* end of addendum */

      len = strlen(token);
      for (i = 0; i < len; i++) {
        innertext[innertext_ptr++] = -token[i];
        innertx_buf_check();
      }
      store_dot(is_dot);
      store_apstrph(has_apstrph, apstrph_num);
    } /* end of "has_alpha(token) == FALSE" */
  } /* end of "isalnum(ch) == TRUE" */


end_of_word:

  if (ch != EOF) {
    innertext[innertext_ptr++] = -ch;
    innertx_buf_check();
  }
}  
  

/*-------------------------------------------------------------------

  has_alpha  --  check if a token contains alpha characters

    input  -- token: the token to be checked
    output -- returns TRUE if the token contains alpha characters, 
              FALSE otherwise.

--------------------------------------------------------------------*/
boolean has_alpha(token)
char *token;
{
  int len, i;

  len = strlen(token);
  for (i = 0; i < len; i++) {
    if (isalpha(token[i])) return TRUE;
  }
  return FALSE;
}


/*---------------------------------------------------------------------
  is_number  --  check if a token is a number

    input  -- token: the token to be checked
    output -- returns TRUE if the token is a number, FALSE otherwise.

----------------------------------------------------------------------*/
boolean is_number(token)
char *token;
{
  int len, i;

  len = strlen(token);
  for (i = 0; i < len; i++) 
    if ((!isdigit(token[i])) && (token[i] != '.')) return FALSE;
  return TRUE;
}


/*--------------------------------------------------------------------

  store_dot  --  store a dot in the innertext

    input  -- is_dot: indicate if the token is followed by a dot.
    output -- none

--------------------------------------------------------------------*/
void store_dot(is_dot)
boolean is_dot;
{
  if (is_dot) {
    innertext[innertext_ptr++] = -46;
    innertx_buf_check();
  }
}


/*--------------------------------------------------------------------

  store_apstrph  --  store apostrophe(s) in the innertext

    input  -- has_apstrph: indicate if the token is followed by 
                           apostrophe(s).
              apstrph_num: the number of apostrophe.
    output -- none

--------------------------------------------------------------------*/
void store_apstrph(has_apstrph, apstrph_num)
boolean has_apstrph;
int     apstrph_num;
{
  if (has_apstrph) {
    int  j;

    for (j = 0; j < apstrph_num; j++) {
      innertext[innertext_ptr++] = -39;
      innertx_buf_check();
    }
  }
}



/*-------------------------------------------------------------------

  wrongwd_buf_check  --  check if the wrong word buffer overflow.

    input  -- none
    output -- none

--------------------------------------------------------------------*/
void wrongwd_buf_check()
{
  if (wrongwd_ptr >= WRONGWD_MAX) {
    system_error("out of memory, wrong word buffer overflow");
  }
}


/*-------------------------------------------------------------------

  innertx_buf_check  --  check if the innertext buffer overflow.

    input  -- none
    output -- none

--------------------------------------------------------------------*/
void innertx_buf_check()
{
  if (innertext_ptr >= INNERTEXT_MAX) {
    system_error("out of memory, innertext buffer overflow");
  }
}


/*---------------------------------------------------------------------

  get_default_text_name  --  read default text name from disk file

    input  -- none
    output -- none

----------------------------------------------------------------------*/
boolean  get_default_text_name()
{
 FILE     *dfp;
 
 
 if( (dfp=fopen(filename_storage,"r")) == NULL )
     {
        return FALSE;
      
       }
 
 fscanf(dfp,"%s",default_text_name);
 fclose(dfp);
 if( strcmp(default_text_name,"") == 0 ) return FALSE;
 return TRUE;

}


/*---------------------------------------------------------------------

  save_default_text_name()  --  save text name in disk file to be used 
                                 as default text name.

    input  -- none
    output -- none

----------------------------------------------------------------------*/
void  save_default_text_name()
{
 FILE     *dfp;
 
 
 if( (dfp=fopen(filename_storage,"w")) == NULL )
     {
        printf("\n Error writing file %s.\n",filename_storage);
        return;
      
       }
 
 fprintf(dfp,"%s",text_name);
 fclose(dfp);
 return;

}
/**************************************************************************/





