#include  "spell_cnst.h"

#include "spellroutines.h"



extern    char nono_usr[];

/*#define TITLE */

struct  correction {
                      char  wrong_wd[MAXWORDLEN + 1];
                      char  correct_wd[MAXWORDLEN + 1];
                      int   correct_wd_code;
                      struct correction *last;
                      struct correction *next;
                   };

struct  rplc_all{
                  int               oldcode;
                  int               newcode;
                  struct  rplc_all  *next;
                };

typedef struct rplc_all rplcall;



extern int                 itprt, Textwd, wrongwd_ptr, innertext_ptr, 
                           innertxtout_ptr, onewddat_ptr, usrdctdat_ptr, 
                           errhstry_ptr, errhstry_head, 
                           repeat, transp, spc_trsp, neighb, insert, omit, 
                           de_di, di_de, ei_ie, ie_ei, retain_e, usrdct_ptr,
                           total, spelling, lower_ltr, size_altlist,
                           dcmdct_head[MAXWORDLEN + 1],
                           innertext[INNERTEXT_MAX], 
                           innertxtout[INNERTEXT_MAX], 
                           err_hstry[RCNTERR_MAX + 1], 
                           usrdct_head[MAXWORDLEN + 1],
                           extral_alt[EXTRALTMAX], extralt_ptr;
extern float               alpha;
extern char                Txt_Alt, wdfm_prg[], act_prg[];
extern struct WrongWord    wrongwd[];
extern struct OneWord      onewddat[];
extern struct UserWd       usrdctdat[];
extern struct DictIndex    dcm_dct[], usr_dct[];
extern char                text_name[];



int       wd_occur, text_line, spos;
boolean   cnsctv_wrngwd, classify, accept_unknown, text_changed;
rplcall   *rplcall_ptr;
struct correction *correction_list = NULL, *correction_list_end = NULL;

int scaled_word_occur();
int is_option();
int fix_excluded_word();

void new_correction_entry();
void already_corrected();
void correction_list_insert();



void  Neighb_Ltr(ch, neb)
char  ch, neb[];
{
  strcpy(neb, "");

  switch(ch)
  {
    case 'a': strcpy(neb, "sqwezx");
              break;
    case 'b': strcpy(neb, "vnfghj");
              break;
    case 'c': strcpy(neb, "xvsdfg");
              break;
    case 'd': strcpy(neb, "sfwertzxcv");
              break;
    case 'e': strcpy(neb, "wrasdf2345");
              break;
    case 'f': strcpy(neb, "dgertyxcvb");
              break;
    case 'g': strcpy(neb, "fhrtyucvbn");
              break;
    case 'h': strcpy(neb, "gjtyuivbnm");
              break;
    case 'i': strcpy(neb, "uohjkl7890");
              break;
    case 'j': strcpy(neb, "hkyuiobnm,");
              break;
    case 'k': strcpy(neb, "jlnmuiop,.");
              break;
    case 'l': strcpy(neb, "kiopm,.;[");
              break;
    case 'm': strcpy(neb, "nhjkl,");
              break;
    case 'n': strcpy(neb, "bmghjk");
              break;
    case 'o': strcpy(neb, "ipjkl-890;");
              break;
    case 'p': strcpy(neb, "okl[90-=l;'");
              break;
    case 'q': strcpy(neb, "was123");
              break;
    case 'r': strcpy(neb, "etsdfg3456");
              break;
    case 's': strcpy(neb, "adqwerzxc");
              break;
    case 't': strcpy(neb, "rydfgh4567");
              break;
    case 'u': strcpy(neb, "yighjk6789");
              break;
    case 'v': strcpy(neb, "cbdfgh");
              break;
    case 'w': strcpy(neb, "asdqe1234");
              break;
    case 'x': strcpy(neb, "zcasdf");
              break;
    case 'y': strcpy(neb, "tufghj5678");
              break;
    case 'z': strcpy(neb, "xasd");
              break;
  };
}


/**************************************************************************/
/*  Function to check if two letters are neighbhoolds                     */
/**************************************************************************/
boolean  is_neighbour(ch1, ch2)
char  ch1, ch2;
{
  char  neb[11];
  int   len, i;

  Neighb_Ltr(ch1, neb);
  len = strlen(neb);
  for (i = 0; i < len; i++)
  {
    if (ch2 == neb[i])
    {
      return(TRUE);
    };
  };

  return(FALSE);
}


/*************************************************************************/
/*  Function to keep track of errors user made.                          */
/*************************************************************************/
/*
void  error_track(error)

int  error;

{
    switch (error)
    {
      case REPEAT:   repeat = repeat + wd_occur;
                     break;
      case TRANSP:   transp = transp + wd_occur;
                     break;
      case SPC_TRSP: spc_trsp = spc_trsp + wd_occur;
                     break;
      case NEIGHB:   neighb = neighb + wd_occur;
                     break;
      case INSERT:   insert = insert + wd_occur;
                     break;
      case OMIT:     omit = omit + wd_occur;
                     break;
      case DE_DI:    de_di = de_di + wd_occur;
                     break;
      case DI_DE:    di_de = di_de + wd_occur;
                     break;
      case EI_IE:    ei_ie = ei_ie + wd_occur;
                     break;
      case IE_EI:    ie_ei = ie_ei + wd_occur;
                     break;
      case RETAIN_E: retain_e = retain_e + wd_occur;
                     break;
      
    };

}

*/


void  Ltr_transp(word)
char  word[];
{
  int          wdlen, i;
  char         ch1, ch2, altword[MAXWORDLEN + 1], pttrn[MAXPTRNS+1]; 

# ifdef  TITLE
  printf("checking transposition errors\n");
# endif

  wdlen = strlen(word) - 1;

  for (i = 0; i < wdlen; i ++)
  {
    if (word[i] == word[i + 1])
    {
      continue;
    };

    strcpy(altword, word);
    ch1 = altword[i];
    ch2 = altword[i + 1];
    altword[i] = ch2;
    altword[i + 1] = ch1;

    if (FIND_WORD(altword, pttrn))
    {
     /* printf("\nInterpretation %d: \n", itprt);*/
     /* printf("word: %s; pattern:  %s\n", altword, pttrn);*/
      /*printf("transp\n");*/

      inner_form(altword, " ", " ", pttrn, Txt_Alt, 'F', 0, 0, TRANSP);
      /*error_track(TRANSP);*/
      break;

    }
    else
    {
      int      itprt_tmp, datptr_tmp, i, len;
      char     ch1, ch2;
      boolean  found = FALSE;
   
      len = strlen(altword);
      ch1 = altword[len - 1];
      switch (ch1)
      {
        case 'g':
        case 't': 
                  ch2 = altword[len - 2];
                  if (((ch1 == 't') && (ch2 != 's')) ||
                      ((ch1 == 'g') && ((ch2 != 'n') || (altword[len - 3] != 'i'
                     ))))
                  {
                    break;
                  };

        case 'd':
        case 's':
        case 'r':
      
                  itprt_tmp = itprt;
                  datptr_tmp = onewddat_ptr;

                  Find_wdform(altword);
                  for (i = datptr_tmp; i < onewddat_ptr; i++)
                  {
                    onewddat[i].errtype = TRANSP;
                     /* error_track(TRANSP);*/
                  };
                  found = (itprt_tmp < itprt);
                    if ((onewddat_ptr - datptr_tmp) == 2)
                    {
                      if (extralt_ptr == 1)
                      {
                        onewddat[Textwd].ptr3 = extral_alt[0];
                        extralt_ptr = 0;
                      }
                      else
                      {
                        if (extralt_ptr > 1)
                        {
                          extral_alt[extralt_ptr - 2] = extral_alt[extralt_ptr - 1];
                          extralt_ptr--;
                        }
                        else /* extral_ptr < 1 */
                        {
                          if (onewddat[Textwd].ptr3 == -1)
                          {
                            onewddat[Textwd].ptr1 = onewddat[Textwd].ptr2;
                            onewddat[Textwd].ptr2 = -1;
                          }
                          else
                          {
                            onewddat[Textwd].ptr2 = onewddat[Textwd].ptr3;
                            onewddat[Textwd].ptr3 = -1;
                          };
                        };
                      };
                    };
                  break;
      };  /* end of switch */

      if (found)
      {
        break; /* quit from for loop */
      }
      else
      {
        altword[0] = '\0';
        pttrn[0] = '\0'; 
      };
    };
  };
 
}


void  Ltr_repeat(word)
char  word[];
{
  int          wdlen, i, j;
  char         altword[MAXWORDLEN + 1], pttrn[MAXPTRNS+1]; 
    
# ifdef  TITLE
  printf("checking repeat errors\n");
# endif

  wdlen = strlen(word) - 1;

  for (i = 0; i < wdlen; i ++)
  {
    strcpy(altword, word);
    if (altword[i] == altword[i + 1])
    {
      for (j = i + 1; j < wdlen; j++)
      {
        altword[j] = altword[j + 1];
      };
      altword[j] = '\0';

      if (FIND_WORD(altword, pttrn))
      {
      /*  printf("\nInterpretation %d: \n", itprt);*/
      /*  printf("word: %s; pattern:  %s\n", altword, pttrn);*/
      /*  printf("repeat\n");*/

        inner_form(altword, " ", " ", pttrn, Txt_Alt, 'F', 0, 0, REPEAT);
        /*error_track(REPEAT);*/
        break;

      }
      else
      {
        int      itprt_tmp, datptr_tmp, i, len;
        char     ch1, ch2;
        boolean  found = FALSE;
   


        len = strlen(altword);
        ch1 = altword[len - 1];
        switch (ch1)
        {
          case 'g':
          case 't': 
                    ch2 = altword[len - 2];
                    if (((ch1 == 't') && (ch2 != 's')) ||
                        ((ch1 == 'g') && ((ch2 != 'n') || 
                         (altword[len - 3] != 'i'))))
                    {
                      break;
                    };

          case 'd':
          case 's':
          case 'r':
      
                    itprt_tmp = itprt;
                    datptr_tmp = onewddat_ptr;

                    Find_wdform(altword);
                    for (i = datptr_tmp; i < onewddat_ptr; i++)
                    {
                      onewddat[i].errtype = REPEAT;
                       /* error_track(REPEAT);*/
                    };
                    found = (itprt_tmp < itprt);
                    
                    if ((onewddat_ptr - datptr_tmp) == 2)
                    {
                      if (extralt_ptr == 1)
                      {
                        onewddat[Textwd].ptr3 = extral_alt[0];
                        extralt_ptr = 0;
                      }
                      else
                      {
                        if (extralt_ptr > 1)
                        {
                          extral_alt[extralt_ptr - 2] = extral_alt[extralt_ptr - 1];
                          extralt_ptr--;
                        }
                        else /* extral_ptr < 1 */
                        {
                          if (onewddat[Textwd].ptr3 == -1)
                          {
                            onewddat[Textwd].ptr1 = onewddat[Textwd].ptr2;
                            onewddat[Textwd].ptr2 = -1;
                          }
                          else
                          {
                            onewddat[Textwd].ptr2 = onewddat[Textwd].ptr3;
                            onewddat[Textwd].ptr3 = -1;
                          };
                        };
                      };
                    };


                  
                    break;
        };  /* end of switch */

        if (found)
        {
          break; /* quit from for loop */
        }
        else
        {
          altword[0] = '\0';
          pttrn[0] = '\0'; 
        };
      };
    };
  };
}


void  Ltr_neighb(word)
char  word[];
{
  int          wdlen, neblen, i, j;
  char         neb[11], altword[MAXWORDLEN + 1], pttrn[MAXPTRNS+1]; 
    
# ifdef  TITLE
  printf("checking neighb\n");
# endif

  wdlen = strlen(word);

  i = 0;
  while (i < wdlen)
  {
    Neighb_Ltr(word[i], neb);
    neblen = strlen(neb);
    for (j = 0; j < neblen; j++)
    {
      strcpy(altword, word);
      altword[i] = neb[j];

      if (FIND_WORD(altword, pttrn))
      {
       /* printf("\nInterpretation %d: \n", itprt);*/
       /* printf("word: %s; pattern:  %s\n", altword, pttrn);*/
       /* printf("neighb\n");*/
        
        inner_form(altword, " ", " ", pttrn, Txt_Alt, 'F', 0, 0, NEIGHB);
        /*error_track(NEIGHB);*/
        break;

      }
      else
      {
        int      itprt_tmp, datptr_tmp, i, len;
        char     ch1, ch2;
        boolean  found = FALSE;
   


        len = strlen(altword);
        ch1 = altword[len - 1];
        switch (ch1)
        {
          case 'g':
          case 't': 
                    ch2 = altword[len - 2];
                    if (((ch1 == 't') && (ch2 != 's')) ||
                      ((ch1 == 'g') && ((ch2 != 'n') || (altword[len - 3] != 'i'
                       ))))
                    {
                      break;
                    };

          case 'd':
          case 's':
          case 'r':
      
                    itprt_tmp = itprt;
                    datptr_tmp = onewddat_ptr;

                    Find_wdform(altword);
                    for (i = datptr_tmp; i < onewddat_ptr; i++)
                    {
                      onewddat[i].errtype = NEIGHB;
                        /*error_track(NEIGHB);*/
                    };

                    if ((onewddat_ptr - datptr_tmp) == 2)
                    {
                      if (extralt_ptr == 1)
                      {
                        onewddat[Textwd].ptr3 = extral_alt[0];
                        extralt_ptr = 0;
                      }
                      else
                      {
                        if (extralt_ptr > 1)
                        {
                          extral_alt[extralt_ptr - 2] = extral_alt[extralt_ptr - 1];
                          extralt_ptr--;
                        }
                        else /* extral_ptr < 1 */
                        {
                          if (onewddat[Textwd].ptr3 == -1)
                          {
                            onewddat[Textwd].ptr1 = onewddat[Textwd].ptr2;
                            onewddat[Textwd].ptr2 = -1;
                          }
                          else
                          {
                            onewddat[Textwd].ptr2 = onewddat[Textwd].ptr3;
                            onewddat[Textwd].ptr3 = -1;
                          };
                        };
                      };
                    };

                      
                    found = (itprt_tmp < itprt);
                  
                    break;
        };  /* end of switch */

        if (found)
        {
          break; /* quit from for loop */
        }
        else
        {
          altword[0] = '\0';
          pttrn[0] = '\0'; 
        };

 
      };
    };
    
    i ++;

  };

}


void  Ltr_insert(word)
char  word[];
{

  int          wdlen, neblen, i, j, k;
  char         neb[11], altword[MAXWORDLEN + 1], pttrn[MAXPTRNS+1]; 
  boolean      found;

# ifdef  TITLE
  printf("checking insert\n");
# endif

  found = FALSE;
 
  wdlen = strlen(word) - 1;

  Neighb_Ltr(word[0], neb);
  neblen = strlen(neb);

  for (j = 0; j < neblen; j++)
  {
    if (neb[j] == word[1])
    {
      altword[0] = word[0];
      for (k = 2; k <= wdlen; k ++)
      {
        altword[k - 1] = word[k];
      };
      altword[k - 1] = '\0';

/* printf("altword2 %s\n", altword);*/


      if ((found = FIND_WORD(altword, pttrn)))
      {
       /* printf("\nInterpretation %d: \n", itprt);*/
        /*printf("word: %s; pattern:  %s\n", altword, pttrn);*/
       /* printf("insert\n");*/

        inner_form(altword, " ", " ", pttrn, Txt_Alt, 'F', 0, 0, INSERT);
        /*error_track(INSERT);*/
        break;

      }
      else
      {
        int      itprt_tmp, datptr_tmp, i, len;
        char     ch1, ch2;
        boolean  found = FALSE;
   


        len = strlen(altword);
        ch1 = altword[len - 1];
        switch (ch1)
        {
          case 'g':
          case 't': 
                    ch2 = altword[len - 2];
                    if (((ch1 == 't') && (ch2 != 's')) ||
                      ((ch1 == 'g') && ((ch2 != 'n') || (altword[len - 3] != 'i'
                       ))))
                    {
                      break;
                    };

          case 'd':
          case 's':
          case 'r':
      
                    itprt_tmp = itprt;
                    datptr_tmp = onewddat_ptr;

                    Find_wdform(altword);
                    for (i = datptr_tmp; i < onewddat_ptr; i++)
                    {
                      onewddat[i].errtype = INSERT;
                       /* error_track(INSERT);*/
                    };
                    found = (itprt_tmp < itprt);
        
                    if ((onewddat_ptr - datptr_tmp) == 2)
                    {
                      if (extralt_ptr == 1)
                      {
                        onewddat[Textwd].ptr3 = extral_alt[0];
                        extralt_ptr = 0;
                      }
                      else
                      {
                        if (extralt_ptr > 1)
                        {
                          extral_alt[extralt_ptr - 2] = extral_alt[extralt_ptr - 1];
                          extralt_ptr--;
                        }
                        else /* extral_ptr < 1 */
                        {
                          if (onewddat[Textwd].ptr3 == -1)
                          {
                            onewddat[Textwd].ptr1 = onewddat[Textwd].ptr2;
                            onewddat[Textwd].ptr2 = -1;
                          }
                          else
                          {
                            onewddat[Textwd].ptr2 = onewddat[Textwd].ptr3;
                            onewddat[Textwd].ptr3 = -1;
                          };
                        };
                      };
                    };


                  
                    break;
        };  /* end of switch */

        if (found)
        {
          break; /* quit from for loop */
        }
        else
        {
          altword[0] = '\0';
          pttrn[0] = '\0'; 
        };

      };
    };

  };

  i = 1;
  while ((! found) && (i < wdlen))
  {
    Neighb_Ltr(word[i], neb);

/*printf("neb %s\n", neb); */

    neblen = strlen(neb);
    for (j = 0; j < neblen; j++)
    {
      if (neb[j] == word[i - 1])
      {
        strncpy(altword, word, i - 1);
        for (k = i; k <= wdlen; k ++)
        {
          altword[k - 1] = word[k];
        };
        altword[k - 1] = '\0';

/*printf("altword1 %s\n", altword); */

        if ((found = FIND_WORD(altword, pttrn)))
        {
          /*printf("\nInterpretation %d: \n", itprt);*/
          /*printf("word: %s; pattern:  %s\n", altword, pttrn);*/
         /* printf("insert\n");*/

          inner_form(altword, " ", " ", pttrn, Txt_Alt, 'F', 0, 0, INSERT);
          /*error_track(INSERT);*/
          break;

        }
        else
        {
          int      itprt_tmp, datptr_tmp, i, len;
          char     ch1, ch2;
          boolean  found = FALSE;
   


          len = strlen(altword);
          ch1 = altword[len - 1];
          switch (ch1)
          {
            case 'g':
            case 't': 
                      ch2 = altword[len - 2];
                      if (((ch1 == 't') && (ch2 != 's')) ||
                      ((ch1 == 'g') && ((ch2 != 'n') || (altword[len - 3] != 'i'
                       ))))
                      {
                        break;
                      };

            case 'd':
            case 's':
            case 'r':
      
                      itprt_tmp = itprt;
                      datptr_tmp = onewddat_ptr;
  
                      Find_wdform(altword);
                      for (i = datptr_tmp; i < onewddat_ptr; i++)
                      {
                        onewddat[i].errtype = INSERT;
                          /*error_track(INSERT);*/
                      };
                      found = (itprt_tmp < itprt);

                    if ((onewddat_ptr - datptr_tmp) == 2)
                    {
                      if (extralt_ptr == 1)
                      {
                        onewddat[Textwd].ptr3 = extral_alt[0];
                        extralt_ptr = 0;
                      }
                      else
                      {
                        if (extralt_ptr > 1)
                        {
                          extral_alt[extralt_ptr - 2] = extral_alt[extralt_ptr - 1];
                          extralt_ptr--;
                        }
                        else /* extral_ptr < 1 */
                        {
                          if (onewddat[Textwd].ptr3 == -1)
                          {
                            onewddat[Textwd].ptr1 = onewddat[Textwd].ptr2;
                            onewddat[Textwd].ptr2 = -1;
                          }
                          else
                          {
                            onewddat[Textwd].ptr2 = onewddat[Textwd].ptr3;
                            onewddat[Textwd].ptr3 = -1;
                          };
                        };
                      };
                    };
           
                      break;
          };  /* end of switch */

          if (found)
          {
            break; /* quit from for loop */
          }
          else
          {
            altword[0] = '\0';
            pttrn[0] = '\0'; 
          };
        };
      };

      if (neb[j] == word[i + 1])
      {
        strncpy(altword, word, i + 1);
        for (k = i + 2; k <= wdlen; k ++)
        {
          altword[k - 1] = word[k];
        };
        altword[k - 1] = '\0';

/* printf("altword2 %s\n", altword);*/


        if ((found = FIND_WORD(altword, pttrn)))
        {
          /*printf("\nInterpretation %d: \n", itprt);*/
          /*printf("word: %s; pattern:  %s\n", altword, pttrn);*/
          /*printf("insert\n");*/

          inner_form(altword, " ", " ", pttrn, Txt_Alt, 'F', 0, 0, INSERT);
          /*error_track(INSERT); */       

        }
        else
        {
          int      itprt_tmp, datptr_tmp, i, len;
          char     ch1, ch2;
          boolean  found = FALSE;
   


          len = strlen(altword);
          ch1 = altword[len - 1];
          switch (ch1)
          {
            case 'g':
            case 't': 
                      ch2 = altword[len - 2];
                      if (((ch1 == 't') && (ch2 != 's')) ||
                      ((ch1 == 'g') && ((ch2 != 'n') || (altword[len - 3] != 'i'
                       ))))
                      {
                        break;
                      };

            case 'd':
            case 's':
            case 'r':
      
                      itprt_tmp = itprt;
                      datptr_tmp = onewddat_ptr;

                      Find_wdform(altword);
                      for (i = datptr_tmp; i < onewddat_ptr; i++)
                      {
                        onewddat[i].errtype = INSERT;
                          /*error_track(INSERT);*/
                      };
                      found = (itprt_tmp < itprt);

                      if ((onewddat_ptr - datptr_tmp) == 2)
                    {
                      if (extralt_ptr == 1)
                      {
                        onewddat[Textwd].ptr3 = extral_alt[0];
                        extralt_ptr = 0;
                      }
                      else
                      {
                        if (extralt_ptr > 1)
                        {
                          extral_alt[extralt_ptr - 2] = extral_alt[extralt_ptr - 1];
                          extralt_ptr--;
                        }
                        else /* extral_ptr < 1 */
                        {
                          if (onewddat[Textwd].ptr3 == -1)
                          {
                            onewddat[Textwd].ptr1 = onewddat[Textwd].ptr2;
                            onewddat[Textwd].ptr2 = -1;
                          }
                          else
                          {
                            onewddat[Textwd].ptr2 = onewddat[Textwd].ptr3;
                            onewddat[Textwd].ptr3 = -1;
                          };
                        };
                      };
                    };



                      break;
          };  /* end of switch */

          if (found)
          {
            break; /* quit from for loop */
          }
          else
          {
            altword[0] = '\0';
            pttrn[0] = '\0'; 
          };
        };
      };

    };

    i ++;

  };
  
  Neighb_Ltr(word[wdlen], neb);
  neblen = strlen(neb);
  j = 0;
  while ((! found) && (j < neblen))
  {
    if (neb[j] == word[wdlen - 1])
    {
      strcpy(altword, word);
      altword[wdlen - 1] = altword[wdlen];
      altword[wdlen] = '\0';

      if ((found = FIND_WORD(altword, pttrn)))
      {
        /*printf("\nInterpretation %d: \n", itprt);*/
        /*printf("word: %s; pattern:  %s\n", altword, pttrn);*/
       /* printf("insert\n");*/

        inner_form(altword, " ", " ", pttrn, Txt_Alt, 'F', 0, 0, INSERT);
        /*error_track(INSERT); */      

      }
      else
      {
        int      itprt_tmp, datptr_tmp, i, len;
        char     ch1, ch2;
        boolean  found = FALSE;
   


        len = strlen(altword);
        ch1 = altword[len - 1];
        switch (ch1)
        {
          case 'g':
          case 't': 
                    ch2 = altword[len - 2];
                    if (((ch1 == 't') && (ch2 != 's')) ||
                      ((ch1 == 'g') && ((ch2 != 'n') || (altword[len - 3] != 'i'
                       ))))
                    {
                      break;
                    };

          case 'd':
          case 's':
          case 'r':
      
                    itprt_tmp = itprt;
                    datptr_tmp = onewddat_ptr;

                    Find_wdform(altword);
                    for (i = datptr_tmp; i < onewddat_ptr; i++)
                    {
                      onewddat[i].errtype = INSERT;
                        /*error_track(INSERT);*/
                    };
                    found = (itprt_tmp < itprt);

                    if ((onewddat_ptr - datptr_tmp) == 2)
                    {
                      if (extralt_ptr == 1)
                      {
                        onewddat[Textwd].ptr3 = extral_alt[0];
                        extralt_ptr = 0;
                      }
                      else
                      {
                        if (extralt_ptr > 1)
                        {
                          extral_alt[extralt_ptr - 2] = extral_alt[extralt_ptr - 1];
                          extralt_ptr--;
                        }
                        else /* extral_ptr < 1 */
                        {
                          if (onewddat[Textwd].ptr3 == -1)
                          {
                            onewddat[Textwd].ptr1 = onewddat[Textwd].ptr2;
                            onewddat[Textwd].ptr2 = -1;
                          }
                          else
                          {
                            onewddat[Textwd].ptr2 = onewddat[Textwd].ptr3;
                            onewddat[Textwd].ptr3 = -1;
                          };
                        };
                      };
                    };


                  
                    break;
        };  /* end of switch */

        if (found)
        {
          break; /* quit from for loop */
        }
        else
        {
          altword[0] = '\0';
          pttrn[0] = '\0'; 
        };
      };
    };

    j++;

  };

}


void  Ltr_omit(word)
char  word[];
{
  int          wdlen, i, j, k;
  char         altword[MAXWORDLEN + 1], pttrn[MAXPTRNS+1]; 
  boolean      found;

# ifdef  TITLE
  printf("checking omit\n");
# endif
/*printf("extralt_ptr %d\n", extralt_ptr);*/


  found = FALSE;
 
  wdlen = strlen(word);
 

  for (i = 97; i <= 122; i++)
  {
    altword[0] = i;
    altword[1] = '\0';

    strcat(altword, word);
    if ((found = FIND_WORD(altword, pttrn)))
    {
     /* printf("\nInterpretation %d: \n", itprt);*/
     /* printf("word: %s; pattern:  %s\n", altword, pttrn);*/
      /*printf("omit\n");*/
        
      inner_form(altword, " ", " ", pttrn, Txt_Alt, 'F', 0, 0, OMIT);
      /*error_track(OMIT);*/
      break;

    }
    else
    {
      int      itprt_tmp, datptr_tmp, i, len;
      char     ch1, ch2;
      boolean  found = FALSE;
   


      len = strlen(altword);
      ch1 = altword[len - 1];
      switch (ch1)
      {
          case 'g':
          case 't': 
                    ch2 = altword[len - 2];
                    if (((ch1 == 't') && (ch2 != 's')) ||
                      ((ch1 == 'g') && ((ch2 != 'n') || (altword[len - 3] != 'i'
                       ))))
                    {
                      break;
                    };

          case 'd':
          case 's':
          case 'r':
      
                    itprt_tmp = itprt;
                    datptr_tmp = onewddat_ptr;

                    Find_wdform(altword);
                    for (i = datptr_tmp; i < onewddat_ptr; i++)
                    {
                      onewddat[i].errtype = OMIT;
                        /*error_track(OMIT);*/
                    };
                    found = (itprt_tmp < itprt);

                    if ((onewddat_ptr - datptr_tmp) == 2)
                    {
                      if (extralt_ptr == 1)
                      {
                        onewddat[Textwd].ptr3 = extral_alt[0];
                        extralt_ptr = 0;
                      }
                      else
                      {
                        if (extralt_ptr > 1)
                        {
                          extral_alt[extralt_ptr - 2] = extral_alt[extralt_ptr - 1];
                          extralt_ptr--;
                        }
                        else /* extral_ptr < 1 */
                        {
                          if (onewddat[Textwd].ptr3 == -1)
                          {
                            onewddat[Textwd].ptr1 = onewddat[Textwd].ptr2;
                            onewddat[Textwd].ptr2 = -1;
                          }
                          else
                          {
                            onewddat[Textwd].ptr2 = onewddat[Textwd].ptr3;
                            onewddat[Textwd].ptr3 = -1;
                          };
                        };
                      };
                    };


                    
                    break;
      };  /* end of switch */

      if (found)
      {
        break; /* quit from for loop */
      }
      else
      {
        altword[0] = '\0';
        pttrn[0] = '\0'; 
      };
    };
  };


  i = 1;
  while ((! found) && (i <= wdlen))
  {
    for (k = 97; k <= 122; k ++)
    {
      strncpy(altword, word, i);

      altword[i] = k;
      altword[i + 1] = '\0';

      for(j = i + 1; j <= wdlen; j++)
      {
        altword[j] = word[j - 1];
      };
      altword[j] = '\0';


      if ((found = FIND_WORD(altword, pttrn)))
      {
       /* printf("\nInterpretation %d: \n", itprt);*/
        /*printf("word: %s; pattern:  %s\n", altword, pttrn);*/
        /*printf("omit\n");*/
        
        inner_form(altword, " ", " ", pttrn, Txt_Alt, 'F', 0, 0, OMIT);
        /*error_track(OMIT);*/

      }
      else
      {
        int      itprt_tmp, datptr_tmp, i, len;
        char     ch1, ch2;
        boolean  found = FALSE;
   


        len = strlen(altword);
        ch1 = altword[len - 1];
        switch (ch1)
        {
          case 'g':
          case 't': 
                    ch2 = altword[len - 2];
                    if (((ch1 == 't') && (ch2 != 's')) ||
                      ((ch1 == 'g') && ((ch2 != 'n') || (altword[len - 3] != 'i'
                       ))))
                    {
                      break;
                    };

          case 'd':
          case 's':
          case 'r':
      
                    itprt_tmp = itprt;
                    datptr_tmp = onewddat_ptr;

                    Find_wdform(altword);
                    for (i = datptr_tmp; i < onewddat_ptr; i++)
                    {
                      onewddat[i].errtype = OMIT;
                       /* error_track(OMIT);*/
                    };
                    found = (itprt_tmp < itprt);


                    if ((onewddat_ptr - datptr_tmp) == 2)
                    {
                      if (extralt_ptr == 1)
                      {
                        onewddat[Textwd].ptr3 = extral_alt[0];
                        extralt_ptr = 0;
                      }
                      else
                      {
                        if (extralt_ptr > 1)
                        {
                          extral_alt[extralt_ptr - 2] = extral_alt[extralt_ptr - 1];
                          extralt_ptr--;
                        }
                        else /* extral_ptr < 1 */
                        {
                          if (onewddat[Textwd].ptr3 == -1)
                          {
                            onewddat[Textwd].ptr1 = onewddat[Textwd].ptr2;
                            onewddat[Textwd].ptr2 = -1;
                          }
                          else
                          {
                            onewddat[Textwd].ptr2 = onewddat[Textwd].ptr3;
                            onewddat[Textwd].ptr3 = -1;
                          };
                        };
                      };
                    };


                    break;
        };  /* end of switch */

        if (found)
        {
          break; /* quit from for loop */
        }
        else
        {
          altword[0] = '\0';
          pttrn[0] = '\0'; 
        }; 
      };
    };
  
    i ++;
  };
}

void  Ltr_de_di(word)
char  word[];
{
  int          wdlen, i;
  char         altword[MAXWORDLEN + 1], pttrn[MAXPTRNS+1]; 
 
# ifdef  TITLE
  printf("checking de_di\n");
# endif

  wdlen = strlen(word) - 1;
  strcpy(altword, word);

  i = 0;
  while (i < wdlen)
  {
    if ((altword[i] == 'd') && (altword[i + 1] == 'i'))
    {
      altword[i + 1] = 'e';

      if (FIND_WORD(altword, pttrn))
      {
       /* printf("\nInterpretation %d: \n", itprt);*/
        /*printf("word: %s; pattern:  %s\n", altword, pttrn);*/
        /*printf("de_di\n");*/
        
        inner_form(altword, " ", " ", pttrn, Txt_Alt, 'F', 0, 0, DE_DI);
        /*error_track(DE_DI);*/
        break;
      }
      else
      {
        int      itprt_tmp, datptr_tmp, i, len;
        char     ch1, ch2;
        boolean  found = FALSE;
   


        len = strlen(altword);
        ch1 = altword[len - 1];
        switch (ch1)
        {
          case 'g':
          case 't': 
                    ch2 = altword[len - 2];
                    if (((ch1 == 't') && (ch2 != 's')) ||
                      ((ch1 == 'g') && ((ch2 != 'n') || (altword[len - 3] != 'i'
                       ))))
                    {
                      break;
                    };

          case 'd':
          case 's':
          case 'r':
      
                    itprt_tmp = itprt;
                    datptr_tmp = onewddat_ptr;

                    Find_wdform(altword);
                    for (i = datptr_tmp; i < onewddat_ptr; i++)
                    {
                      onewddat[i].errtype = DE_DI;
                       /* error_track(DE_DI);*/
                    };
                    found = (itprt_tmp < itprt);
          
                    if ((onewddat_ptr - datptr_tmp) == 2)
                    {
                      if (extralt_ptr == 1)
                      {
                        onewddat[Textwd].ptr3 = extral_alt[0];
                        extralt_ptr = 0;
                      }
                      else
                      {
                        if (extralt_ptr > 1)
                        {
                          extral_alt[extralt_ptr - 2] = extral_alt[extralt_ptr - 1];
                          extralt_ptr--;
                        }
                        else /* extral_ptr < 1 */
                        {
                          if (onewddat[Textwd].ptr3 == -1)
                          {
                            onewddat[Textwd].ptr1 = onewddat[Textwd].ptr2;
                            onewddat[Textwd].ptr2 = -1;
                          }
                          else
                          {
                            onewddat[Textwd].ptr2 = onewddat[Textwd].ptr3;
                            onewddat[Textwd].ptr3 = -1;
                          };
                        };
                      };
                    };


                  
                    break;
        };  /* end of switch */

        if (found)
        {
          break; /* quit from for loop */
        }
        else
        {
          altword[0] = '\0';
          pttrn[0] = '\0'; 
        };
      };

      strcpy(altword, word); 
    };
    
         
    i ++;
  };

}
  

void  Ltr_di_de(word)
char  word[];
{
  int          wdlen, i;
  char         altword[MAXWORDLEN + 1], pttrn[MAXPTRNS+1]; 

# ifdef  TITLE
  printf("checking di_de\n");
# endif

  wdlen = strlen(word) - 1;
  strcpy(altword, word);

  i = 0;
  while (i < wdlen)
  {
    if ((altword[i] == 'd') && (altword[i + 1] == 'e'))
    {
      altword[i + 1] = 'i';

      if (FIND_WORD(altword, pttrn))
      {
       /* printf("\nInterpretation %d: \n", itprt);*/
       /* printf("word: %s; pattern:  %s\n", altword, pttrn);*/
        /*printf("di_de\n");*/
        
        inner_form(altword, " ", " ", pttrn, Txt_Alt, 'F', 0, 0, DI_DE);
        /*error_track(DI_DE);*/
        break;
      }
      else
      {
        int      itprt_tmp, datptr_tmp, i, len;
        char     ch1, ch2;
        boolean  found = FALSE;
   


        len = strlen(altword);
        ch1 = altword[len - 1];
        switch (ch1)
        {
          case 'g':
          case 't': 
                    ch2 = altword[len - 2];
                    if (((ch1 == 't') && (ch2 != 's')) ||
                      ((ch1 == 'g') && ((ch2 != 'n') || (altword[len - 3] != 'i'
                       ))))
                    {
                      break;
                    };

          case 'd':
          case 's':
          case 'r':
      
                    itprt_tmp = itprt;
                    datptr_tmp = onewddat_ptr;

                    Find_wdform(altword);
                    for (i = datptr_tmp; i < onewddat_ptr; i++)
                    {
                      onewddat[i].errtype = DI_DE;
                        /*error_track(DI_DE);*/
                    };
                    found = (itprt_tmp < itprt);

                    if ((onewddat_ptr - datptr_tmp) == 2)
                    {
                      if (extralt_ptr == 1)
                      {
                        onewddat[Textwd].ptr3 = extral_alt[0];
                        extralt_ptr = 0;
                      }
                      else
                      {
                        if (extralt_ptr > 1)
                        {
                          extral_alt[extralt_ptr - 2] = extral_alt[extralt_ptr - 1];
                          extralt_ptr--;
                        }
                        else /* extral_ptr < 1 */
                        {
                          if (onewddat[Textwd].ptr3 == -1)
                          {
                            onewddat[Textwd].ptr1 = onewddat[Textwd].ptr2;
                            onewddat[Textwd].ptr2 = -1;
                          }
                          else
                          {
                            onewddat[Textwd].ptr2 = onewddat[Textwd].ptr3;
                            onewddat[Textwd].ptr3 = -1;
                          };
                        };
                      };
                    };


                  
                    break;
        };  /* end of switch */

        if (found)
        {
          break; /* quit from for loop */
        }
        else
        {
          altword[0] = '\0';
          pttrn[0] = '\0'; 
        };
      };

      strcpy(altword, word); 
    };
  
    i ++;

  };
  
}

void  Ltr_ei_ie(word)
char  word[];
{
  int          wdlen, i;
  char         altword[MAXWORDLEN + 1], pttrn[MAXPTRNS+1]; 
  
# ifdef  TITLE
  printf("checking ei_ie\n");
# endif

  wdlen = strlen(word) - 1;
  strcpy(altword, word);

  i = 0;
  while (i < wdlen)
  {
    if ((altword[i] == 'i') && (altword[i + 1] == 'e'))
    {
      altword[i] = 'e';
      altword[i + 1] = 'i';

      if (FIND_WORD(altword, pttrn))
      {
       /* printf("\nInterpretation %d: \n", itprt);*/
       /* printf("word: %s; pattern:  %s\n", altword, pttrn);*/
       /* printf("ei_ie\n");*/
        
        inner_form(altword, " ", " ", pttrn, Txt_Alt, 'F', 0, 0, EI_IE);
        /*error_track(EI_IE); */       
        break;
      }
      else
      {
        int      itprt_tmp, datptr_tmp, i, len;
        char     ch1, ch2;
        boolean  found = FALSE;
   
        len = strlen(altword);
        ch1 = altword[len - 1];
        switch (ch1)
        {
          case 'g':
          case 't': 
                    ch2 = altword[len - 2];
                    if (((ch1 == 't') && (ch2 != 's')) ||
                      ((ch1 == 'g') && ((ch2 != 'n') || (altword[len - 3] != 'i'
                       ))))
                    {
                      break;
                    };

          case 'd':
          case 's':
          case 'r':
      
                    itprt_tmp = itprt;
                    datptr_tmp = onewddat_ptr;

                    Find_wdform(altword);
                    for (i = datptr_tmp; i < onewddat_ptr; i++)
                    {
                      onewddat[i].errtype = EI_IE;
                       /* error_track(EI_IE);*/
                    };
                    found = (itprt_tmp < itprt);

                    if ((onewddat_ptr - datptr_tmp) == 2)
                    {
                      if (extralt_ptr == 1)
                      {
                        onewddat[Textwd].ptr3 = extral_alt[0];
                        extralt_ptr = 0;
                      }
                      else
                      {
                        if (extralt_ptr > 1)
                        {
                          extral_alt[extralt_ptr - 2] = extral_alt[extralt_ptr - 1];
                          extralt_ptr--;
                        }
                        else /* extral_ptr < 1 */
                        {
                          if (onewddat[Textwd].ptr3 == -1)
                          {
                            onewddat[Textwd].ptr1 = onewddat[Textwd].ptr2;
                            onewddat[Textwd].ptr2 = -1;
                          }
                          else
                          {
                            onewddat[Textwd].ptr2 = onewddat[Textwd].ptr3;
                            onewddat[Textwd].ptr3 = -1;
                          };
                        };
                      };
                    };


                  
                    break;
        };  /* end of switch */

        if (found)
        {
          break; /* quit from for loop */
        }
        else
        {
          altword[0] = '\0';
          pttrn[0] = '\0'; 
        };
      };

      strcpy(altword, word); 
    };
    
    
    i ++;

  };
  
}


void   Ltr_ie_ei(word)
char  word[];
{
  int          wdlen, i;
  char         altword[MAXWORDLEN + 1], pttrn[MAXPTRNS+1]; 
 
# ifdef  TITLE
  printf("checking ie_ei\n");
# endif

  wdlen = strlen(word) - 1;
  strcpy(altword, word);

  i = 0;
  while (i < wdlen)
  {
    if ((altword[i] == 'e') && (altword[i + 1] == 'i'))
    {
      altword[i] = 'i';
      altword[i + 1] = 'e';

      if (FIND_WORD(altword, pttrn))
      {
        /*printf("\nInterpretation %d: \n", itprt);*/
        /*printf("word: %s; pattern:  %s\n", altword, pttrn);*/
        /*printf("ie_ei\n");*/
        
        inner_form(altword, " ", " ", pttrn, Txt_Alt, 'F', 0, 0, IE_EI);
        /*error_track(IE_EI); */       
        break;
      }
      else
      {
        int      itprt_tmp, datptr_tmp, i, len;
        char     ch1, ch2;
        boolean  found = FALSE;
   


        len = strlen(altword);
        ch1 = altword[len - 1];
        switch (ch1)
        {
          case 'g':
          case 't': 
                    ch2 = altword[len - 2];
                    if (((ch1 == 't') && (ch2 != 's')) ||
                      ((ch1 == 'g') && ((ch2 != 'n') || (altword[len - 3] != 'i'
                       ))))
                    {
                      break;
                    };

          case 'd':
          case 's':
          case 'r':
      
                    itprt_tmp = itprt;
                    datptr_tmp = onewddat_ptr;

                    Find_wdform(altword);
                    for (i = datptr_tmp; i < onewddat_ptr; i++)
                    {
                      onewddat[i].errtype = IE_EI;
                       /* error_track(IE_EI);*/
                    };
                    found = (itprt_tmp < itprt);

                    if ((onewddat_ptr - datptr_tmp) == 2)
                    {
                      if (extralt_ptr == 1)
                      {
                        onewddat[Textwd].ptr3 = extral_alt[0];
                        extralt_ptr = 0;
                      }
                      else
                      {
                        if (extralt_ptr > 1)
                        {
                          extral_alt[extralt_ptr - 2] = extral_alt[extralt_ptr - 1];
                          extralt_ptr--;
                        }
                        else /* extral_ptr < 1 */
                        {
                          if (onewddat[Textwd].ptr3 == -1)
                          {
                            onewddat[Textwd].ptr1 = onewddat[Textwd].ptr2;
                            onewddat[Textwd].ptr2 = -1;
                          }
                          else
                          {
                            onewddat[Textwd].ptr2 = onewddat[Textwd].ptr3;
                            onewddat[Textwd].ptr3 = -1;
                          };
                        };
                      };
                    };


                  
                    break;
        };  /* end of switch */

        if (found)
        {
          break; /* quit from for loop */
        }
        else
        {
          altword[0] = '\0';
          pttrn[0] = '\0'; 
        };
      };

      strcpy(altword, word); 
    };
  
    i ++;

  };
  
}


void  Ltr_retain_e(word)
char  word[];
{
  int          wdlen, len, i, k;
  char         altword[MAXWORDLEN + 1], pttrn[MAXPTRNS+1], ch1, ch2, ch3; 

# ifdef  TITLE
  printf("checking retain_e\n");
# endif

  wdlen = strlen(word) - 1;
  
  len = wdlen - 3;
  for (i = len; i >= 0; i--)
  {
    ch1 = word[i];
    ch2 = word[i + 1];
    ch3 = word[i + 2];

    if (ch2 == 'e')
    {
      if (((ch1 == 'u') || (! Is_vowel(ch1))) && (Is_vowel(ch3)))
      {
        strncpy(altword, word, i + 1);
        for (k = i + 2; k <= wdlen; k ++)
        {
          altword[k - 1] = word[k];
        };
        altword[k - 1] = '\0';

        if (FIND_WORD(altword, pttrn))
        {
          /*printf("\nInterpretation %d: \n", itprt);*/
          /*printf("word: %s; pattern:  %s\n", altword, pttrn);*/
          /*printf("retain_e\n");*/
        
          inner_form(altword, " ", " ", pttrn, Txt_Alt, 'F', 0, 0, RETAIN_E);
          /*error_track(RETAIN_E);  */      
          break;
        }
        else
        {
          int      itprt_tmp, datptr_tmp, i, len;
          char     ch1, ch2;
          boolean  found = FALSE;
   


          len = strlen(altword);
          ch1 = altword[len - 1];
          switch (ch1)
          {
            case 'g':
            case 't': 
                      ch2 = altword[len - 2];
                      if (((ch1 == 't') && (ch2 != 's')) ||
                      ((ch1 == 'g') && ((ch2 != 'n') || (altword[len - 3] != 'i'
                       ))))
                      {
                        break;
                      };

            case 'd':
            case 's':
            case 'r':
      
                      itprt_tmp = itprt;
                      datptr_tmp = onewddat_ptr;

                      Find_wdform(altword);
                      for (i = datptr_tmp; i < onewddat_ptr; i++)
                      {
                        onewddat[i].errtype = RETAIN_E;
                          /*error_track(RETAIN_E);*/
                      };
                      found = (itprt_tmp < itprt);

                      if ((onewddat_ptr - datptr_tmp) == 2)
                    {
                      if (extralt_ptr == 1)
                      {
                        onewddat[Textwd].ptr3 = extral_alt[0];
                        extralt_ptr = 0;
                      }
                      else
                      {
                        if (extralt_ptr > 1)
                        {
                          extral_alt[extralt_ptr - 2] = extral_alt[extralt_ptr - 1];
                          extralt_ptr--;
                        }
                        else /* extral_ptr < 1 */
                        {
                          if (onewddat[Textwd].ptr3 == -1)
                          {
                            onewddat[Textwd].ptr1 = onewddat[Textwd].ptr2;
                            onewddat[Textwd].ptr2 = -1;
                          }
                          else
                          {
                            onewddat[Textwd].ptr2 = onewddat[Textwd].ptr3;
                            onewddat[Textwd].ptr3 = -1;
                          };
                        };
                      };
                    };


                  
                      break;
          };  /* end of switch */

          if (found)
          {
            break; /* quit from for loop */
          }
          else
          {
            altword[0] = '\0';
            pttrn[0] = '\0'; 
          };
        };
      };
    };
  };

}

    
void  Ltr_spc_trsp(ptr)
int  ptr;
{
  char  word1[MAXWORDLEN + 1], word2[MAXWORDLEN + 1], 
        altword1[MAXWORDLEN + 1], altword2[MAXWORDLEN + 1], 
        pttrn1[MAXPTRNS+1], pttrn2[MAXPTRNS+1];
  int   pos1, pos2, len1, len2, i, old_Textwd;

# ifdef  TITLE
  printf("checking spc_trsp\n");
# endif

  pos1 = wrongwd[ptr].pos;
  pos2 = wrongwd[ptr + 1].pos;
  if (pos2 == (pos1 + 2)) 
  {
    strcpy(word1, onewddat[wrongwd[ptr].code].word);
    strcpy(word2, onewddat[wrongwd[ptr + 1].code].word);

    len1 = strlen(word1);
    strncpy(altword1, word1, len1 - 1);
    altword1[len1-1] = '\0';
    altword2[0] = word1[len1 - 1];
    altword2[1] = '\0';
    strcat(altword2, word2);
  
    if ((FIND_WORD(altword1, pttrn1)) && (FIND_WORD(altword2, pttrn2)))
    {
      /*printf("\nInterpretation %d: \n", itprt);*/
     /* printf("word1: %s; pattern:  %s\n", altword1, pttrn1);*/
      /*printf("word2: %s; pattern:  %s\n", altword2, pttrn2);*/
     /* printf("spc_trsp\n");*/
     
      old_Textwd = Textwd;
      Textwd = wrongwd[ptr].code;
      inner_form(altword1, " ", " ", pttrn1, Txt_Alt, 'F', 0, 0, SPC_TRSP);
      Textwd = wrongwd[ptr + 1].code;
      inner_form(altword2, " ", " ", pttrn2, Txt_Alt, 'F', 0, 0, SPC_TRSP);
      /*error_track(SPC_TRSP);*/      

      Textwd = old_Textwd;
    }
    else
    {
      strcpy(altword1, word1);
      altword1[len1] = word2[0];
      altword1[len1 + 1] = '\0';
      len2 = strlen(word2) - 1;
      for (i = 0; i < len2; i++)
      {
        altword2[i] = word2[i + 1];
      };
      altword2[i] = '\0';

      if ((FIND_WORD(altword1, pttrn1)) && (FIND_WORD(altword2, pttrn2)))
      {
        /*printf("\nInterpretation %d: \n", itprt);*/
       /* printf("word1: %s; pattern:  %s\n", altword1, pttrn1);*/
       /* printf("word2: %s; pattern:  %s\n", altword2, pttrn2);*/
       /* printf("spc_trsp\n");*/
     
        old_Textwd = Textwd;
        Textwd = wrongwd[ptr].code;
        inner_form(altword1, " ", " ", pttrn1, Txt_Alt, 'F', 0, 0, SPC_TRSP);
        Textwd = wrongwd[ptr + 1].code;
        inner_form(altword2, " ", " ", pttrn2, Txt_Alt, 'F', 0, 0, SPC_TRSP);
        /*error_track(SPC_TRSP);*/
        Textwd = old_Textwd;
      };
    };
  };

}

/*
int  Ltr_added(word, itprt)
char  word[];
int   itprt;
{
  int          len, wdlen, prct[7], i, j, k, new_itprt;
  char         altword[MAXWORDLEN + 1], pttrn[MAXPTRNS+1]; 

  altword[0] = '\0';
  pttrn[0] = '\0';
 
  wdlen = strlen(word) - 1;
 

  for (i = 1; i < wdlen; i++)
  {
    strncpy(altword, word, i);
    for(j = i; j < wdlen; j++)
    {
      altword[j] = word[j + 1];
    };
    altword[j] = '\0';


    if (FIND_WORD(altword, pttrn))
    {
      new_itprt = Find_wdform(altword, itprt);
      if (new_itprt == itprt)
      {
        printf("\nInterpretation %d: \n", ++ itprt);
        printf("word: %s; pattern:  %s\n", altword, pttrn);
      }
      else
      {
        itprt = new_itprt;
      };
       
      printf("typing_error\n");
      printf("added\n");
       
    }
    else
    {
      altword[0] = '\0';
      pttrn[0] = '\0'; 
    };
  };

  return(itprt);
 
}
*/


/*************************************************************************/
/* Function to return the quantity(used in onewd_act.log) corresponding  */
/* to a num.                                                             */
/*************************************************************************/
void  quantity(num, qunt)
int  num;
char qunt[];
{
  strcpy(qunt, "");

  if (num <= 0)
  {
    strcpy(qunt, "none");
    return;
  };

  if (num == 1)
  {
    strcpy(qunt, "one");
    return;
  };

  if ((num > 1) && (num < 5))
  {
    strcpy(qunt, "few");
    return;
  };

  if ((num > 4) && (num < 9))
  {
    strcpy(qunt, "several");
    return;
  };

  strcpy(qunt, "many");
  return;
}



/************************************************************************/
/*   Function to set history varibles in onewd_act.log                  */
/************************************************************************/
void  history()
{
  char         qunt[QUNT_MAX + 1];
  static char  var[129];

  quantity(repeat, qunt);
  strcpy(var, "user_err(repeat,");
  strcat(var, qunt);
  strcat(var,")");
  mstvar(var, 0, "T");
  
  quantity(transp, qunt);
  strcpy(var, "user_err(transp,");
  strcat(var, qunt);
  strcat(var,")");
  mstvar(var, 0, "T");
    

  quantity(spc_trsp, qunt);
  strcpy(var, "user_err(spc_trsp,");
  strcat(var, qunt);
  strcat(var,")");
  mstvar(var, 0, "T");
  

  quantity(neighb, qunt);
  strcpy(var, "user_err(neighb,");
  strcat(var, qunt);
  strcat(var,")");
  mstvar(var, 0, "T");
  
  quantity(insert, qunt);
  strcpy(var, "user_err(insert,");
  strcat(var, qunt);
  strcat(var,")");
  mstvar(var, 0, "T");
  
  quantity(omit, qunt);
  strcpy(var, "user_err(omit,");
  strcat(var, qunt);
  strcat(var,")");
  mstvar(var, 0, "T");
  

  quantity(de_di, qunt);
  strcpy(var, "user_err(de_di,");
  strcat(var, qunt);
  strcat(var,")");
  mstvar(var, 0, "T");
  

  quantity(di_de, qunt);
  strcpy(var, "user_err(di_de,");
  strcat(var, qunt);
  strcat(var,")");
  mstvar(var, 0, "T");
  
  quantity(ei_ie, qunt);
  strcpy(var, "user_err(ei_ie,");
  strcat(var, qunt);
  strcat(var,")");
  mstvar(var, 0, "T");
  
  quantity(ie_ei, qunt);
  strcpy(var, "user_err(ie_ei,");
  strcat(var, qunt);
  strcat(var,")");
  mstvar(var, 0, "T");
  
  quantity(retain_e, qunt);
  strcpy(var, "user_err(retain_e,");
  strcat(var, qunt);
  strcat(var,")");
  mstvar(var, 0, "T");
  
}


/*************************************************************************/
/* Function to check what kind of structures the wrong word has, and fix */
/* coresponding logic varibles.                                          */
/*************************************************************************/
void  structure_check(word)
char  word[];
{
  int          len, i;
  char         ch1, ch2, ch3;
  boolean      rept = FALSE, nblt = FALSE, de = FALSE, di = FALSE, 
               ie = FALSE, ei = FALSE;
 
  len = strlen(word) - 1;
  i = 0;
  while ((i < len) && (! (rept && nblt && de && di && ie && ei)))
  {
    ch1 = word[i];
    ch2 = word[i + 1];

    if ((! rept) && (ch1 == ch2))
    {
      mstvar("has_st(rept)", 0, "T");
      rept = TRUE;
/*printf("has rept\n");*/

    };

    if ((! nblt) && (is_neighbour(ch1, ch2)))
    {
      mstvar("has_st(nblt)", 0, "T");
      nblt = TRUE;
/*printf("has nblt\n");*/


    };

    if ((! de) && ((ch1 == 'd') && (ch2 == 'e')))
    {
      mstvar("has_st(de)", 0, "T");
      de = TRUE;
/*printf("has de\n");*/


    };

    if ((! di) && ((ch1 == 'd') && (ch2 == 'i')))
    {
      mstvar("has_st(di)", 0, "T");
      di = TRUE;
/*printf("has di\n");*/


    };

    if ((! ie) && ((ch1 == 'i') && (ch2 == 'e')))
    {
      mstvar("has_st(ie)", 0, "T");
      ie = TRUE;
/*printf("has ie\n");*/


    };

    if ((! ei) && ((ch1 == 'e') && (ch2 == 'i')))
    {
      mstvar("has_st(ei)", 0, "T");
      ei = TRUE;
/*printf("has ei\n");*/


    };

    i++;

  };


  len = len - 3;
  for (i = len; i >= 0; i--)
  {
    ch1 = word[i];
    ch2 = word[i + 1];
    ch3 = word[i + 2];

    if (ch2 == 'e')
    {
      if (((ch1 == 'u') || (! Is_vowel(ch1))) && (Is_vowel(ch3)))
      {
        mstvar("has_st(silent_e)", 0, "T");
/*printf("has silent_e\n");*/
        break;

      }
    }
  }
}


/*************************************************************************/
/*   Function to check with document dictionary how many times the word  */
/*   has occured.                                                        */
/*************************************************************************/
int   word_occur(word)
char  word[];
{
  int  ptr, cmp, len;
  
  len = strlen(word);
  if (dcmdct_head[len] == -1) {
    char msg[100];

    sprintf(msg, "word %s is not in dmc_dct.", word);
    system_error(msg);
  }


  ptr = dcmdct_head[len];

  do  
  { 
    cmp = strcmp(word, dcm_dct[ptr].word);

    if (cmp == 0)
    {
/*
      if (maxfrq <= 15)
      {
        return(dcm_dct[ptr].count);
      }
      else
      {
        return((dcm_dct[ptr].count * 15) / maxfrq);
      };
*/
      return(scaled_word_occur(dcm_dct[ptr].count));

    };

    if (cmp < 0)
    {
      ptr = dcm_dct[ptr].left;
    }
    else
    {
      ptr = dcm_dct[ptr].right;
    };

  } while (ptr > 0);

  if (1) {
    char msg[100];

    sprintf(msg, "word %s is not in dmc_dct", word);
    system_error(msg);
  }
  printf("\n*** Program never goes here spell_typerr.c 102");
  exit(1); 
}


/************************************************************************/
/*  Function to compute the weight of an altenate.                      */
/************************************************************************/
float  weight(alt)
int  alt;
{
  float   w;
  int     freq = 0, ptr;
/*printf("alt == %d %s %s %d\n", alt,
                               onewddat[alt].word,
                               onewddat[alt].pttrn,
                               onewddat[alt].errtype);*/


  if ((ptr = dcmdct_search1(onewddat[alt].word, dcm_dct, dcmdct_head)) != -1)
  {
    freq = dcm_dct[ptr].count;
    if (freq < 0) freq = 0;
  };

  if (total == 0)
  {
    w = freq * (alpha + 1);
  }
  else
  {
    switch (onewddat[alt].errtype)
    {
      case REPEAT:    w = freq * (alpha + 1) + 100 * (repeat / total);
                      break;
      case TRANSP:    w = freq * (alpha + 1) + 100 * (transp / total);
                      break;
      case SPC_TRSP:  w = freq * (alpha + 1) + 100 * (spc_trsp / total);
                      break;
      case NEIGHB:    w = freq * (alpha + 1) + 100 * (neighb / total);
                      break;
      case INSERT:    w = freq * (alpha + 1) + 100 * (insert / total);
                      break;
      case OMIT:      w = freq * (alpha + 1) + 100 * (omit / total);
                      break;
      case DE_DI:     w = freq * (alpha + 1) + 100 * (de_di / total);
                      break;
      case DI_DE:     w = freq * (alpha + 1) + 100 * (di_de / total);
                      break;
      case EI_IE:     w = freq * (alpha + 1) + 100 * (ei_ie / total);
                      break;
      case IE_EI:     w = freq * (alpha + 1) + 100 * (ie_ei / total);
                      break;
      case RETAIN_E:  w = freq * (alpha + 1) + 100 * (retain_e / total);
                      break;
      case SPELLING:  w = freq * (alpha + 1) + 100 * (spelling / total);
                      break;
      case LOWER_LTR: w = freq * (alpha + 1) + 100 * (lower_ltr / total);
                      break;
      default:        /*printf("wrong error number %d\n", onewddat[alt].errtype);
                      printf("in procedure 'weight()', word: %s\n", 
                              onewddat[alt].word);
                      exit(0);*/

                      system_error("wrong error type.");
    };
  };

  return(w);
}

int      list_idx;
struct   {
           int   code;
           float weight;
         } alt_list[EXTRALTMAX];

/*************************************************************************/
/*Function to insert a word into alt_list. It will first check if a word */
/*is already in the alt_list. If yes, then store the word having a higher*/
/*  weight, otherwise insert the word itself                             */
/*************************************************************************/
void altlist_ins(code, weight)
int    code;
float  weight;
{
  int    i, cd;
  float  wt;
  
  for (i = 0; i < list_idx; i++)
  {
    cd = alt_list[i].code;
    wt = alt_list[i].weight;

    if (strcmp(onewddat[cd].word, onewddat[code].word) == 0)
    {
      if (weight > wt)
      {
        alt_list[i].code = code;
        alt_list[i].weight = weight;
        return;
      }
      else
      {
        return;
      };
    };
  };

  if (list_idx == EXTRALTMAX) {
    system_error("out of memory, alt_list is overflow.\n\n");
  }
  alt_list[list_idx].code = code;
  alt_list[list_idx++].weight = weight;
}
  

/************************************************************************/
/*  Function to sort the list of altenates according to some weights    */
/************************************************************************/
void  sort_alt(code)
int  code;
{
  int     i, j, temp1, cd;
  float   temp2;
/**&&&&&&&&&7/99&&&&&&&&**/
  char    word1[MAXWORDLEN + 1], word2[MAXWORDLEN + 1];
/**&&&&&&end7/99&&&&&&&&**/
 
/*
  info_print();

printf("extral alts: %d\n", extralt_ptr);
for (i = 0; i < extralt_ptr; i++)
{
  printf("%s\n", onewddat[extral_alt[i]].word);
};

*/

  list_idx = 0;

  if (onewddat[code].ptr1 != -1)
  {
    cd = onewddat[code].ptr1;
    altlist_ins(cd, weight(cd));
    
    if (onewddat[code].ptr2 != -1)
    {
      cd = onewddat[code].ptr2;
      altlist_ins(cd, weight(cd));

      if (onewddat[code].ptr3 != -1)
      {
        cd = onewddat[code].ptr3;
        altlist_ins(cd, weight(cd));
      };
    };
  };

  for (i = 0; i < extralt_ptr; i++)
  {
    cd = extral_alt[i];
    altlist_ins(cd, weight(cd));

   /* printf("extral word:  %s\n", onewddat[temp1].word);*/
  };
/*
printf("alt_list before sort:\n");
for (i = 0; i < list_idx; i++)
{
  printf("%s\n", onewddat[alt_list[i].code].word);
};*/

  for (i = 1; i < list_idx; i++)  /* bubble sorting the list */
  {
    for (j = (list_idx - 1); j >= i; j--)
    {
      if (alt_list[j].weight > alt_list[j - 1].weight)
      {
        temp1 = alt_list[j].code;
        temp2 = alt_list[j].weight;
        alt_list[j].code = alt_list[j - 1].code;
        alt_list[j].weight = alt_list[j - 1].weight;
        alt_list[j - 1].code = temp1;
        alt_list[j - 1].weight = temp2;
      };
    };
  };

/**********  
printf("alt_list after sort:\n");
for (i = 0; i < list_idx; i++)
{
  printf("%s\n", onewddat[alt_list[i].code].word);
};********/

/**&&&&&&&&&7/99&&&&&&&&**/ 

   strcpy(word1,onewddat[code].word);
   if( is_usr_replcmnt_word(word1, word2) )
       {  
         int    ptr;
         
         ptr = onewddat_ptr++;
        if (onewddat_ptr >= ONEWD_MAX) {
            system_error("out of memory, onewddat buffer is overflow.");
          }
             alt_list[2] = alt_list[1];
             alt_list[1] = alt_list[0];
             strcpy(onewddat[ptr].word, word2);
             strcpy(onewddat[ptr].root, "");
             strcpy(onewddat[ptr].suffix, "");
             onewddat[ptr].errtype = onewddat[code].errtype;
             onewddat[ptr].ptr1 = -1;
             onewddat[ptr].ptr2 = -1;
             onewddat[ptr].ptr3 = -1;
             strcpy(onewddat[ptr].pttrn,"U");
             onewddat[code].ptr1 = ptr;
             onewddat[ptr].errtype = 1;
             alt_list[0].code = ptr;
             if( list_idx < 3 ) list_idx++;   
        }
  
 /**&&&&&&end7/99&&&&&&&&**/

  temp1= 0;
  if (temp1 < list_idx)
  {
    onewddat[code].ptr1 = alt_list[temp1++].code;

    if (temp1 < list_idx)
    {
      onewddat[code].ptr2 = alt_list[temp1++].code;
    
      if (temp1 < list_idx)
      {
        onewddat[code].ptr3 = alt_list[temp1++].code;
      };
    };
  };

  
  j = 0;
  for (i = temp1; i < list_idx; i++)
  {
    extral_alt[j++] = alt_list[i].code;
  };

  extralt_ptr = j;

} /* end of sort_alt */


/************************************************************************/
/*  Function to update the value of alpha.                              */
/************************************************************************/
float  update_alpha(code1, err1, code2, err2)
int   code1, code2, err1, err2;
{
  int    freq1, freq2, ptr;
  float  rate1, rate2, old_alpha;

  if (total == 0)
  {
    return(alpha);
  };

  if ((err1 == 0) || (err2 == 0)) return alpha;
  
  if ((ptr = dcmdct_search1(onewddat[code1].word, dcm_dct, dcmdct_head)) != -1)
  {
    freq1 = dcm_dct[ptr].count;
    if (freq1 < 0) freq1 = 0;
  };
   
  if ((ptr = dcmdct_search1(onewddat[code2].word, dcm_dct, dcmdct_head)) != -1)
  {
    freq2 = dcm_dct[ptr].count;
    if (freq2 < 0) freq2 = 0;
  };
   
  switch (err1)
  {
      case REPEAT:    rate1 = (float)(100 * repeat / total);
                      break;
      case TRANSP:    rate1 = (float)(100 * transp / total);
                      break;
      case SPC_TRSP:  rate1 = (float)(100 * spc_trsp / total);
                      break;
      case NEIGHB:    rate1 = (float)(100 * neighb / total);
                      break;
      case INSERT:    rate1 = (float)(100 * insert / total);
                      break;
      case OMIT:      rate1 = (float)(100 * omit / total);
                      break;
      case DE_DI:     rate1 = (float)(100 * de_di / total);
                      break;
      case DI_DE:     rate1 = (float)(100 * di_de / total);
                      break;
      case EI_IE:     rate1 = (float)(100 * ei_ie / total);
                      break;
      case IE_EI:     rate1 = (float)(100 * ie_ei / total);
                      break;
      case RETAIN_E:  rate1 = (float)(100 * retain_e / total);
                      break;
      case SPELLING:  rate1 = (float)(100 * spelling / total);
                      break;
      case LOWER_LTR: rate1 = (float)(100 * lower_ltr / total);
                      break;
      default:        /*printf("wrong error number %d\n", err1);
                      printf("in procedure 'update_alpha()' with err1 \n");
                      exit(0);*/

                      system_error("wrong error type.");
  };

  switch (err2)
  {
      case REPEAT:    rate2 = (float)(100 * repeat / total);
                      break;
      case TRANSP:    rate2 = (float)(100 * transp / total);
                      break;
      case SPC_TRSP:  rate2 = (float)(100 * spc_trsp / total);
                      break;
      case NEIGHB:    rate2 = (float)(100 * neighb / total);
                      break;
      case INSERT:    rate2 = (float)(100 * insert / total);
                      break;
      case OMIT:      rate2 = (float)(100 * omit / total);
                      break;
      case DE_DI:     rate2 = (float)(100 * de_di / total);
                      break;
      case DI_DE:     rate2 = (float)(100 * di_de / total);
                      break;
      case EI_IE:     rate2 = (float)(100 * ei_ie / total);
                      break;
      case IE_EI:     rate2 = (float)(100 * ie_ei / total);
                      break;
      case RETAIN_E:  rate2 = (float)(100 * retain_e / total);
                      break;
      case SPELLING:  rate2 = (float)(100 * spelling / total);
                      break;
      case LOWER_LTR: rate2 = (float)(100 * lower_ltr / total);
                      break;
      default:        /*printf("wrong error number %d\n", err2);
                      printf("in procedure 'update_alpha()' with err2\n");
                      exit(0);*/

                      system_error("wrong error type.");
  };

  if ((freq1 - freq2) == 0)
  {
    return(alpha);
  }
  else
  {
    old_alpha = alpha;
    alpha = (float) ((rate2 - rate1) / (freq1 - freq2));
    if (alpha < 0)
    {
      return(old_alpha);
    }
    else
    {
      alpha = (float) ((old_alpha + alpha) / 2);
      return(alpha);
    };
  };

} /* end of update_alpha */


/*************************************************************************/
/*   Function to determin alternative words for a wrong word             */
/*************************************************************************/
void  alt_word(ptr)
int  ptr;
{
  int          code, pos1, pos2, i;
  char         word[MAXWORDLEN + 1], qunt[QUNT_MAX + 1];
  static char  var[129];
  static long  prct[5] = {100, 85, 65, 50, 25};
  boolean      do_repeat = FALSE, do_transp = FALSE, do_spc_trsp = FALSE, 
               do_neighb = FALSE, do_insert = FALSE, do_omit = FALSE,
               do_de_di = FALSE, do_di_de = FALSE, do_ei_ie = FALSE, 
               do_ie_ei = FALSE, do_retain_e = FALSE,
               done_repeat = FALSE, done_transp = FALSE, 
               done_spc_trsp = FALSE, done_neighb = FALSE, 
               done_insert = FALSE, done_omit = FALSE,
               done_de_di = FALSE, done_di_de = FALSE, done_ei_ie = FALSE, 
               done_ie_ei = FALSE, done_retain_e = FALSE;

  extralt_ptr = 0;

  code = wrongwd[ptr].code;
  strcpy(word, onewddat[code].word);

/*printf("wrong word: %s\n\n", word);*/

  structure_check(word);

  if (ptr < (wrongwd_ptr - 1))
  {
    pos1 = wrongwd[ptr].pos;
    pos2 = wrongwd[ptr + 1].pos;
    if (pos1 == (pos2 - 2)) 
    {
      mstvar("has_st(cnsctv)", 0, "T");
      cnsctv_wrngwd = TRUE;
    }
    else
    {
      cnsctv_wrngwd = FALSE;
    };

  };

  wd_occur = word_occur(word);
  quantity(wd_occur, qunt);
  strcpy(var, "wd_occur(");
  strcat(var, qunt);
  strcat(var,")");
  mstvar(var, 0, "T");
  
  itprt = 0;
  i = 0;
  Txt_Alt = 'A';
  Textwd = code;
  
  while (i < 5) 
  {
    boolean  atl_act = FALSE;
    void     rstr_actprg();

/*printf("\npercent %d%%\n\n", prct[i]);*/

    mstcls("c??", "D", 1, prct[i] - 1, 0);
    solprb();

    if (!do_repeat)
    {
      do_repeat = getval(0, "action(repeat)");
      atl_act = atl_act || do_repeat;
    };

    if (!do_transp)
    {
      do_transp = getval(0, "action(transp)");
      atl_act = atl_act || do_transp;
    };

    if (!do_spc_trsp)
    { 
      do_spc_trsp = getval(0, "action(spc_trsp)");
      atl_act = atl_act || do_spc_trsp;
    };

    if (!do_neighb)
    {
      do_neighb = getval(0, "action(neighb)");
      atl_act = atl_act || do_neighb;
    };

    if (!do_insert)
    {
      do_insert = getval(0, "action(insert)");
      atl_act = atl_act || do_insert;
    };

    if (!do_omit)
    {
      do_omit = getval(0, "action(omit)");
      atl_act = atl_act || do_omit;
    };

    if (!do_de_di)
    {
      do_de_di = getval(0, "action(de_di)");
      atl_act = atl_act || do_de_di;
    };

    if (!do_di_de)
    {
      do_di_de = getval(0, "action(di_de)");
      atl_act = atl_act || do_di_de;
    };

    if (!do_ei_ie)
    {
      do_ei_ie = getval(0, "action(ei_ie)");
      atl_act = atl_act || do_ei_ie;
    };

    if (!do_ie_ei)
    {
      do_ie_ei = getval(0, "action(ie_ei)");
      atl_act = atl_act || do_ie_ei;
    };

    if (!do_retain_e)
    {
      do_retain_e = getval(0, "action(retain_e)");
      atl_act = atl_act || do_retain_e;
    };



    if (!atl_act)
    {
      mstcls("c??", "A", 1, prct[i++] - 1, 0);
      continue;
    };

    retprb("FindWdForm");

    if ((!done_repeat) && (do_repeat))
    {
      Ltr_repeat(word);
      done_repeat = TRUE;
    };

    if ((!done_transp) && (do_transp))
    {
      Ltr_transp(word);
      done_transp = TRUE;
    };

    if ((!done_spc_trsp) && (do_spc_trsp))
    { 
      Ltr_spc_trsp(ptr);
      done_spc_trsp = TRUE;
    };

    if ((!done_neighb) && (do_neighb))
    {
      Ltr_neighb(word);
      done_neighb = TRUE;
    };

    if ((!done_insert) && (do_insert))
    {
      Ltr_insert(word);
      done_insert = TRUE;
    };

    if ((!done_omit) && (do_omit))
    {
      Ltr_omit(word);
      done_omit = TRUE;
    };

    if ((!done_de_di) && (do_de_di))
    {
      Ltr_de_di(word);
      done_de_di = TRUE;
    };

    if ((!done_di_de) && (do_di_de))
    {
      Ltr_di_de(word);
      done_di_de = TRUE;
    };

    if ((!done_ei_ie) && (do_ei_ie))
    {
      Ltr_ei_ie(word);
      done_ei_ie = TRUE;
    };

    if ((!done_ie_ei) && (do_ie_ei))
    {
      Ltr_ie_ei(word);
      done_ie_ei = TRUE;
    };

    if ((!done_retain_e) && (do_retain_e))
    {
      Ltr_retain_e(word);
      done_retain_e = TRUE;
    };

    rstr_actprg(word);
    mstcls("c??", "A", 1, prct[i++] - 1, 0);

  };

  if (TRUE)
  {
    boolean  atl_act = FALSE;
    void     rstr_actprg();


    solprb();

    if (!do_repeat)
    {
      do_repeat = getval(0, "action(repeat)");
      atl_act = atl_act || do_repeat;
    };

    if (!do_transp)
    {
      do_transp = getval(0, "action(transp)");
      atl_act = atl_act || do_transp;
    };

    if (!do_spc_trsp)
    { 
      do_spc_trsp = getval(0, "action(spc_trsp)");
      atl_act = atl_act || do_spc_trsp;
    };

    if (!do_neighb)
    {
      do_neighb = getval(0, "action(neighb)");
      atl_act = atl_act || do_neighb;
    };

    if (!do_insert)
    {
      do_insert = getval(0, "action(insert)");
      atl_act = atl_act || do_insert;
    };

    if (!do_omit)
    {
      do_omit = getval(0, "action(omit)");
      atl_act = atl_act || do_omit;
    };

    if (!do_de_di)
    {
      do_de_di = getval(0, "action(de_di)");
      atl_act = atl_act || do_de_di;
    };

    if (!do_di_de)
    {
      do_di_de = getval(0, "action(di_de)");
      atl_act = atl_act || do_di_de;
    };

    if (!do_ei_ie)
    {
      do_ei_ie = getval(0, "action(ei_ie)");
      atl_act = atl_act || do_ei_ie;
    };

    if (!do_ie_ei)
    {
      do_ie_ei = getval(0, "action(ie_ei)");
      atl_act = atl_act || do_ie_ei;
    };

    if (!do_retain_e)
    {
      do_retain_e = getval(0, "action(retain_e)");
      atl_act = atl_act || do_retain_e;
    };



    if (atl_act)
    {
   
    retprb("FindWdForm");

    if ((!done_repeat) && (do_repeat))
    {
      Ltr_repeat(word);
      done_repeat = TRUE;
    };

    if ((!done_transp) && (do_transp))
    {
      Ltr_transp(word);
      done_transp = TRUE;
    };

    if ((!done_spc_trsp) && (do_spc_trsp))
    { 
      Ltr_spc_trsp(ptr);
      done_spc_trsp = TRUE;
    };

    if ((!done_neighb) && (do_neighb))
    {
      Ltr_neighb(word);
      done_neighb = TRUE;
    };

    if ((!done_insert) && (do_insert))
    {
      Ltr_insert(word);
      done_insert = TRUE;
    };

    if ((!done_omit) && (do_omit))
    {
      Ltr_omit(word);
      done_omit = TRUE;
    };

    if ((!done_de_di) && (do_de_di))
    {
      Ltr_de_di(word);
      done_de_di = TRUE;
    };

    if ((!done_di_de) && (do_di_de))
    {
      Ltr_di_de(word);
      done_di_de = TRUE;
    };

    if ((!done_ei_ie) && (do_ei_ie))
    {
      Ltr_ei_ie(word);
      done_ei_ie = TRUE;
    };

    if ((!done_ie_ei) && (do_ie_ei))
    {
      Ltr_ie_ei(word);
      done_ie_ei = TRUE;
    };

    if ((!done_retain_e) && (do_retain_e))
    {
      Ltr_retain_e(word);
      done_retain_e = TRUE;
    };

    rstr_actprg(word);
    };
    
  };
  
  rstprb("A");

  sort_alt(code);
}



void  error_check(wrongwd_idx)
int  wrongwd_idx;
{
  retprb("DetermineAct");
  history();
  alt_word(wrongwd_idx);
}

/************************************************************************/
/*  Function to record the errors user made most recently.              */
/************************************************************************/
void  error_record(error)
int  error;
{
  int   ptr;

/*
printf("head =%d\n", errhstry_head);
printf("ptr = %d\n", errhstry_ptr);
printf("error = %d\n", error);
*/
  if (error == 0) return;

  err_hstry[errhstry_ptr++] = error;
  errhstry_ptr = errhstry_ptr % (RCNTERR_MAX + 1);
  if (errhstry_ptr == errhstry_head)
  {
    err_hstry[errhstry_head ++] = 0;
    errhstry_head = errhstry_head % (RCNTERR_MAX + 1);
  };

  total = 0;
  repeat = 0;
  transp = 0;
  spc_trsp = 0;
  neighb = 0;
  insert = 0;
  omit = 0;
  de_di = 0;
  di_de = 0;
  ei_ie = 0;
  ie_ei = 0;
  retain_e = 0;
  spelling = 0;
  lower_ltr = 0;

  ptr = errhstry_head;
  while (ptr != errhstry_ptr)
  {
    switch (err_hstry[ptr])
    {
      case REPEAT:    repeat++;
                      break;
      case TRANSP:    transp++;
                      break;
      case SPC_TRSP:  spc_trsp++;
                      break;
      case NEIGHB:    neighb++;
                      break;
      case INSERT:    insert++;
                      break;
      case OMIT:      omit++;
                      break;
      case DE_DI:     de_di++;
                      break;
      case DI_DE:     di_de++;
                      break;
      case EI_IE:     ei_ie++;
                      break;
      case IE_EI:     ie_ei++;
                      break;
      case RETAIN_E:  retain_e++;
                      break;
      case SPELLING:  spelling++;
                      break;
      case LOWER_LTR: lower_ltr++;
                      break;
         
      /**&&&&&&&&&7/99&&&&&&&&**/
       case USR_RPLCMNT:   break;
      /**&&&&&&end7/99&&&&&&&&**/
      
      default:        /*printf("wrong error number %d\n", err_hstry[ptr]);
                      exit(0);*/

                      system_error("wrong error type.");
      
    };

    total ++;
    ptr++;
    ptr = ptr % (RCNTERR_MAX + 1);
  };
 
}


/***************************************************************************/
/*  Function to print out the context of a wrong word.                     */
/***************************************************************************/
void   print_context()
{
  int   i, code, count = 0, start, end;
  char  ch;

  start = spos - 1;
  while ((start >= 0) && (count < 5))
  {
    if (innertext[start --] >= 0)
    {
      count++;
    };
  };

  if (start < 0)
  {
    start = 0;
  };

  count = 0;
  printf("... ");
  for (i = start; i <= spos; i++)
  {
    code = innertext[i];
    if (code < 0)
    {
      ch = - code;
      if (ch == '\n')
      {
        ch = ' ';
      };

      printf("%c", ch);
      count ++;
    }
    else
    {
      printf("%s", onewddat[code].word);
      count = count + strlen(onewddat[code].word);
    };
  };
  if ((spos + 1) == innertext_ptr)
  {
    printf (" ...\n\n");
    return;
  };

  printf("\n");

  count = count + 5;
  ch = ' ';
  for (i = 0; i < count; i++)
  {
    printf("%c", ch);
  };

  /*code = innertext[spos];
  printf("%s", onewddat[code].word);*/
  
  /*count = count + strlen(onewddat[code].word);
  ch = ' ';
  for (i = 0; i < count; i++)
  {
    printf("%c", ch);
  };*/

  end = spos + 1;
  count = 0;
  while ((end < innertext_ptr) && (count < 5))
  {
    if (innertext[end++] >= 0)
    {
      count++;
    };
  };

 
  for (i = spos + 1; i < end; i++)
  { 
    code = innertext[i];
    if (code < 0)
    {
      ch = - code;
      if (ch == '\n')
      {
        ch = ' ';
      };

      printf("%c", ch);
    }
    else
    {
      printf("%s", onewddat[code].word);
    };
  };
  printf(" ...\n");

}

/*-------------------------------------------------------------------------
   function:  prompt_print(msg, word, prompt, expln1, expln2, expln3, expln4,
                           expln5)
              print prompt sign and corresponding information.
---------------------------------------------------------------------------*/
void  prompt_print(msg, word, prompt, expln1, expln2, expln3, expln4, expln5)
char *msg, *word, *prompt, *expln1, *expln2, *expln3, *expln4, *expln5;
{
  int    splen, i, msglen, wdlen, isone, isall;
  char   spaces[80];


  wdlen = strlen(word);

  isone = strcmp(msg, "accept one");
  isall = strcmp(msg, "accept all");
  if ((isone == 0) || (isall == 0))
  {
    char  str[22];
    
    if (isone == 0)
    {
      strcpy(str, "(for THIS occurrence)");
    }
    else
    {
      strcpy(str, "(for ALL occurrences)");
    };

    printf("\n\n Accept Word --> %s", word);
    splen = 24 - wdlen;
    if (splen < 0 ) { splen = 0;};
    for (i = 0; i < splen; i++)
    {
      spaces[i] = ' ';
    };
    spaces[i] = '\0';

    printf("%s| %s\n", spaces, expln1);
    printf("                 %s   | %s\n", str, expln2);
    printf("\n");

    splen = 13 - strlen(prompt);
    for (i = 0; i < splen; i++)
    {
      printf(" ");
    };
    printf("%s >> ", prompt);
    return;
  };

  msglen = strlen(msg);

  splen = 12 - msglen;
  for (i = 0; i < splen; i++)
  {
    spaces[i] = ' ';
  };
  spaces[i] = '\0';

  printf("\n\n%s%s --> %s", spaces, msg, word);

  splen = 24 - wdlen;
  if (splen < 0 ) { splen = 0;};

  for (i = 0; i < splen; i++)
  {
    spaces[i] = ' ';
  };
  spaces[i] = '\0';

  printf("%s| %s\n", spaces, expln1);


  for (i = 0; i < 41; i++)
  {
    spaces[i] = ' ';
  };
  spaces[i] = '\0';

  if (strcmp(expln2, "") != 0)
  {
    printf("%s| %s\n", spaces, expln2);
    if (strcmp(expln3, "") != 0)
    {
      printf("%s| %s\n", spaces, expln3);
      if (strcmp(expln4, "") != 0)
      {
        printf("%s| %s\n", spaces, expln4);
        if (strcmp(expln5, "") != 0)
        {
          printf("%s| %s\n", spaces, expln5);
        };
      };
    };
  };
  printf("\n");

  splen = 13 - strlen(prompt);
  for (i = 0; i < splen; i++)
  {
    printf(" ");
  };
  printf("%s >> ", prompt);

}
  
/*-------------------------------------------------------------------------
   function:  altrnt_print(word, alt1, alt2, alt3)
              print alternatives and corresponding information.
---------------------------------------------------------------------------*/
void  altrnt_print(word, alt1, alt2, alt3)
char *word, *alt1, *alt2, *alt3;
{
  int    splen, i;
  char   spaces[80], expl1[30], expl2[30], expl3[30], expl4[30], expl5[30];
         

  strcpy(expl1, "Select an alternative:");
  strcpy(expl2, "type number of selection,");
  strcpy(expl3, "press return for '1',");
  strcpy(expl4, "type '0' to delete word,");
  strcpy(expl5, "or type corrected word.");
 
  printf("\n  Wrong Word --> %s\n\n", word);
  if (strcmp(alt1, "") == 0)
  {
    printf("Alternatives --> 1. (Accept word as is,  | %s\n", expl1);
    printf("                    for ALL occurrences) | %s\n", expl2);
    printf("                 2. (Accept word as is,  | %s\n", expl3);
    printf("                    for THIS occurrence) | %s\n", expl4);
    printf("                                         | %s\n", expl5);
  }
  else
  {
    splen = 21 - strlen(alt1);
    if (splen < 0 ) { splen = 0;};
    for (i = 0; i < splen; i++)
    {
      spaces[i] = ' ';
    };
    spaces[i] = '\0';
    printf("Alternatives --> 1. %s%s| %s\n", alt1, spaces, expl1);
    
    if (strcmp(alt2, "") == 0)
    {
      printf("                 2. (Accept word as is,  | %s\n", expl2);
      printf("                    for ALL occurrences) | %s\n", expl3);
      printf("                 3. (Accept word as is,  | %s\n", expl4);
      printf("                    for THIS occurrence) | %s\n", expl5);
    }
    else
    {
      splen = 21 - strlen(alt2);
      if (splen < 0 ) { splen = 0;};
      for (i = 0; i < splen; i++)
      {
        spaces[i] = ' ';
      };
      spaces[i] = '\0';
      printf("                 2. %s%s| %s\n", alt2, spaces, expl2);

      if (strcmp(alt3, "") == 0)
      {
        printf("                 3. (Accept word as is,  | %s\n", expl3);
        printf("                    for ALL occurrences) | %s\n", expl4);
        printf("                 4. (Accept word as is,  | %s\n", expl5);
        printf("                    for THIS occurrence) |\n");
      }
      else
      {
        splen = 21 - strlen(alt3);
        if (splen < 0 ) { splen = 0;};
        for (i = 0; i < splen; i++)
        {
          spaces[i] = ' ';
        };
        spaces[i] = '\0';
        printf("                 3. %s%s| %s\n", alt3, spaces, expl3);

        printf("                 4. (Accept word as is,  | %s\n", expl4);
        printf("                    for ALL occurrences) | %s\n", expl5);
        printf("                 5. (Accept word as is,  |\n");
        printf("                    for THIS occurrence) |\n");
      };
    };
  };
  
  printf("\n");
  printf("       SELECT >> ");
}
  

/*-------------------------------------------------------------------------
   function:  classification_print()
              print the abbreviations of the classification for user to 
              choose.
   input:     none.
   output:    none.
---------------------------------------------------------------------------*/

void  classification_print()

{

  printf("\n  Classification                         |\n");
  printf("                                         | Classify word using following\n");
  printf("                                         | abbreviations (example: 'nti').\n");
  printf("                                         | Press return to skip classification.\n");
  printf("                                         |\n");
  printf("                                         |   n ---- noun\n");
  printf("                                         |   o ---- irregular noun\n");
  printf("                                         |   N ---- plural\n");
  printf("                                         |   t ---- vt (transitive verb)\n");
  printf("                                         |   u ---- irregular vt\n");
  printf("                                         |   i ---- vi (intransitive verb)\n");
  printf("                                         |   j ---- irregular vi\n");
  printf("                                         |   a ---- adjective\n");
  printf("                                         |   y ---- adverb\n");
  printf("                                         |   c ---- conjunction\n");
  printf("                                         |   p ---- preposition\n");
  printf("                                         |   q ---- interjection\n");
  printf("                                         |   r ---- pronoun\n");
  printf("                                         |   E ---- definite article\n");
  printf("                                         |   e ---- indefinite article\n");
  printf("                                         |   x ---- auxiliary verb (present)\n");
  printf("                                         |   X ---- auxiliary verb (past)\n");
  printf("                                         |   A ---- abbreviation\n");
  printf("                                         |   U ---- udefined\n\n");
       
  printf("       SELECT >> ");

}

  
/*-------------------------------------------------------------------------
    function: insert_rplcall(oldcode, newcode)
              insert a word, accepted as is for ALL occurrences, into the 
              list rplcall.
    input:    oldcode: the code of the word to be inserted.
              newcode: the code after user fix the word.
    output:   none
---------------------------------------------------------------------------*/
void  insert_rplcall(oldcode, newcode)
int  oldcode, newcode;
{
  rplcall  *ptr;

  ptr = (rplcall *)malloc(sizeof(rplcall));

  ptr->oldcode = oldcode;
  ptr->newcode = newcode;
  ptr->next = rplcall_ptr;
  rplcall_ptr = ptr;

}


/*-------------------------------------------------------------------------
    function: replace_all(wordcode)
              check if word is in the list of rplcall.
    input:    wordcode: the code of the word to be checked.
    output:   >= 0: the word is in the list, return the newcode.
              -1  : the word is not in the list.
---------------------------------------------------------------------------*/
int   replace_all(wordcode)
int     wordcode;
{
  rplcall  *ptr;

  ptr = rplcall_ptr;
  while (ptr != NULL)
  {
    if (ptr->oldcode == wordcode)
    {
      return(ptr->newcode);
    };
    ptr = ptr->next;
  };

  return(-1);
}


/*-------------------------------------------------------------------------
   function:  free_rplcall()
              free the memories occupied by the lis rplcall.
   input:     none.
   output:    none.
---------------------------------------------------------------------------*/
void  free_rplcall()
{
  rplcall  *ptr, *temp;

  ptr = rplcall_ptr;
  while (ptr != NULL)
  {
    temp = ptr->next;
    free(ptr);
    ptr = temp;
  };
}
    
/*************************************************************************/
/* Function to ask user to fix a wrong word, and return the code of the  */
/* correct word.                                                       */
/*************************************************************************/
int  fix_a_word(code)
int     code;
{

  int     alt1 = -1, alt2 = -1, alt3 = -1, num = 0, line, ptr, alt_code,
          correction_code[4];
  char    up1_word[MAXWORDLEN + 1], pttrn[MAXPTRNS+1], ch, 
          altwd1[MAXWORDLEN + 1], altwd2[MAXWORDLEN + 1], 
          altwd3[MAXWORDLEN + 1], ans[MAXWORDLEN + 1], 
          tmp[MAXWORDLEN + 1], wrong_wd[MAXWORDLEN + 1];
  boolean lower_ltr = FALSE, word_found;
  
/**&&&&&&&&&7/99&&&&&&&&**/
  char    word2[MAXWORDLEN + 1];
/**&&&&&&end7/99&&&&&&&&**/


  strcpy(wrong_wd, onewddat[code].word);

printf("\n\n----------------------------------------------------------\n");
  printf("Wrong Word: %s\n", wrong_wd);
  printf("in line %d: \n", text_line);
  print_context();
  printf("----------------------------------------------------------\n\n");

  altwd1[0] = '\0';
  altwd2[0] = '\0';
  altwd3[0] = '\0';

  already_corrected(wrong_wd, correction_code);
  if (correction_code[0] != -1) {
    strcpy(altwd1, onewddat[correction_code[0]].word);
    alt1 = correction_code[0];
    num++;
    
    if (correction_code[1] != -1) {
      strcpy(altwd2, onewddat[correction_code[1]].word);
      alt2 = correction_code[1];
      num++;
    
      if (correction_code[2] != -1) {
        strcpy(altwd3, onewddat[correction_code[2]].word);
        alt3 = correction_code[2];
        num++;
      }
    }
  }
  
  if ((lower_ltr = ((onewddat[code].errtype == LOWER_LTR) &&
                   (strcmp(onewddat[code].pttrn, " ") != 0))))
  {
    int    ptr;

    strcpy(up1_word, onewddat[code].word);
    up1_word[0] = toupper(up1_word[0]);

    ptr = onewddat_ptr++;
    if (onewddat_ptr >= ONEWD_MAX) {
      system_error("out of memory, onewddat buffer is overflow.");
    }
    strcpy(onewddat[ptr].word, up1_word);
    strcpy(onewddat[ptr].root, onewddat[code].root);
    strcpy(onewddat[ptr].suffix, onewddat[code].suffix);
    onewddat[ptr].errtype = onewddat[code].errtype;
    onewddat[ptr].ptr1 = onewddat[code].ptr1;
    onewddat[ptr].ptr2 = onewddat[code].ptr2;
    onewddat[ptr].ptr3 = onewddat[code].ptr3;

    switch(num) {
      case 0: strcpy(altwd1, up1_word); 
              alt1 = ptr;
              num++;
              break;
      case 1: if (strcmp(up1_word, altwd1) != 0) {
                strcpy(altwd2, up1_word);
                alt2 = ptr; 
                num++;
              }
              break;
      case 2: if ((strcmp(up1_word, altwd1) != 0) &&
                  (strcmp(up1_word, altwd2) != 0))   {
                strcpy(altwd3, up1_word);
                alt3 = ptr; 
                num++;
              }
              break;
    }
  }


  if ((alt_code = onewddat[code].ptr1) != -1)
  {

    switch(num)
    {
      case 0: strcpy(altwd1, onewddat[alt_code].word); 
              alt1 = alt_code;
              num++;
              break;
      case 1: if (strcmp(onewddat[alt_code].word, altwd1) != 0) {
                strcpy(altwd2, onewddat[alt_code].word);
                alt2 = alt_code;
                num++;
              }
              break;
      case 2: if ((strcmp(onewddat[alt_code].word, altwd1) != 0) &&
                  (strcmp(onewddat[alt_code].word, altwd2) != 0))   {
                strcpy(altwd3, onewddat[alt_code].word);
                alt3 = alt_code;
                num++;
              }
              break;
    }
       
  }
 

  if ((alt_code = onewddat[code].ptr2) != -1)
  {
    switch(num)
    {
      case 0: strcpy(altwd1, onewddat[alt_code].word);
              alt1 = alt_code;
              num++;
              break;
      case 1: if (strcmp(onewddat[alt_code].word, altwd1) != 0) {
                strcpy(altwd2, onewddat[alt_code].word);
                alt2 = alt_code;
                num++;
              }
              break;
      case 2: if ((strcmp(onewddat[alt_code].word, altwd1) != 0) &&
                  (strcmp(onewddat[alt_code].word, altwd2) != 0))   {
                strcpy(altwd3, onewddat[alt_code].word);
                alt3 = alt_code;
                num++;
              }
              break;
    }
  }

       
  if ((alt_code = onewddat[code].ptr3) != -1)
  {
    switch(num)
    {
      case 0: strcpy(altwd1, onewddat[alt_code].word);
              alt1 = alt_code;
              num++;
              break;
      case 1: if (strcmp(onewddat[alt_code].word, altwd1) != 0) {
                strcpy(altwd2, onewddat[alt_code].word);
                alt2 = alt_code;
                num++;
              }
              break;
      case 2: if ((strcmp(onewddat[alt_code].word, altwd1) != 0) &&
                  (strcmp(onewddat[alt_code].word, altwd2) != 0))   {
                strcpy(altwd3, onewddat[alt_code].word);
                alt3 = alt_code;
                num++;
              }
              break;
    }
  }

/****** added 0n 04/06/97 ******/

  if (size_altlist < num) {
    num = size_altlist;
    if (num == 1) { altwd2[0] = '\0'; altwd3[0] = '\0'; }
    else if (num == 2) { altwd3[0] = '\0'; }
  }
 
/****** 04/06/97 ******/

  altrnt_print(onewddat[code].word, altwd1, altwd2, altwd3);


  ch = getchar();
  while (ch == ' ')
  {
    ch = getchar();
  };

  if (ch == -1)
  {
    exit(0);
  };

  if ((ch == '\n') && (num == 0))
  {
    prompt_print("accept all", 
                 onewddat[code].word,
                 "CONFIRM",
                 "Press return to confirm,",
                 "or type another word.",
                 "",
                 "",
                 "");
 
    ch = getchar();

    if (ch == -1)
    {
      exit(0);
    };


    if (ch == '\n')
    {
      int    ptr;

      ptr = onewddat_ptr++; 
      if (onewddat_ptr >= ONEWD_MAX) {
        system_error("out of memory, onewddat buffer is overflow.");
      }

      strcpy(onewddat[ptr].word, onewddat[code].word);
      strcpy(onewddat[ptr].root, onewddat[code].root);
      strcpy(onewddat[ptr].suffix, onewddat[code].suffix);
      onewddat[ptr].errtype = onewddat[code].errtype;
      onewddat[ptr].ptr1 = onewddat[code].ptr1;
      onewddat[ptr].ptr2 = onewddat[code].ptr2;
      onewddat[ptr].ptr3 = onewddat[code].ptr3;


      if (classify)
      {
        char  pttrn[20], str[20];
       
        classification_print();
        ch = getchar();
       
        if (ch == -1)
        {
          exit(0);
        };

        if (ch == '\n')
        {
          strcpy(onewddat[ptr].pttrn, "U");
        }
        else
        {
fixclass1:
          while (ch == ' ')
          {
            ch = getchar();
          };
    
          if (ch == -1) { exit(0); };

          pttrn[0] = ch;
          pttrn[1] = '\0';
          gets(str);
          strcat(pttrn, str);
          
          prompt_print("Selected", 
                       pttrn,
                       "CONFIRM",
                       "Press return to confirm,",
                       "or type another classification.",
                       "",
                       "",
                       "");

          ch = getchar();

          if (ch == -1) { exit(0); };

          if (ch == '\n')
          {
            strcpy(onewddat[ptr].pttrn, pttrn);
          }
          else
          {
            goto fixclass1;
          };
        };  /* end of "ch != '\n'" */
      }
      else
      {
        strcpy(onewddat[ptr].pttrn, "U");
      };

      insert_rplcall(code, ptr);

      return(ptr);
    }
    else
    {
      goto fix;
    }
  }

  if ((ch == '\n') && (num > 0))
  {
    prompt_print("Selected", 
                  altwd1,
                 "CONFIRM",
                 "Press return to accept,",
                 "or type another word.",
                 "",
                 "",
                 "");

    ch = getchar();

    if (ch == -1) { exit(0); };

    if (ch == '\n')
    {
      error_record(onewddat[alt1].errtype);
      correction_list_insert(wrong_wd, onewddat[alt1].word, alt1);


      return(alt1);
    }
    else
    {
      goto fix;
    }
  }


fix:

  while (ch == ' ')
  {
    ch = getchar();
  };

  if (ch == -1) { exit(0); };

  ans[0] = ch;
  ans[1] = '\0';
  gets(tmp);
  strcat(ans, tmp);

  if ((line = is_option(ans, num)) != -1)
  {    
    if (line > num)
    {
      if (line == num + 1)
      {
        prompt_print("accept all", 
                   onewddat[code].word,
                   "CONFIRM",
                   "Press return to confirm,",
                   "or type another word.",
                   "",
                   "",
                   "");
      }
      else
      {
        prompt_print("accept one", 
                   onewddat[code].word,
                   "CONFIRM",
                   "Press return to confirm,",
                   "or type another word.",
                   "",
                   "",
                   "");
      };

      ch = getchar();

      if (ch == -1) { exit(0); };

      if (ch == '\n')
      {
        int    ptr;

        ptr = onewddat_ptr++;
        if (onewddat_ptr >= ONEWD_MAX) {
          system_error("out of memory, onewddat buffer is overflow.");
        }

        strcpy(onewddat[ptr].word, onewddat[code].word);
        strcpy(onewddat[ptr].root, onewddat[code].root);
        strcpy(onewddat[ptr].suffix, onewddat[code].suffix);
        onewddat[ptr].errtype = onewddat[code].errtype;
        onewddat[ptr].ptr1 = onewddat[code].ptr1;
        onewddat[ptr].ptr2 = onewddat[code].ptr2;
        onewddat[ptr].ptr3 = onewddat[code].ptr3;

        if (classify)
        {
          char  pttrn[20], str[20];
       
    
          classification_print();
          ch = getchar();

          if (ch == -1) { exit(0); };

          if (ch == '\n')
          {
            strcpy(onewddat[ptr].pttrn, "U");
          }
          else
          {
fixclass2:
            while (ch == ' ')
            {
              ch = getchar();
            };
    
            if (ch == -1) { exit(0); };

            pttrn[0] = ch;
            pttrn[1] = '\0';
            gets(str);
            strcat(pttrn, str);

            prompt_print("Selected", 
                         pttrn,
                         "CONFIRM",
                         "Press return to confirm,",
                         "or type another",
                         "classification.",
                         "",
                         "");

            ch = getchar();
            if (ch == -1) { exit(0); };
            if (ch == '\n')
            {
              strcpy(onewddat[ptr].pttrn, pttrn);
            }
            else
            {
              goto fixclass2;
            };
          };  /* end of "ch != '\n'" */
        }
        else
        {
          strcpy(onewddat[ptr].pttrn, "U");
        };

        if (line == num + 1)
        {
          insert_rplcall(code, ptr);
        };

        return(ptr);

      }
      else
      {
        goto fix;
      };
    };

    switch (line)
    {
      case 0:
              prompt_print("Deleted", 
                            onewddat[code].word,
                            "CONFIRM",
                            "Press return to confirm,",
                            "or type another word.",
                            "",
                            "",
                            "");
              
              ch = getchar();
              if (ch == -1) { exit(0); };
              if (ch == '\n')
              {
                correction_list_insert(wrong_wd, "*** deleted ***", -1);
                return(-1);
              }
              else
              {
                goto fix;
              };

      case 1: 
              prompt_print("Selected", 
                            altwd1,
                           "CONFIRM",
                           "Press return to accept,",
                           "or type another word.",
                           "",
                           "",
                           "");

              ch = getchar();
              if (ch == -1) { exit(0); };
              if (ch == '\n')
              {
                error_record(onewddat[alt1].errtype);
                correction_list_insert(wrong_wd,onewddat[alt1].word, alt1);
                

                return(alt1);
              }
              else
              {
                goto fix;
              };

      case 2:
              prompt_print("Selected", 
                            altwd2,
                           "CONFIRM",
                           "Press return to accept,",
                           "or type another word.",
                           "",
                           "",
                           "");

              ch = getchar();
              if (ch == -1) { exit(0); };
              if (ch == '\n')
              {
                alpha = update_alpha(alt1, onewddat[alt1].errtype,
                                     alt2, onewddat[alt2].errtype);
                error_record(onewddat[alt2].errtype);
                correction_list_insert(wrong_wd, onewddat[alt2].word,alt2);
       /**&&&&&&&&&7/99&&&&&&&&**/
       if( is_usr_replcmnt_word(wrong_wd, word2) )
                    remove_replacement_word(wrong_wd);
       /**&&&&&&end7/99&&&&&&&&**/

                return(alt2);
              }
              else
              {
                goto fix;
              }
  
      case 3:
              prompt_print("Selected", 
                            altwd3,
                           "CONFIRM",
                           "Press return to accept,",
                           "or type another word.",
                           "",
                           "",
                           "");

              ch = getchar();
              if (ch == -1) { exit(0); };
              if (ch == '\n')
              {
                alpha = update_alpha(alt1, onewddat[alt1].errtype,
                                     alt3, onewddat[alt3].errtype);
                error_record(onewddat[alt3].errtype);
                correction_list_insert(wrong_wd, onewddat[alt3].word,alt3);
      /**&&&&&&&&&7/99&&&&&&&&**/
         /**printf("\n  -----------alt3 selected (line:4068)  <%s>  ",
                  wrong_wd);**/
         if( is_usr_replcmnt_word(wrong_wd, word2) )
                    remove_replacement_word(wrong_wd);
      /**&&&&&&end7/99&&&&&&&&**/

                return(alt3);
              }
              else
              {
                goto fix;
              };
    };  /* end of switch */

  }  /* end of 'if (is_option(ans, num) != -1)' */
  else
  { /* user specify his own word */
    int      i;

    boolean  lower = FALSE;
    char     word[MAXWORDLEN+1];

    strcpy(word, ans);
    Txt_Alt = 'T';
    Textwd = -1;
    itprt = 0;
    retprb("FindWdForm");

checkword: 

    word_found = FIND_WORD(word, pttrn);
    ptr = onewddat_ptr;
    Find_wdform(word);
    if (itprt == 0) 
    { 
      if(word_found)       
      {
        if (lower)
        {
          word[0] = toupper(word[0]);
        };

        inner_form(word, " ", " ", pttrn, 'T', 'F', 0, 0, 0);
        innertext_ptr--;

        prompt_print("Selected", 
                     onewddat[ptr].word,
                     "CONFIRM",
                     "Press return to accept,",
                     "or type another word.",
                     "",
                     "",
                     "");

        ch = getchar();
        if (ch == -1) { exit(0); };
        if (ch == '\n')
        {
          /**&&&&&&&&&7/99&&&&&&&&**/
          /**printf("\n New word confirmed  1 ...\n");
             printf("@@@@@@@@@@@@@@@@@@@@ %s %s <%s><%s><%s>\n",onewddat[code].word,
                           onewddat[ptr].word, altwd1,altwd2,altwd3 );***/
          if( (strcmp(onewddat[ptr].word, altwd1) != 0 ) &&
              (strcmp(onewddat[ptr].word, altwd2) != 0 ) &&
              (strcmp(onewddat[ptr].word, altwd3) != 0 ) )
                rplc_insert(onewddat[code].word, onewddat[ptr].word);
          else
              {
                if( is_usr_replcmnt_word(wrong_wd, word2) )
                    remove_replacement_word(wrong_wd);
               }
          /**&&&&&&end7/99&&&&&&&&**/

          for (i = 0; i < extralt_ptr; i++)
          {
            int  cd;

            cd = extral_alt[i];
            if(strcmp(word, onewddat[cd].word) == 0)
            {
              error_record(onewddat[cd].errtype);
              if (alt1 != -1)
                alpha = update_alpha(alt1, onewddat[alt1].errtype,
                                     cd, onewddat[cd].errtype);
              break;
            }
          }
          correction_list_insert(wrong_wd, onewddat[ptr].word, ptr);
          return(ptr);
        }
        else
        {
          goto fix;
        };
      }
      else
      {
        if (isupper(word[0]))
        {
          lower = TRUE;
          word[0] = tolower(word[0]);
          goto checkword;
        };
      };
    }
    else
    {
      innertext_ptr--;
      if (itprt == 1)
      {
        if (lower)
        {
          onewddat[ptr].word[0] = toupper(onewddat[ptr].word[0]);
        };

        prompt_print("Selected", 
                     onewddat[ptr].word,
                     "CONFIRM",
                     "Press return to accept,",
                     "or type another word.",
                     "",
                     "",
                     "");

        ch = getchar();
        if (ch == -1) { exit(0); };
        if (ch == '\n')
        {
          /**&&&&&&&&&7/99&&&&&&&&**/
          if( (strcmp(onewddat[ptr].word, altwd1) != 0 ) &&
              (strcmp(onewddat[ptr].word, altwd2) != 0 ) &&
              (strcmp(onewddat[ptr].word, altwd3) != 0 ) )    
                 rplc_insert(onewddat[code].word, onewddat[ptr].word);
          else
              {
                if( is_usr_replcmnt_word(wrong_wd, word2) )
                    remove_replacement_word(wrong_wd);
               }
          /**&&&&&&end7/99&&&&&&&&**/

          for (i = 0; i < extralt_ptr; i++)
          {
            int  cd;

            cd = extral_alt[i];
            if(strcmp(onewddat[ptr].word, onewddat[cd].word) == 0)
            {
              error_record(onewddat[cd].errtype);
              if (alt1 != -1)
                alpha = update_alpha(alt1, onewddat[alt1].errtype,
                                     cd, onewddat[cd].errtype);
              break;
            }
          }
          correction_list_insert(wrong_wd, onewddat[ptr].word, ptr);
          return(ptr);
        }
        else
        {
          goto fix;
        };
      };
    };

    
    if (lower)
    {
      word[0] = toupper(word[0]);
    };


    prompt_print("Selected", 
                 word,
                 "CONFIRM",
                 "Word does not exist in main",
                 "dictionary, but it can be ",
                 "added to user dictionary.",
                 "Press return to accept,",
                 "or type another word.");

    ch = getchar();
    if (ch == -1) { exit(0); };
    if (ch == '\n')
    {
          /**&&&&&&&&&7/99&&&&&&&&**/
      /*          char   wrdx[MAXWORDLEN+1];*/
          inner_form(word, " ", " ", pttrn, 'T', 'F', 0, 0, 0);
          innertext_ptr--;
          if( (strcmp(onewddat[ptr].word, altwd1) != 0 ) &&
              (strcmp(onewddat[ptr].word, altwd2) != 0 ) &&
              (strcmp(onewddat[ptr].word, altwd3) != 0 ) )     
                rplc_insert(onewddat[code].word,onewddat[ptr].word);
          else
              {
                if( is_usr_replcmnt_word(wrong_wd, word2) )
                    remove_replacement_word(wrong_wd);
               }
          /**&&&&&&end7/99&&&&&&&&**/

      strcpy(onewddat[ptr].word, word);
      if (classify)
      {
        char  pttrn[20], str[20];
       

        classification_print();
        ch = getchar();
        if (ch == -1) { exit(0); };
        if (ch == '\n')
        {
          strcpy(onewddat[ptr].pttrn, "U");
        }
        else
        {
fixclass:
          while (ch == ' ')
          {
            ch = getchar();
          };
    
          if (ch == -1) { exit(0); };
          pttrn[0] = ch;
          pttrn[1] = '\0';
          gets(str);
          strcat(pttrn, str);

          prompt_print("Selected", 
                       pttrn,
                       "CONFIRM",
                       "Press return to confirm,",
                       "or type another",
                       "classification.",
                       "",
                       "");

          ch = getchar();
          if (ch == -1) { exit(0); };
          if (ch == '\n')
          {
            strcpy(onewddat[ptr].pttrn, pttrn);
          }
          else
          {
            goto fixclass;
          };
        };  /* end of "ch != '\n'"  */
      }
      else
      {
        strcpy(onewddat[ptr].pttrn, "U");
      };

      correction_list_insert(wrong_wd, onewddat[ptr].word, ptr);
      return(ptr);
    }
    else
    {
      goto fix;
    };
  }  /* end of 'if (is_option(ans, num) == -1)' */
  printf("\n *** Program never goes here spell_typerr.c 202***");
  exit(1);
}


int legal_alt(code)
int code;
{
  int  altcode;

  if ((altcode = onewddat[code].ptr1) == -1) return -1;
  if (onewddat[altcode].errtype == 0) return altcode;
  
  if ((altcode = onewddat[code].ptr2) == -1) return -1;
  if (onewddat[altcode].errtype == 0) return altcode;

  if ((altcode = onewddat[code].ptr3) == -1) return -1;
  if (onewddat[altcode].errtype == 0) return altcode;

  return -1;
}

/************************************************************************/
/*    Function to ask user to fix all wrong words                       */
/************************************************************************/
void fix_words()
{
  int     i, code, code1, newcode, altcode, wrongwd_idx = 0;
  char    word[MAXWORDLEN + 1], ch;
  int     num, j, k;
  float   base, diff;
  struct  correction *ptr;

  extern  boolean  abccflg;

  text_changed = FALSE;

  if (abccflg)
  {
    info_print();
  };

  if (accept_unknown)
  {
    printf("\n\n******************************************************\n");
    printf("*      All Unknown Words are Accepted as Correct     *\n");
    printf("******************************************************\n\n");
  }
  else
  {
    printf("\n\n******************************************************\n");
    printf("*          Find Alternatives for Wrong Words         *\n");
    printf("******************************************************\n\n");
  };

  wrongwd[wrongwd_ptr].code = -1;
  correction_list = NULL;
  correction_list_end = NULL;
  spos = 0;
  text_line = 1;
  rplcall_ptr = NULL;
  for (i = 0; i < innertext_ptr; i ++)
  {
    code = innertext[i];
    if (code >= 0)
    {
      if (code == wrongwd[wrongwd_idx].code)
      {
        if (onewddat[code].errtype == EXCLUDED_WD) {
          char wrong_wd[MAXWORDLEN+1];

          strcpy(wrong_wd, onewddat[code].word);
          code = fix_excluded_word(code);
          strcpy(word, onewddat[code].word);
          correction_list_insert(wrong_wd, word, code);
          if ((code1 = dcmdct_insert(word, usrdctdat_ptr, usr_dct,
               usrdct_head, &usrdct_ptr)) != -1) {
            code = code1;
          }
          else {

            strcpy(usrdctdat[usrdctdat_ptr].word, word);
            strcpy(usrdctdat[usrdctdat_ptr].root, onewddat[code].root);
            strcpy(usrdctdat[usrdctdat_ptr].suffix, onewddat[code].suffix);
            strcpy(usrdctdat[usrdctdat_ptr].pttrns, onewddat[code].pttrn);

            if ((num = strlen(usrdctdat[usrdctdat_ptr].pttrns)) != 1) {
              base = 2 * 100 / 3 / num;
              diff = 2 * (100 - num * base) / (num * (num - 1));
              k = 0;
              for (j = num - 1; j >= 0; j--) 
                usrdctdat[usrdctdat_ptr].ptrn_likelihood[j] = 
                                                 (int) (base + diff * k++);
            }
            else {
              usrdctdat[usrdctdat_ptr].ptrn_likelihood[0] = 100;
            }

            usrdctdat[usrdctdat_ptr].is_wf = onewddat[code].is_wf;
            usrdctdat[usrdctdat_ptr].not_wf = onewddat[code].not_wf;
            code = usrdctdat_ptr++;
          }
          wrongwd_idx++;
          goto end_of_for;
        }


        if (accept_unknown)
        {
          if (classify)
          {
            char  pttrn[20], str[20];


            printf("\nUnknown Word --> %s\n", onewddat[code].word);
            classification_print();
            ch = getchar();
            if (ch == -1) { exit(0); };
            if (ch == '\n')
            {
              strcpy(onewddat[code].pttrn, "U");
            }
            else
            {
classify:
              while (ch == ' ')
              {
                ch = getchar();
              };
    
              if (ch == -1) { exit(0); };
              pttrn[0] = ch;
              pttrn[1] = '\0';
              gets(str);
              strcat(pttrn, str);

              prompt_print("Selected", 
                           pttrn,
                           "CONFIRM",
                           "Press return to confirm,",
                           "or type another",
                           "classification.",
                           "",
                           "");

              ch = getchar();
              if (ch == -1) { exit(0); };
              if (ch == '\n')
              {
                strcpy(onewddat[code].pttrn, pttrn);
              }
              else
              {
                goto classify;
              };
            };  /* end of "ch != '\n'"  */
          }
          else  /* classify == FALSE */
          {
            strcpy(onewddat[code].pttrn, "U");
          }
          wrongwd_idx++;
        }
        else  /* accept_unknown == FALSE */
        {
          error_check(wrongwd_idx++);
        }
      }
      
      
      if (((newcode = replace_all(code)) == -1) &&
         ((altcode = legal_alt(code)) == -1))
      {    
        if (((onewddat[code].errtype != 0)             || 
           ((onewddat[code].ptr1 != -1)  &&
            (strcmp(onewddat[code].pttrn, " ") == 0))  ||
           ((onewddat[code].Fnd_Not == 'N') &&
            (strcmp(onewddat[code].pttrn, " ") == 0)))    && !accept_unknown)
        {
          if ((code = fix_a_word(code)) == -1)
          {
            spos++;
            if (innertxtout[innertxtout_ptr-1] == -32) innertxtout_ptr--;
            continue;
          }
        }
         /*---------- 110398 ----------*/
        else
        {
          if (((onewddat[code].errtype != 0)             || 
             ((onewddat[code].ptr1 != -1)  &&
              (strcmp(onewddat[code].pttrn, " ") == 0))  ||
             ((onewddat[code].Fnd_Not == 'N') &&
              (strcmp(onewddat[code].pttrn, " ") == 0)))    && accept_unknown)
        
               {   strcpy(onewddat[code].pttrn, "U");   }
          }
        /*-------------------------------*/
      }
      else
      {
        if (newcode != -1) { code  = newcode; }
        else { code = altcode; }
      }
      

      strcpy(word, onewddat[code].word);
      if ((code1 = dcmdct_insert(word, usrdctdat_ptr, usr_dct,usrdct_head,
         &usrdct_ptr)) != -1)
      {
        code = code1;
      }
      else
      {
        strcpy(usrdctdat[usrdctdat_ptr].word, word);
        strcpy(usrdctdat[usrdctdat_ptr].root, onewddat[code].root);
        strcpy(usrdctdat[usrdctdat_ptr].suffix, onewddat[code].suffix);
        strcpy(usrdctdat[usrdctdat_ptr].pttrns, onewddat[code].pttrn);

        if ((num = strlen(usrdctdat[usrdctdat_ptr].pttrns)) != 1) {
          base = 2 * 100 / 3 / num;
          diff = 2 * (100 - num * base) / (num * (num - 1));
          k = 0;
          for (j = num - 1; j >= 0; j--) 
            usrdctdat[usrdctdat_ptr].ptrn_likelihood[j] = (int) (base + diff * k++);
        }
        else {
          usrdctdat[usrdctdat_ptr].ptrn_likelihood[0] = 100;
        }

        usrdctdat[usrdctdat_ptr].is_wf = onewddat[code].is_wf;
        usrdctdat[usrdctdat_ptr].not_wf = onewddat[code].not_wf;
        code = usrdctdat_ptr++;
      }
    }
    else
    {
      switch (-code)
      {
        case '\n':
                   text_line ++;
                   break;
      };

    };
    
end_of_for:

    innertxtout[innertxtout_ptr++] = code;
    spos++;
  };

  if (abccflg)
  {
    info_print();
  };

  if (correction_list == NULL)
  {
    printf("\n\nYour text has not been changed\n\n");
    return;
  };

 /* printf("\n\nYour text is corrected as, \n");

  for (i = 0; i < innertxtout_ptr; i++)
  {
    code = innertxtout[i];
    if (code < 0)
    {
      ch = - code;
      fputc(ch, stdout);
    }
    else
    {
      fputs(usrdctdat[code].word, stdout);
    };
  };
*/

  free_rplcall();

  printf("\n\n          WRONG WORD                          CORRECTION\n");
  printf("          ==========                          ==========\n\n");

  ptr = correction_list_end;
  while (ptr != NULL) {
    struct correction *tmp;

    if (strcmp(ptr->wrong_wd, ptr->correct_wd) == 0) {
      tmp = ptr;
      ptr = ptr->last;
      free(tmp);
      continue;
    }
    text_changed = TRUE;
    printf("%20s          ====>>%20s\n", ptr->wrong_wd, 
                                         ptr->correct_wd);
    tmp = ptr;
    ptr = ptr->last;
    free(tmp);
  }
/*
  printf("\n\nCAUTION:  The file %s has been corrected. Therefore any copy\n", text_name); 
  printf("          displayed by your text editor is out of date. Make sure\n");
  printf("          that any further editing is done on the corrected file.\n");
*/
}


/**************************************************************************/
/*  Function to reload the onewd_act.prg and recover corresponding env    */
/**************************************************************************/
void  rstr_actprg(token)
char    token[];
{
  char         qunt[QUNT_MAX + 1];
  static char  var[129];

  retprb("DetermineAct");

  history();
  structure_check(token);

  if (cnsctv_wrngwd) 
  {
    mstvar("has_st(cnsctv)", 0, "T");

  };

  wd_occur = word_occur(token);
  quantity(wd_occur, qunt);
  strcpy(var, "wd_occur(");
  strcat(var, qunt);
  strcat(var,")");
  mstvar(var, 0, "T");
}



/*------------------------------------------------------------------------
  is_option  --  function to check if an answer is a legal option number
-------------------------------------------------------------------------*/
int is_option(ans, num)
char *ans;
int  num;
{
  int  i, len;

  if (!isdigit(ans[0])) return -1;
  if ((len = strlen(ans)) != 1) return -1;
  i = ans[0] - 48;
  if ((i < 0) || (i > (num+2))) return -1;
  return i;
}
  

/*---------------------------------------------------------------------

  scaled_word_occur  --  return scaled word occuring number

    input  -- count: word occuring number
    output -- none

  function returns the scaled word occuring number.

----------------------------------------------------------------------*/
int scaled_word_occur(count)
int count;
{
  if (count <= 0) return 0;
  if (count <= 15) return count;
  return 15;
}


/*----------------------------------------------------------------------

  fix_excluded_word  --  ask user to fix an excluded word 

    input  -- code: code pointing to the excluded word
    output -- function returns the code pointing to the corrected word.

-----------------------------------------------------------------------*/
int fix_excluded_word(code)
int code;
{
  char ch, ans[80], tmp[80], word[MAXWORDLEN + 1], pttrn[MAXPTRNS+1];
  boolean word_found = FALSE, lower = FALSE;
  int  ptr;


  strcpy(word, onewddat[code].word);

printf("\n\n----------------------------------------------------------\n");
  printf("Wrong Word: %s\n", word);
  printf("in line %d: \n", text_line);
  print_context();
  printf("----------------------------------------------------------\n\n");

fix_excld_wd:

  printf("\n  Wrong Word --> %s\n\n", word);
  printf("Alternatives --> Word is an excluded word of %s.\n", nono_usr);
  printf("                 You must type in another word. If you\n");
  printf("                 want to accept the word, you must stop\n");
  printf("                 this run (Cntrl-C), delete the word from\n");
  printf("                 %s, and start again.\n", nono_usr);

  printf("\n");
  printf("       SELECT >> ");

  
  ch = getchar();
  while (ch == ' ')
  {
    ch = getchar();
  };

  if (ch == -1)
  {
    exit(0);
  };

  if (ch == '\n') {
    goto fix_excld_wd;
  }

input_wd:

  ans[0] = ch;
  ans[1] = '\0';
  gets(tmp);
  strcat(ans, tmp);

  if (is_option(ans, 3) != -1) goto fix_excld_wd;

  strcpy(word, ans);
  Txt_Alt = 'T';
  Textwd = -1;
  itprt = 0;
  retprb("FindWdForm");

check_usrwd:

  if (is_excluded_word(word)) goto fix_excld_wd;
 
  word_found = FIND_WORD(word, pttrn);
  ptr = onewddat_ptr;
  Find_wdform(word);
  if (itprt == 0) { 
    if (word_found) {
      if (lower) word[0] = toupper(word[0]);
      inner_form(word, " ", " ", pttrn, 'T', 'F', 0, 0, 0);
      innertext_ptr--;

      prompt_print("Selected", 
                   onewddat[ptr].word,
                   "CONFIRM",
                   "Press return to accept,",
                   "or type another word.",
                   "",
                   "",
                   "");

      ch = getchar();
      if (ch == -1) exit(0); 
      if (ch == '\n') return(ptr);
      goto input_wd;  
    }
    else {
      if (isupper(word[0])) {
        lower = TRUE;
        word[0] = tolower(word[0]);
        goto check_usrwd;
      }
    }
  }
  else {
    innertext_ptr--;
    if (itprt == 1) {
      if (lower)
        onewddat[ptr].word[0] = toupper(onewddat[ptr].word[0]);
      
      prompt_print("Selected", 
                    onewddat[ptr].word,
                   "CONFIRM",
                   "Press return to accept,",
                   "or type another word.",
                   "",
                   "",
                   "");

      ch = getchar();
      if (ch == -1) exit(0); 
      if (ch == '\n') return(ptr);
      goto input_wd;  
    }
  }

  if (lower) word[0] = toupper(word[0]);

  prompt_print("Selected", 
               word,
               "CONFIRM",
               "Word does not exist in main",
               "dictionary, but it can be ",
               "added to user dictionary.",
               "Press return to accept,",
               "or type another word.");

  ch = getchar();
  if (ch == -1) exit(0); 
  if (ch == '\n') {
    strcpy(onewddat[ptr].word, word);
    strcpy(onewddat[ptr].pttrn, "U");
    return(ptr);
  }

  goto input_wd;
}



  


/*-----------------------------------------------------------------------

  new_correction_entry  -- request a new entry in correction_list

    input  -- none
    output -- none

-------------------------------------------------------------------------*/
void new_correction_entry()
{
  struct correction *ptr;

  ptr = (struct correction *) malloc(sizeof(*ptr));
  ptr->wrong_wd[0] = '\0';
  ptr->correct_wd[0] = '\0';
  ptr->correct_wd_code = -1;
  ptr->next = correction_list;
  ptr->last = NULL;
  if (correction_list != NULL) 
    correction_list->last = ptr;
  correction_list = ptr;
  if (correction_list_end == NULL) correction_list_end = ptr;
}


/*----------------------------------------------------------------------

  already_corrected  --  check is a wrong word has already been corrected

    input  -- wd: the word to be checked
    output -- codes: an array to store the corrected codes

------------------------------------------------------------------------*/
void already_corrected(wd, codes)
char *wd;
int  codes[4];
{
  struct correction *ptr;
  int    i = 0;

  ptr = correction_list;
  while (ptr != NULL) {
    if (strcmp(ptr->wrong_wd, wd) == 0) {
      if ((strcmp(ptr->correct_wd, wd) != 0) &&
          (strcmp(ptr->correct_wd, "*** deleted ***") != 0)) {
        if (i == 3) { codes[3] = -1; return; }
        codes[i++] = ptr->correct_wd_code; 
      }
    }
    ptr = ptr->next;
  }
  codes[i] = -1;
}

      
/*----------------------------------------------------------------------

  correction_list_insert  --  insert an entry into correction_list

    input  -- wrong_wd: wrong word
              correct_wd: corrected word
              correct_wd_code: the code of the corrected word
    output -- none

------------------------------------------------------------------------*/
void correction_list_insert(wrong_wd, correct_wd, correct_wd_code)
char *wrong_wd, *correct_wd;
int   correct_wd_code;
{
  struct correction *ptr;

  ptr = correction_list;
  while (ptr != NULL) {
    if ((strcmp(ptr->wrong_wd, wrong_wd) == 0) && 
        (strcmp(ptr->correct_wd, correct_wd) == 0)) return;
    ptr = ptr->next;
  }
  
  new_correction_entry();
  strcpy(correction_list->wrong_wd, wrong_wd);
  strcpy(correction_list->correct_wd, correct_wd);
  correction_list->correct_wd_code = correct_wd_code;
}

