#include "spell_cnst.h" 

#include "spellroutines.h"
 
extern int                   Textwd, onewddat_ptr, 
                             innertext_ptr, innertxtout_ptr, itprt,
                             dcmdct_ptr, maxfrq, extralt_ptr,
                             errhstry_ptr, errhstry_head,
                             dcmdct_head[MAXWORDLEN + 1], innertext[], 
                             innertxtout[], err_hstry[RCNTERR_MAX + 1],
                             usrdct_head[], extral_alt[EXTRALTMAX];
extern boolean               upper_head;
extern boolean               all_upper;
extern struct  OneWord       onewddat[];
extern struct  DictIndex     dcm_dct[], usr_dct[];
extern boolean               has_nono;
/**&&&&&&&&&7/99&&&&&&&&**/
extern boolean               has_rplc;
/**&&&&&&end7/99&&&&&&&&**/

extern char              Txt_Alt;

void system_error();
void running_error();

/*typedef  struct  UserWd     words_usr;
typedef  struct  DictIndex  words_idx;*/

/***************************************************************************/
/*  Function to return the length of an non negtive integer                */
/***************************************************************************/
int  int_len(num)
int  num;
{
  int  len;

  if (num == 0)
  {
    return(1);
  }
  else
  {
    len = 0;
    while (num > 0)
    {
      num = num / 10;
      len ++;
    };
    return(len);
  };
}
  
/************************************************************************/
/*   Function to initialize dcm_dct                                     */
/************************************************************************/
void  dctn_init(dctn, head, headptr, datptr)
struct  DictIndex      *dctn;
int                    *head, *headptr, *datptr;
{
  int  i;

  for (i = 0; i <= MAXWORDLEN; i++)
  {
    head[i] = -1;
  };

  dctn[0].left = 0;
  dctn[0].right = 0;
  dctn[0].red = FALSE;

  for (i = 1; i < DCMDCT_MAX; i++)
  {
    dcm_dct[i].count = 0;
    dcm_dct[i].code = 0;
    dcm_dct[i].red = 0;
    dcm_dct[i].left = 0;
    dcm_dct[i].right = 0;
  };

  *headptr = 1;
  *datptr = 0;
}


/**************************************************************************/
/*  Function to rotate nodes in constructing a red-black tree.            */
/**************************************************************************/
int  rotate(word, ptr, dctn)
char                   word[];
int                    ptr;
struct  DictIndex      *dctn;
{
  int  c, gc;

  if (strcmp(word, dctn[ptr].word) < 0)
  {
    c = dctn[ptr].left;
  }
  else
  {
    c = dctn[ptr].right;
  };
  
  if (strcmp(word, dctn[c].word) < 0)
  {
    gc = dctn[c].left;
    dctn[c].left = dctn[gc].right;
    dctn[gc].right = c;
  }
  else
  {
    gc = dctn[c].right;
    dctn[c].right = dctn[gc].left;
    dctn[gc].left = c;
  };

  if (strcmp(word, dctn[ptr].word) < 0)
  {
    dctn[ptr].left = gc;
  }
  else
  {
    dctn[ptr].right = gc;
  };

  return(gc);
}

/***************************************************************************/
/*     Function to split a 4-node in constructing a red-black tree         */
/***************************************************************************/
int  split(word, gg, g, p, ptr, dctn, head)
char                   word[];
int                    gg, g, p, ptr;
struct  DictIndex      *dctn;
int                    *head;
{
  int  left, right, cmp1, cmp2;

  dctn[ptr].red = TRUE;
  left = dctn[ptr].left;
  right = dctn[ptr].right;
  dctn[left].red = FALSE;
  dctn[right].red = FALSE;
   
  if (dctn[p].red)
  {
    dctn[g].red = TRUE;

    cmp1 = strcmp(word, dctn[g].word);
    cmp2 = strcmp(word, dctn[p].word);
    if ((cmp1 * cmp2) < 0)
    {
      p = rotate(word, g, dctn);
    };
    ptr = rotate(word, gg, dctn);
    dctn[ptr].red = FALSE;
  };

  dctn[dctn[head[strlen(word)]].right].red = FALSE;
  return(ptr);
}

/***************************************************************************/
/* Function to insert a word into the red-black tree. If the word is found */
/* in the tree, return the corresponding code, otherwise insert the word   */
/* and return -1.                                                          */
/***************************************************************************/
int   dcmdct_insert(word, code, dctn, head, dct_ptr)
char                   word[];
int                    code;
struct  DictIndex      *dctn;
int                    *head;
int                    *dct_ptr;
{
  int  parent, grandparent, great_grandparent, left, right, ptr, cmp, len;
  
  if (all_upper) {
    int   len, i;
        
    len = strlen(word);
    for (i = 0; i < len; i++){
      word[i] = toupper(word[i]);
    }
  }
  else {
    if (upper_head) {
      word[0] = toupper(word[0]);
    }
  }

  len = strlen(word);
  if (head[len] == -1)
  {
    head[len] = *dct_ptr;
    strcpy(dctn[*dct_ptr].word, " ");
    dctn[*dct_ptr].count = 0;
    dctn[*dct_ptr].code = 0;
    dctn[*dct_ptr].red = FALSE;
    dctn[*dct_ptr].left = 0;
    dctn[*dct_ptr].right = 0;
    *dct_ptr = * dct_ptr + 1;
    if (*dct_ptr >= DCMDCT_MAX) {
      system_error("out of memory, dcmdct buffer is overflow.");
    }

  };

  ptr = head[len];

  parent = ptr;
  grandparent = ptr;
  
  do  
  { 
    great_grandparent = grandparent;
    grandparent = parent;
    parent = ptr;

    cmp = strcmp(word, dctn[ptr].word);

    if (cmp == 0)
    {
      if (dctn[ptr].count <= 0) dctn[ptr].count = 1;
      dctn[ptr].count ++; 
      if (maxfrq < dctn[ptr].count)
      {
        maxfrq = dctn[ptr].count;
      };

    /*  printf("%s is found\n", word);*/
      return(dctn[ptr].code);  
    };

    if (cmp < 0)
    {
      ptr = dctn[ptr].left;
    }
    else
    {
      ptr = dctn[ptr].right;
    };

    left = dctn[ptr].left;
    right = dctn[ptr].right;
    if ((dctn[left].red) && (dctn[right].red))
    {
      ptr = split(word, great_grandparent, grandparent, parent, ptr, dctn,head);
    };
  } while (ptr > 0);

  ptr = *dct_ptr;
  *dct_ptr = *dct_ptr + 1;
  if (*dct_ptr >= DCMDCT_MAX) {
    system_error("out of memory, dcmdct buffer is overflow.");
  }

  strcpy(dctn[ptr].word, word);
  dctn[ptr].count = 2;
  dctn[ptr].code = code;
  dctn[ptr].left = 0;
  dctn[ptr].right = 0;
    
  if (strcmp(word, dctn[parent].word) < 0)
  {
    dctn[parent].left = ptr;
  }
  else
  {
      
    dctn[parent].right = ptr;
  };

  split(word, great_grandparent, grandparent, parent, ptr, dctn, head);

  return(-1);  
}


/***************************************************************************/
/* Function to insert a word into the red-black tree. If the word is found */
/* in the tree, return the corresponding code, otherwise insert the word   */
/* and return -1.                                                          */
/***************************************************************************/
int   dcmdct_insert1(word, code, count, dctn, head, dct_ptr)
char                   word[];
int                    code;
int                    count;
struct  DictIndex      *dctn;
int                    *head;
int                    *dct_ptr;
{
  int  parent, grandparent, great_grandparent, left, right, ptr, cmp, len;

  len = strlen(word);
  if (head[len] == -1)
  {
    head[len] = *dct_ptr;
    strcpy(dctn[*dct_ptr].word, " ");
    dctn[*dct_ptr].count = 0;
    dctn[*dct_ptr].code = 0;
    dctn[*dct_ptr].red = FALSE;
    dctn[*dct_ptr].left = 0;
    dctn[*dct_ptr].right = 0;
    *dct_ptr = * dct_ptr + 1;
    if (*dct_ptr >= DCMDCT_MAX) {
      system_error("out of memory, dcmdct buffer is overflow.");
    }
  }

  ptr = head[len];

  parent = ptr;
  grandparent = ptr;
  
  do  
  { 
    great_grandparent = grandparent;
    grandparent = parent;
    parent = ptr;

    cmp = strcmp(word, dctn[ptr].word);

    if (cmp == 0)
    {
      if (dctn[ptr].count <= 0) dctn[ptr].count = 1;
      dctn[ptr].count = dctn[ptr].count + count; 
      if (maxfrq < dctn[ptr].count)
      {
        maxfrq = dctn[ptr].count;
      };

    /*  printf("%s is found\n", word);*/
      return(dctn[ptr].code);  
    };

    if (cmp < 0)
    {
      ptr = dctn[ptr].left;
    }
    else
    {
      ptr = dctn[ptr].right;
    };

    left = dctn[ptr].left;
    right = dctn[ptr].right;
    if ((dctn[left].red) && (dctn[right].red))
    {
      ptr = split(word, great_grandparent, grandparent, parent, ptr, dctn,head);
    };
  } while (ptr > 0);

  ptr = *dct_ptr;
  *dct_ptr = *dct_ptr + 1;
  if (*dct_ptr >= DCMDCT_MAX) {
    system_error("out of memory, dcmdct buffer is overflow.");
  }

  strcpy(dctn[ptr].word, word);
  dctn[ptr].count = count;
  if (maxfrq < count)
  {
    maxfrq = count;
  };

  dctn[ptr].code = code;
  dctn[ptr].left = 0;
  dctn[ptr].right = 0;
    
  if (strcmp(word, dctn[parent].word) < 0)
  {
    dctn[parent].left = ptr;
  }
  else
  {
      
    dctn[parent].right = ptr;
  };

  split(word, great_grandparent, grandparent, parent, ptr, dctn, head);

  return(-1);  
}

/***************************************************************************/
/*    Function to search a word in the red-black tree. If the word is found*/
/*    in the tree, return the corresponding ptr, otherwise return -1       */
/***************************************************************************/
int   dcmdct_search1(word, dctn, head)
char                   word[];
struct  DictIndex      *dctn;
int                    *head;
{
  int   ptr, cmp, len;

  len = strlen(word);
  if ((ptr = head[len]) == -1)
  {
    return(-1);
  };

  do  
  { 
    cmp = strcmp(word, dctn[ptr].word);

    if (cmp == 0)
    {
      return(ptr);
    };

    if (cmp < 0)
    {
      ptr = dctn[ptr].left;
    }
    else
    {
      ptr = dctn[ptr].right;
    };

  } while (ptr > 0);
   
  return(-1);
}


/***************************************************************************/
/*    Function to search a word in the red-black tree. If the word is found*/
/*    in the tree, return the corresponding code, otherwise return -1      */
/***************************************************************************/
int   dcmdct_search2(word)
char                   word[];
{
  int   ptr, cmp, len;

  len = strlen(word);
  if ((ptr = dcmdct_head[len]) == -1)
  {
    return(-1);
  };

  do  
  { 
    cmp = strcmp(word, dcm_dct[ptr].word);

    if (cmp == 0)
    {
      return(dcm_dct[ptr].code);
    };

    if (cmp < 0)
    {
      ptr = dcm_dct[ptr].left;
    }
    else
    {
      ptr = dcm_dct[ptr].right;
    };

  } while (ptr > 0);
   
  return(-1);
}



/***************************************************************************/
/*  Function to store an interpretation of a word in array onewddat.       */
/***************************************************************************/
void inner_form(word, root, suffix, pttrn, t_a, f_n, is_wdfm, not_wdfm, errtype)
char                   word[], root[], suffix[], pttrn[], t_a, f_n;
int                    is_wdfm, not_wdfm, errtype;
{
  int  ptr1, ptr2;

  if (itprt <= ITPRT_MAX)
  {
    if (t_a == 'T')
    {
      Textwd = onewddat_ptr;
      innertext[innertext_ptr++] = Textwd;
      if (innertext_ptr >= INNERTEXT_MAX) {
        system_error("out of memory, innertext buffer overflow.");
      }

      if (all_upper)
      {
        int   len, i;
        
        len = strlen(word);
        for (i = 0; i < len; i++)
        {
          word[i] = toupper(word[i]);
        };
      }
      else
      {
        if (upper_head)
        {
          word[0] = toupper(word[0]);
       /* }
        else
        {
          if ((innertext_ptr == 1) || (innertext[innertext_ptr - 2] == -46))
          {
            errtype = LOWER_LTR;
          };*/
        };
      };

    }
    else
    {  
        if (onewddat[Textwd].errtype == LOWER_LTR)
        {
          word[0] = toupper(word[0]);
        };

        if ((ptr1 = onewddat[Textwd].ptr1) == -1)
        {
          onewddat[Textwd].ptr1 = onewddat_ptr;
        }
        else
        {
          if ((strcmp(word, onewddat[ptr1].word) == 0) && 
              (strcmp(root, onewddat[ptr1].root) == 0))
          {
            return;
          };

          if  ((ptr2 = onewddat[Textwd].ptr2) == -1)
          {
            onewddat[Textwd].ptr2 = onewddat_ptr;
          }
          else
          {
            if ((strcmp(word, onewddat[ptr2].word) == 0) && 
               (strcmp(root, onewddat[ptr2].root) == 0))
            {
              return;
            };

            onewddat[Textwd].ptr3 = onewddat_ptr;
          };
        };
    };

    onewddat[onewddat_ptr].word[0] = '\0';
    strcpy(onewddat[onewddat_ptr].word, word);
    onewddat[onewddat_ptr].root[0] = '\0';
    strcpy(onewddat[onewddat_ptr].root, root);
    onewddat[onewddat_ptr].suffix[0] = '\0';
    strcpy(onewddat[onewddat_ptr].suffix, suffix);
    onewddat[onewddat_ptr].pttrn[0] = '\0';
    strcpy(onewddat[onewddat_ptr].pttrn, pttrn);
    onewddat[onewddat_ptr].Txt_Alt = t_a;
    onewddat[onewddat_ptr].Fnd_Not = f_n;
    onewddat[onewddat_ptr].is_wf = is_wdfm;
    onewddat[onewddat_ptr].not_wf = not_wdfm;
    onewddat[onewddat_ptr].errtype = errtype;
    onewddat[onewddat_ptr].ptr1 = -1;
    onewddat[onewddat_ptr].ptr2 = -1;
    onewddat[onewddat_ptr++].ptr3 = -1;
    if (onewddat_ptr >= ONEWD_MAX) {
      system_error("out of memory, onewddat buffer overflow.");
    }

    itprt++;
  }
  else  /* itprt >= ITPRTMAX */
  {
    extral_alt[extralt_ptr++] = onewddat_ptr;
/* printf("extralt_ptr = %d %s %d\n", extralt_ptr, word, errtype);*/
    onewddat[onewddat_ptr].word[0] = '\0';
    strcpy(onewddat[onewddat_ptr].word, word);
    onewddat[onewddat_ptr].root[0] = '\0';
    strcpy(onewddat[onewddat_ptr].root, root);
    onewddat[onewddat_ptr].suffix[0] = '\0';
    strcpy(onewddat[onewddat_ptr].suffix, suffix);
    onewddat[onewddat_ptr].pttrn[0] = '\0';
    strcpy(onewddat[onewddat_ptr].pttrn, pttrn);
    onewddat[onewddat_ptr].Txt_Alt = t_a;
    onewddat[onewddat_ptr].Fnd_Not = f_n;
    onewddat[onewddat_ptr].is_wf = is_wdfm;
    onewddat[onewddat_ptr].not_wf = not_wdfm;
    onewddat[onewddat_ptr].errtype = errtype;
    onewddat[onewddat_ptr].ptr1 = -1;
    onewddat[onewddat_ptr].ptr2 = -1;
    onewddat[onewddat_ptr++].ptr3 = -1;
    if (onewddat_ptr >= ONEWD_MAX) {
      system_error("out of memory, onewddat buffer overflow.");
    }
  }
}


boolean FIND_WORD(word, pttrn)
char *word, *pttrn;
{
  int  ptr;

  if ((ptr = dcmdct_search1(word, usr_dct, usrdct_head)) != -1) {
    strcpy(pttrn, onewddat[usr_dct[ptr].code].pttrn);
    return TRUE;
  }
  if (isupper(word[0])) {
    char tmp[MAXWORDLEN + 1];

    strcpy(tmp, word);
    tmp[0] = tolower(word[0]);
    if ((ptr = dcmdct_search1(tmp, usr_dct, usrdct_head)) != -1) {
      strcpy(pttrn, onewddat[usr_dct[ptr].code].pttrn);
      return TRUE;
    }
  }

  if (Find_Word(word, pttrn)) return TRUE;
  if (isupper(word[0])) {
    char tmp[MAXWORDLEN + 1];

    strcpy(tmp, word);
    tmp[0] = tolower(word[0]);
    if (Find_Word(tmp, pttrn)) return TRUE;
  }
  pttrn[0] = '\n';
  return FALSE;
}


/**********************************************************************/

struct nono_word {
                   char     word[MAXWORDLEN + 1]; /* word */
                   boolean  red;                  /* red/black flag */
                   struct nono_word  *left;     /* pointer to left child */
                   struct nono_word  *right;   /* pointer to right child */
                 };

struct nono_word *nono_dict, *dummy;


void nono_init();
void nono_insert();
struct nono_word *nono_split();
struct nono_word *nono_rotate();
boolean is_excluded_word();
void clean_nono();
void clean_nono_tree();



/*---------------------------------------------------------------------

  nono_init  --  initializes the user excluded dictionary

    input  -- none
    output -- none

----------------------------------------------------------------------*/
void nono_init()
{
  dummy = (struct nono_word *) malloc(sizeof(*dummy));
  dummy->left = dummy;
  dummy->right = dummy;
  dummy->red = FALSE;

  nono_dict = (struct nono_word *) malloc(sizeof(*nono_dict));
  strcpy(nono_dict->word, "");
  nono_dict->left = dummy;
  nono_dict->right = dummy;
}


/*---------------------------------------------------------------------

  nono_insert  --  insert an excluded word into user excluded dictionary
                   (red-black tree).

    input  -- word: the word to be inserted;
    output -- none;

-----------------------------------------------------------------------*/
void nono_insert(word)
char             *word;
{
  struct nono_word *gg, *g, *p, *ptr;
  int    cmp;

  ptr = nono_dict;
  p = ptr;
  g = ptr;
  
  do {
    gg = g;
    g = p;
    p = ptr;

    cmp = strcmp(word, ptr->word);
    if (cmp == 0) return;

    if (cmp < 0) {
      ptr = ptr->left;
    }
    else {
      ptr = ptr->right;
    }
  
    if ((ptr->left)->red && (ptr->right)->red) 
      ptr = nono_split(word, gg, g, p, ptr);
  } while (ptr != dummy);

  ptr = (struct nono_word *) malloc(sizeof(*ptr));
  strcpy(ptr->word, word);
  ptr->left = dummy;
  ptr->right = dummy;

  if (strcmp(word, p->word) < 0) {
    p->left = ptr;
  }
  else {
    p->right = ptr;
  }
  ptr = nono_split(word, gg, g, p, ptr);
}


/*---------------------------------------------------------------------

  nono_split  --  Function to split a 4-node in constructing nono_dict

    input  -- word: word to be inserted;
              gg:   pointer to great grandparent;
              g:    pointer to grandparent;
              p:    pointer to parent;
              ptr:  pointer to the 4-node;
    output -- none;

  function returns the pointer to the node after split.

-----------------------------------------------------------------------*/
struct nono_word * nono_split(word, gg, g, p, ptr)
char  *word;
struct nono_word *gg, *g, *p, *ptr;
{
  int cmp1, cmp2;

  ptr->red = TRUE;
  (ptr->left)->red = FALSE;
  (ptr->right)->red = FALSE;

  if (p->red) {
    g->red = TRUE;
    cmp1 = strcmp(word, g->word);
    cmp2 = strcmp(word, p->word);
    if ((cmp1 * cmp2) < 0) {
      p = nono_rotate(word, g);
    }
    ptr = nono_rotate(word, gg);
    ptr->red = FALSE;
  };

  (nono_dict->right)->red = FALSE;
  return(ptr);
}


/*----------------------------------------------------------------------

  nono_rotate  --  rotate nodes in constructing nono_dict.

    input  -- word: word to be inserted;
              pt:   pointer to the node to be rotated
    output -- none;

------------------------------------------------------------------------*/
struct nono_word * nono_rotate(word, pt)
char  *word;
struct nono_word *pt;
{
  struct nono_word *c, *gc;

  if (strcmp(word, pt->word) < 0) {
    c = pt->left;
  }
  else {
    c = pt->right;
  }

  if (strcmp(word, c->word) < 0) {
    gc = c->left;
    c->left = gc->right;
    gc->right = c;
  }
  else {
    gc = c->right;
    c->right = gc->left;
    gc->left = c;
  }

  if (strcmp(word, pt->word) < 0) {
    pt->left = gc;
  }
  else {
    pt->right = gc;
  }

  return gc;
}

/**&&&&&&&&&7/99&&&&&&&&**/


/**********************************************************************/


struct rplc_word rplc_dict[USR_RPLC_MAX];

int  rplc_end = 0, rplc_ptr = 0;

void rplc_insert();
boolean is_excluded_word();


/*---------------------------------------------------------------------

  rplc_insert  --  insert a user replacement word into user excluded
                   dictionary  (red-black tree).

    input  -- word: the word to be inserted;
    output -- none;

-----------------------------------------------------------------------*/
void rplc_insert(word, word2)
char             *word, *word2;
{
   int  t;
   
   if( (t=rplc_exist(word)) != -1 )
      { 
        strcpy(rplc_dict[t].word2,word2);
        return;
      }
      
  if ( rplc_end < ( USR_RPLC_MAX ) )
     {  strcpy(rplc_dict[rplc_end].word,word);
        strcpy(rplc_dict[rplc_end++].word2,word2);
      }
  else {  /** shift **/
          for(t=0; t<(rplc_end-1); t++ )
            {  strcpy(rplc_dict[t].word,rplc_dict[t+1].word);
               strcpy(rplc_dict[t].word2,rplc_dict[t+1].word2);
             }
          strcpy(rplc_dict[rplc_end-1].word,word);
          strcpy(rplc_dict[rplc_end-1].word2,word2);
        }

}

/*---------------------------------------------------------------------

  rplc_exist  --  check if user suggested replacement is already exist.

    input  -- word: the word to be checked;
    output -- index of the word in the table, -1 if does not exist;

-----------------------------------------------------------------------*/
int  rplc_exist(word )
char             *word ;
{
   int  i;
   
   if( rplc_end == 0 )  return(-1);
   for(i=0; i<rplc_end; i++)
     if( strcmp(rplc_dict[i].word,word) == 0 ) return(i);
   
   return(-1);
}


/*---------------------------------------------------------------------

  remove_replacement_word   --  removes user suggested replacement from 
                                list when user selects a computed 
                                replacment.

    input  -- word: the word to be removed
    output -- none

------------------------------------------------------------------------*/
 void  remove_replacement_word(wrdx)
     char  *wrdx;
      {
        int   i, j;

        if( rplc_end == 0 ) return;

        for(i=0; i< rplc_end; i++)
         {
            if( strcmp(wrdx, rplc_dict[i].word) == 0 )
             {  
                for(j=i; j<(rplc_end-1); j++ )
                  {  strcpy(rplc_dict[j].word,rplc_dict[j+1].word);
                     strcpy(rplc_dict[j].word2,rplc_dict[j+1].word2);
                   }
                 rplc_end--;
                 break;
              } 
             
          }  


        
        
       }
       

/**&&&&&&end7/99&&&&&&&&**/

/*---------------------------------------------------------------------

  is_excluded_word  --  check if a word is an excluded word.

    input  -- word: the word to be searched
    output -- none

  function returns TRUE if the word is in the nono_dict, FALSE otherwise.

------------------------------------------------------------------------*/
boolean is_excluded_word(word)
char *word;
{
  struct nono_word *ptr;
  int    cmp;

  if (!has_nono) return FALSE;

  ptr = nono_dict;

  do {
    cmp = strcmp(word, ptr->word);
    if (cmp == 0) return TRUE;
    if (cmp < 0) {
      ptr = ptr->left;
    }
    else {
      ptr = ptr->right;
    }
  } while (ptr != dummy);

  return FALSE;
}

/**&&&&&&&&&7/99&&&&&&&&**/
/*---------------------------------------------------------------------

  is_usr_replcmnt_word   --  check if a word has a user suggested 
                             replacement word.

    input  -- word: the word to be searched
    output -- none

  function returns TRUE if the word is in the rplc_dict, FALSE otherwise.

------------------------------------------------------------------------*/
boolean is_usr_replcmnt_word(word, word2)
char *word, *word2;
{
  int   i;
  
  if( rplc_end == 0 ) return FALSE;
   
  for(i=0; i< rplc_end; i++)
  {
    if( strcmp(word, rplc_dict[i].word) == 0 )
      {  
         strcpy(word2, rplc_dict[i].word2);
         return TRUE;
       }
    }  


  return FALSE;
}

/**&&&&&&end7/99&&&&&&&&**/

/*----------------------------------------------------------------------

  clean_nono  --  free the memory space occupied by nono_dict

    input  -- none
    output -- none

-----------------------------------------------------------------------*/
void clean_nono()
{
  clean_nono_tree(nono_dict);
  free(dummy);
}


/*----------------------------------------------------------------------

  clean_nono_tree  --  free the memory occupied by a nono subtree

    input  -- ptr: pointer to the root of the sybtree
    output -- none

-----------------------------------------------------------------------*/
void clean_nono_tree(ptr)
struct nono_word *ptr;
{
  if (ptr == dummy) return;
  clean_nono_tree(ptr->left);
  clean_nono_tree(ptr->right);
  free(ptr);
}

/*---------------------------------------------------------------------

  system_error  --  report system error

    input  -- msg: error message
    output -- none

----------------------------------------------------------------------*/
void system_error(msg)
char *msg;
{
  char ch;

  printf("------------------------------------------------------------\n");
  printf("\nLaempel System Error: ");
  printf("%s\n\n", msg);
  printf("------------------------------------------------------------\n");
  printf("Press return key to quit Laempel\n");

  ch = getchar();
  exit(0);
}


/*---------------------------------------------------------------------

  running_error  --  report running error

    input  -- msg: error message
    output -- none

----------------------------------------------------------------------*/
void running_error(msg)
char *msg;
{
  char ch;

  printf("------------------------------------------------------------\n");
  printf("\nError: ");
  printf("%s\n\n", msg);
  printf("------------------------------------------------------------\n");
  printf("Press return key to quit Laempel\n");

  ch = getchar();
  exit(0);
}
/*
void str_n_cpy(wd1, wd2, n)
char *wd1, *wd2;
int   n;
{
  int len, i;

  len = strlen(wd2);
  if (len < n) {
    strcpy(wd1, wd2);
    return;
  }

  for (i = 0; i < n; i++) wd1[i]= wd2[i];
  wd1[i] = '\0';
}
*/
